2002-10-03  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/stxncpy.S: Don't access memory beyond the source
	buffer.
	* sysdeps/alpha/alphaev6/stxncpy.S: Likewise.

2002-10-02  Andreas Jaeger  <aj@suse.de>
	    Guido Guenther  <agx@sigxcpu.org>

	* sysdeps/mips/fpu/fraiseexcpt.c: Add internal definition.
	* sysdeps/mips/fpu/fesetenv.c: Likewise.

2002-10-03  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/net/route.h: Include bits/wordsize.h.
	(struct rtentry): Make rt_pad4 6 bytes long if __WORDSIZE == 64.
	* sysdeps/unix/sysv/linux/alpha/Dist: Remove net/route.h.
	* sysdeps/unix/sysv/linux/alpha/net/route.h: Remove.
	* sysdeps/unix/sysv/linux/ia64/Dist: Remove net/route.h.
	* sysdeps/unix/sysv/linux/ia64/net/route.h: Remove.
	* sysdeps/unix/sysv/linux/s390/Dist: Remove net/route.h.
	* sysdeps/unix/sysv/linux/s390/net/route.h: Remove.

2002-10-03  Ulrich Drepper  <drepper@redhat.com>

	* libio/freopen.c: Don't re-set _wide_data element if the stream
	is of old style which didn't have the element.
	* libio/freopen64.c: Likewise.

2002-10-02  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/Dist: Add bits/utmpx.h.
	* sysdeps/unix/sysv/linux/sparc/Dist: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/Dist: Likewise.

	* sysdeps/s390/s390-32/initfini.c: Avoid unterminated string literals.
	* sysdeps/sh/elf/initfini.c: Likewise.
	* sysdeps/mach/hurd/mips/init-first.c: Likewise.
	* sysdeps/hppa/elf/initfini.c: Likewise.
	* sysdeps/sparc/sparc32/soft-fp/sfp-machine.h: Likewise.

2002-10-02  Steven Munroe  <sjmunroe@us.ibm.com>
	    Jakub Jelinek  <jakub@redhat.com>

	* login/programs/utmpdump.c (print_entry): Copy up->ut_tv fields
	to struct timeval temp_tv before printing to be 32-/64-bit agnostic.
	* sysdeps/powerpc/bits/wordsize.h: Move to...
	* sysdeps/powerpc/powerpc32/bits/wordsize.h: ...here.
	(__WORDSIZE_COMPAT32): Define.
	* sysdeps/powerpc/powerpc64/bits/wordsize.h: Likewise.
	* sysdeps/sparc/sparc32/bits/wordsize.h (__WORDSIZE_COMPAT32):
	Define.
	* sysdeps/sparc/sparc64/bits/wordsize.h (__WORDSIZE_COMPAT32):
	Define.
	* sysdeps/s390/bits/wordsize.h: Move to...
	* sysdeps/s390/s390-32/bits/wordsize.h: ...here.
	* sysdeps/s390/s390-64/bits/wordsize.h: Likewise.
	* sysdeps/x86_64/bits/wordsize.h (__WORDSIZE_COMPAT32): Define.
	* sysdeps/unix/sysv/linux/powerpc/bits/utmp.h: New file.
	* sysdeps/unix/sysv/linux/powerpc/bits/utmpx.h: New file.
	* sysdeps/unix/sysv/linux/sparc/bits/utmp.h: New file.
	* sysdeps/unix/sysv/linux/sparc/bits/utmpx.h: New file.
	* sysdeps/unix/sysv/linux/x86_64/bits/utmp.h: New file.
	* sysdeps/unix/sysv/linux/x86_64/bits/utmpx.h: New file.

2002-10-02  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/alpha/dl-machine.h (elf_machine_rela): Fix comment typo.
	Temporarily enable R_ALPHA_NONE relocs in ld.so.
	* sysdeps/ia64/dl-machine.h (elf_machine_rela): Temporarily enable
	R_IA64_NONE relocs in ld.so.

2002-09-27  Steven Munroe  <sjmunroe@us.ibm.com>

	* README.template: Minimum Linux kernel for powerpc64 is 2.4.19.

	* sysdeps/unix/sysv/linux/powerpc/bits/ipc.h (struct ipc_perm):
	Use __uint32_t and __uint64_t for __seq, __pad1, __unused[12] fields
	so they are consistent between PPC32 and PPC64.

	* sysdeps/unix/sysv/linux/powerpc/bits/stat.h [__WORDSIZE != 32]:
	(_STAT_VER): Define to _STAT_VER_KERNEL.
	(stru stat, struct stat64): Define to match the PPC64 kernel.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/Versions
	(libc: GLIBC_2.2): Remove __xstat64, __fxstat64, and __lxstat64.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/kernel_stat.h: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/fxstat64.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/lxstat64.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/xstat64.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/Dist: Add kernel_stat.h.

2002-10-02  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/xstatconv.c [STAT_IS_KERNEL_STAT]:
	Conditionalize the function definitions on this.
	* sysdeps/unix/sysv/linux/xstat.c (__xstat) [STAT_IS_KERNEL_STAT]:
	Don't use xstat_conv, just fail if VERS != _STAT_VER_KERNEL.
	* sysdeps/unix/sysv/linux/fxstat.c (__fxstat) [STAT_IS_KERNEL_STAT]:
	Likewise.
	* sysdeps/unix/sysv/linux/lxstat.c (__lxstat) [STAT_IS_KERNEL_STAT]:
	Likewise.

2002-10-02  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.3.

	* elf/Makefile (distribute): Add tst-tlsmod1.c, tst-tlsmod2.c,
	tst-tlsmod3.c, tst-tlsmod4.c, circlemod1.c, circlemod1a.c,
	circlemod2.c, circlemod2a.c, circlemod3.c, circlemod3a.c,
	and nodlopenmod2.c.

	* login/Makefile (distribute): Add utmp-equal.h.

	* iconvdata/Makefile (distribute): Add TSCII.precomposed and
	TSCII.irreversible.

	* Make-dist (dist): Create .bz2 file.  Add rule to create .bz2 files.
	Also distribute xtests sources.

2002-10-02  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* elf/elf.h: Change TLS ELF relocation numbers.
	* elf/tls-macros.h: Fix code sequences for SH TLS_LD and TLS_GD
	macros.
	* sysdeps/sh/dl-machine.h (dl_machine_rela) [case R_SH_TLS_TPOFF32]:
	Use addend.
	* sysdeps/sh/elf/initfini.c: Move __fpscr_values to...
	* sysdeps/sh/elf/start.S: ...here.

2002-10-01  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/bits/sigstack.h (MINSIGSTKSZ,
	SIGSTKSZ): Changed to match kernel.
	* sysdeps/unix/sysv/linux/sparc/bits/sigstack.h: New file.

2002-10-01  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/unix/sysv/linux/hppa/bits/fcntl.h
	[__USE_GNU] (F_SETLEASE, F_GETLEASE, F_NOTIFY): New macros.
	[__USE_GNU] (DN_ACCESS, DN_MODIFY, DN_CREATE, DN_DELETE, DN_RENAME,
	DN_ATTRIB, DN_MULTISHOT): New macros.

2002-02-08  Randolph Chung  <tausq@debian.org>

	* sysdeps/hppa/elf/start.S: Define __data_start.

2002-10-01  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regex_internal.c (re_string_reconstruct): Reset the member
	LEN and STOP.
	* posix/regexec.c (re_search_stub): Remove incorrect condition of
	"range < 0".
	Round RANGE in case that it is too small.

2002-10-01  Roland McGrath  <roland@frob.com>

	* config.h.in (NO_HIDDEN): New #undef.
	* include/libc-symbols.h [! NO_HIDDEN]: Add this condition to
	nonempty definitions of hidden_proto et al.
	* configure.in: Grok --disable-hidden-plt to define NO_HIDDEN.
	* configure: Regenerated.
	* sysdeps/mach/hurd/configure.in: Always define NO_HIDDEN.
	* sysdeps/mach/hurd/configure: Regenerated.

2002-09-19  David Mosberger  <davidm@hpl.hp.com>

	* sysdeps/ia64/dl-fptr.c (make_fdesc): Load address of "local" via
	a 64-bit gp-relative address to enable binaries with large data
	sections.

2002-09-30  Ulrich Drepper  <drepper@redhat.com>

	* stdlib/cxa_finalize.c (__cxa_finalize): Call UNREGISTER_ATFORK
	if it is defined.
	* posix/Makefile (distribute): Add fork.h.
	* sysdeps/generic/fork.h: New file.

2002-09-29  Bruno Haible  <bruno@clisp.org>

	* sysdeps/generic/utmp_file.c (LOCKING_FAILED): New macro.
	(UNLOCK_FILE): Add a label.
	(getutent_r_file, internal_getut_r, getutline_r_file, pututline_file,
	updwtmp_file): Shut off the alarm clock when locking failed.

2002-09-30  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regex_internal.h (re_match_context_t): Add a new member.
	(re_fail_stack_ent_t): New structure.
	(re_fail_stack_t): Likewise.
	* posix/regexec.c (re_search_internal): Use the new member of
	re_match_context_t.
	Use fail stack only if it has back references and there are plural
	matching candidates.
	(proceed_next_node): Use fail stack if it is indicated.
	(set_regs): Likewise.
	(push_fail_stack): New function.
	(pop_fail_stack): New function.
	(check_dst_limits): Likewise.
	(check_dst_limits_calc_pos): Likewise.
	(search_subexp): Check the limitations on the top of subexpressions.
	(sift_states_bkref): Check the limitations of the destination node.
	Reuse the array sctx->sifted_states.

2002-09-30  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/printf_fp.c: Shuffle a few lines around to help the
	compiler optimizing.  No semantical changes intended.

2002-09-30  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ia64/strncpy.S: Only segfault in .recovery2 if some bits
	from the next quad are needed.

2002-09-30  Roland McGrath  <roland@redhat.com>

	* elf/tls-macros.h (TLS_LD, TLS_GD): Use call insn, not callq.

	* sysdeps/unix/x86_64/sysdep.S [USE_TLS && HAVE___THREAD] [! PIC]:
	Use direct-%fs form of TLS access for errno.

	* sysdeps/unix/sysv/linux/i386/i686/sysdep.h: File removed, since
	the i386 version has all the same asm now.

	* sysdeps/i386/elf/configure.in: Add @GOTNTPOFF and @NTPOFF uses to
	the TLS support check.
	* sysdeps/i386/elf/configure: Regenerated.

	* sysdeps/unix/sysv/linux/i386/sysdep.h [USE_TLS && HAVE___THREAD]
	(SYSCALL_ERROR_HANDLER): Use direct-%gs form of TLS access for errno.

	* sysdeps/unix/i386/sysdep.S (syscall_error)
	[USE_TLS && HAVE___THREAD]: Use TLS access for errno.

	* sysdeps/unix/sysv/linux/x86_64/sysdep.h
	[USE_TLS && HAVE___THREAD] (SYSCALL_ERROR_HANDLER): Use TLS access.

	* rt/tst-aio7.c (do_test): Don't read from stdin, which could be the
	terminal when the test is running in a background job.  Instead, make
	a pipe and read from its read half while never writing anything to it.

2002-09-30  Andreas Jaeger  <aj@suse.de>

	* stdlib/tst-bsearch.c (main): Fix format strings.
	* stdio-common/tst-rndseek.c (do_test): Likewise.
	* libio/tst_swprintf.c (main): Likewise.
	* catgets/tst-catgets.c (main): Likewise.
	* libio/tst-fgetws.c (main): Likewise.
	* posix/tst-mmap.c (main): Likewise.
	* posix/bug-regex12.c (main): Likewise.
	* posix/bug-regex11.c (main): Likewise.
	* io/tst-getcwd.c (do_test): Likewise.

	* iconvdata/tst-e2big.c (test): Use %td in printf for ptrdiff_t.

	* sysdeps/unix/sysv/linux/x86_64/sysdep.h (SYSCALL_ERROR_HANDLER):
	Store 4 bytes into errno, not 8 bytes.

2002-09-29  Ulrich Drepper  <drepper@redhat.com>

	* posix/regexec.c (sift_states_bkref): Remove ret variable.  Use
	err instead.

2002-09-29  Roland McGrath  <roland@redhat.com>

	* test-skeleton.c (timeout_handler): Use WUNTRACED flag in waitpid.
	Examine the child's status and print something different if it wasn't
	just killed by our SIGKILL.
	(main): In the child process call setpgid to put it in its own pgrp.

2002-09-29  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/sigwait.c (__sigwait): The return value
	semantics for sigtimedwait is different.  Rework the return value
	handling and don't pass in a siginfo variable.

2002-09-29  Roland McGrath  <roland@redhat.com>

	* malloc/malloc.c [! MALLOC_DEBUG] (assert): #undef before defining.

	* sysdeps/mach/hurd/Versions (ld: GLIBC_2.2.6): Add __errno_location.

	* sysdeps/unix/sysv/linux/x86_64/sysdep.S [USE_TLS && HAVE___THREAD]:
	Define errno in .tbss.
	* sysdeps/unix/x86_64/sysdep.S [USE_TLS && HAVE___THREAD]: Use TLS
	access for setting errno.

	* sysdeps/unix/x86_64/sysdep.S: Store 32 bits at errno, not 64 bits.
	AFAICT, it was just blind luck that the word following errno in .bss
	was just alignment padding and not some other variable to be clobbered.

2002-09-29  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/kernel-features.h
	(__ASSUME_SETRESUID_SYSCALL): On the sparc, define to 1, not empty.

2002-09-29  Jakub Jelinek  <jakub@redhat.com>

	* nss/bug-erange.c (main): Don't fail if /etc/resolv.conf doesn't
	exist.

2002-09-29  Ulrich Drepper  <drepper@redhat.com>

	* nss/Makefile: Move bug-erange from tests to xtests.

2002-09-29  Jakub Jelinek  <jakub@redhat.com>

	* stdlib/longlong.h (__udiv_qrnnd): Remove PARAMS from prototype.

2002-09-29  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/sysdep.h (inline_syscall0): Make asm
	volatile.
	(inline_syscall1, inline_syscall2, inline_syscall3, inline_syscall4,
	inline_syscall5, inline_syscall6): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/sysdep.h (INLINE_SYSCALL):
	Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/sysdep.h (INLINE_SYSCALL):
	Likewise.

2002-09-29  Roland McGrath  <roland@redhat.com>

	* configure.in (libc_cv_ranlib_necessary check): Put the .o file in
	the archive, not the .c file.
	* configure: Regenerated.

2002-09-29  Roland McGrath  <roland@redhat.com>

	* configure: Regenerated after aclocal.m4 change.

	* sysdeps/x86_64/sysdep.h [HAVE_ELF] (L): Define with .L##name form.
	* sysdeps/unix/sysv/linux/x86_64/sysdep.h (L): Don't define it here.

	* sysdeps/generic/dl-lookupcfg.h [USE_TLS] (DL_LOOKUP_RETURNS_MAP):
	Define it, because _dl_sym presumes it (for any platform).

	* sysdeps/x86_64/dl-tls.h: New file.

	* sysdeps/x86_64/dl-machine.h (elf_machine_rela): Add a cast.

	* sysdeps/x86_64/elf/configure.in: New file.
	* sysdeps/x86_64/elf/configure: New generated file.

2002-09-28  Roland McGrath  <roland@redhat.com>

	* elf/rtld.c (_dl_start): Fix conditional for declaring CNT.

	* aclocal.m4 (LIBC_PROG_BINUTILS): Don't clobber $RANLIB with ranlib
	before we check it.

2002-09-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Add __syscall_exit
	entry point.

2002-09-28  Jakub Jelinek  <jakub@redhat.com>

	* posix/bug-regex11.c (tests): Add flags field.
	(main): Avoid warnings.  Use test[i].flags.  Return nonzero
	if any of the tests failed.
	* posix/bug-regex12.c: New file.
	* posix/Makefile (tests): Add bug-regex12.

2002-03-02  Thorsten Kukuk  <kukuk@suse.de>

	* sysdeps/unix/nice.c (nice): Use getpriority() for the return value.

2002-09-28  Jeff Bailey  <jbailey@gnu.org>

	* sysdeps/unix/sysv/sysv4/solaris2/configure.in: Delete.
	* sysdeps/unix/sysv/aix/configure.in: Update comment and remove
	stdio=libio setting.

2002-09-28  Roland McGrath  <roland@redhat.com>

	* sysdeps/mach/hurd/dl-sysdep.c (_dl_important_hwcaps): Use INTUSE for
	_dl_signal_error.
	* sysdeps/mips/dl-machine.h (elf_machine_runtime_link_map): Likewise.
	* sysdeps/powerpc/powerpc64/dl-machine.c
	(_dl_reloc_overflow): Likewise.
	* sysdeps/arm/dl-machine.h (elf_machine_rel): Likewise.
	(elf_machine_rela): Likewise.

2002-09-27  Steven Munroe  <sjmunroe@us.ibm.com>

	* include/libc-symbols.h (__hidden_dot_weak1): Fix typo.  Replace
	ASM_GLOBAL_DIRECTIVE with .weak.

2002-09-28  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/truncate64.c (truncate64): Fix
	number of args to syscall.
	* sysdeps/unix/sysv/linux/mips/ftruncate64.c (__ftruncate64): Likewise.
	Patch by Guido Guenther <agx@sigxcpu.org>.

2002-09-27  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sysdep.h (__NR_pread, __NR_pwrite):
	Define these to __NR_pread64, __NR_pwrite64 if not defined.

	* sysdeps/unix/sysv/linux/powerpc/lchown.S
	[SHLIB_COMPAT (libc, GLIBC_2_0, GLIBC_2_1)]: Use this condition
	on chown compatibility symbol; use compat_symbol, not symbol_version.

2002-09-27  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regcomp.c (reg_free): Free the debug area.
	(re_compile_internal): Allocate debug area for the input string.
	(create_initial_state): Check the back references in initial states
	if they are really match null string in the initial state.
	(parse_reg_exp): Mark the dfa that the dfa can have plural matchings.
	(parse_expression): Likewise.
	(parse_bracket_exp): Likewise.
	* posix/regex_internal.c (re_node_set_intersect): Remove unused
	function.
	(re_node_set_contains): Change to return the index of node.
	* posix/regex_internal.h (re_backref_cache_entry): Change the members.
	(re_match_context_t): Likewise.
	(struct re_dfa_t): Likewise.
	(re_sift_context_t): New structure.
	* posix/regexec.c (match_ctx_clear_flag): New function.
	(sift_ctx_init): Likewise.
	(update_cur_sifted_state): Likewise.
	(add_epsilon_src_nodes): Likewise.
	(sub_epsilon_src_nodes): Likewise.
	(check_subexp_limits): Likewise.
	(search_subexp): Likewise.
	(sift_states_bkref): Likewise.
	(merge_state_array): Likewise.
	(sift_states_iter_bkref): Remove unused function.
	(add_epsilon_backreference): Remove unused function.
	(re_search_internal): Adapt new members and interfaces.
	(check_matching): Check the back references in initial states
	if they are really match null string in the initial state.
	(proceed_next_node): Change the evaluation of back references,
	since we have real registers here.
	(set_regs): Adapt new interface of proceed_next_node.
	(sift_states_backward): Add invocation of update_cur_sifted_state
	instead of add_epsilon_backreference.
	Add a sentinel to the outermost while loop.
	Move the handling of back references to sift_states_bkref function,
	since we can't handle some back references (e.g. a back reference
	which match NULL string) here.
	(transit_state_mb): Handle the new member max_mb_elem_len.
	(transit_state_bkref_loop): Move the evaluation of back references to
	search_subexp function, since we can't evaluate some back references
	(e.g. a back reference which can have plural matchings) here.
	(match_ctx_init): Adapt the new member.
	(match_ctx_add_entry): Adapt the new members.

2002-09-25  Alan Modra  <amodra@bigpond.net.au>

	* elf/do-rel.h: Define macro DO_ELF_MACHINE_REL_RELATIVE for
	'elf_machine_rel_relative'
	(elf_dynamic_do_rel): Call DO_ELF_MACHINE_REL_RELATIVE macro
	instead of 'elf_machine_rel_relative'.
	* sysdeps/hppa/dl-machine.h:
	Define macro DO_ELF_MACHINE_REL_RELATIVE for
	'elf_machine_rel_relative' with extra map parameter
	required by HPPA.
	(elf_machine_rela_relative): Add plt relocation changes.

2001-11-14  Matthew Wilcox  <willy@debian.org>

	* sysdeps/unix/sysv/linux/hppa/bits/ipc.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/msq.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/sem.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/shm.h: New file.

2002-09-27  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/powerpc32/Makefile: Fix typo in comment.

	* sysdeps/powerpc/powerpc64/Makefile
	[$(build-shared) = yes] (pic-ccflag): Define it.
	[$(subdir) = csu] (CFLAGS-initfini.s): Add -fpic here too.

2002-09-27  Roland McGrath  <roland@redhat.com>

	* sysdeps/x86_64/dl-machine.h (elf_machine_type_class): Remove
	unneeded TLS cases.

2002-09-27  Jakub Jelinek  <jakub@redhat.com>

	* elf/dl-addr.c (_dl_addr): Set dli_fbase to l_map_start
	unconditionally.  Set dli_fname to _dl_argv[0] only for main program.

2002-09-27  Roland McGrath  <roland@redhat.com>

	* elf/dl-addr.c (_dl_addr): Add a cast.

	* sysdeps/x86_64/dl-machine.h (elf_machine_rela) [USE_TLS]: Handle new
	TLS relocs R_X86_64_DTPMOD64, R_X86_64_DTPOFF64, and R_X86_64_TPOFF64.

	* elf/elf.h (R_X86_64_DTPMOD64, R_X86_64_DTPOFF64, R_X86_64_TPOFF64,
	R_X86_64_TLSGD, R_X86_64_TLSLD, R_X86_64_DTPOFF32,
	R_x86_64_GOTTPOFF, R_X86_64_TPOFF32): New macros.
	(R_X86_64_NUM): Update the value.

2002-09-24  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc32/dl-machine.h (elf_machine_load_address): Don't
	rely on *r_offset of R_SPARC_RELATIVE reloc in .got to contain the
	addend.
	* sysdeps/sparc/sparc64/dl-machine.h (elf_machine_load_address): Use
	the same l_addr computation.
	* sysdeps/sparc/sparc64/configure.in: Removed.
	* sysdeps/sparc/sparc64/configure: Removed.
	* config.h.in (SPARC64_DYNAMIC_BEFORE_GOT): Remove.

2002-09-26  Ulrich Drepper  <drepper@redhat.com>

	* elf/dynamic-link.h (elf_get_dynamic_info): Relocate DT_HASH entry
	if necessary.
	* elf/dl-lookup.c (_dl_setup_hash): DT_HASH entry is already relocated.
	* elf/dl-addr.c (_dl_addr): Use .hash[1] entry to determine end of the
	symbol table if necessary.

2002-09-26  Roland McGrath  <roland@redhat.com>

	* stdlib/longlong.h: Replaced with current version from GCC mainline,
	last modified 2002-09-22  Kazu Hirata  <kazu@cs.umass.edu>.

2002-09-25  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/syscalls.list: Add syscall_exit.
	Patch by Guido Guenther <agx@sigxcpu.org>.

2002-09-25  Roland McGrath  <roland@redhat.com>

	* Makeconfig (%.v.i pattern rule): Use $(CPPFLAGS).

2002-09-24  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/configure.in: Recognize nptl add-on name.

2002-09-24  Roland McGrath  <roland@redhat.com>

	* sysdeps/mach/hurd/Versions (ld: GLIBC_2.0): Move __libc_read,
	__libc_write, __libc_lseek64, to ...
	(ld: GLIBC_PRIVATE): ... here.

	* csu/Versions: Use %include <tls.h> to get USE_TLS defined.
	(libc: GLIBC_2.0) [USE_TLS && HAVE___THREAD]: Remove _errno, errno.
	(libc: GLIBC_2.3) [USE_TLS && HAVE___THREAD]: Put errno here instead.
	* resolv/Versions: Use %include <tls.h> to get USE_TLS defined.
	(libc: GLIBC_2.0) [USE_TLS && HAVE___THREAD]: Remove _h_errno, h_errno,
	and _res.
	(libc: GLIBC_2.3) [USE_TLS && HAVE___THREAD]: Put h_errno, _res here.

	* elf/tls-macros.h [__x86_64__] (TLS_LE, TLS_IE, TLS_LD, TLS_GD):
	New macros for x86-64.

	* sysdeps/unix/sysv/linux/alpha/bits/time.h: File removed.
	It was indentical to the linux/bits/time.h file.

	* nscd/nscd_gethst_r.c (nscd_gethst_r): Add a cast to silence warning.

	* resolv/gethnamaddr.c (gethostbyaddr): Use socklen_t for SIZE.

2002-09-23  Ulrich Drepper  <drepper@redhat.com>

	* po/zh_CN.po: New file.

2002-09-23  Roland McGrath  <roland@redhat.com>

	* posix/unistd.h: Test [__USE_UNIX98] instead of [__USE_OPEN2K]
	for gethostname declaration.

	* catgets/open_catalog.c (__open_catalog): Don't use a value type
	as the __builtin_expect expression, just the Boolean value.

	* sysdeps/generic/wordexp.c (parse_glob): int -> size_t for counter.
	* sysdeps/unix/sysv/linux/opensock.c (__opensock): Likewise.
	* resolv/res_hconf.c (arg_service_list, parse_line): Likewise.
	* iconvdata/tst-loading.c (main): Likewise.
	* catgets/tst-catgets.c (main): Likewise.
	* stdlib/tst-xpg-basename.c (main): Likewise.
	* stdlib/tst-bsearch.c (main): Likewise.
	* stdio-common/test-vfprintf.c (main): Likewise.
	* stdio-common/tst-rndseek.c (do_test): Likewise.
	* libio/tst_swprintf.c (main): Likewise.
	* libio/tst-fgetws.c (main): Likewise.
	* wcsmbs/tst-mbrtowc.c (check_ascii): Likewise.
	* time/tst-posixtz.c (main): Likewise.
	* time/tst-strptime.c (test_tm): Likewise.
	* time/tst-strptime.c (main): Likewise.
	* time/tst-getdate.c (main): Likewise.
	* posix/tst-mmap.c (main): Likewise.
	* posix/tst-getaddrinfo.c (do_test): Likewise.
	* io/tst-getcwd.c (do_test): Likewise.
	* resolv/tst-aton.c (main): Likewise.
	* inet/tst-network.c (main): Likewise.
	* libio/tst-fgetws.c (main): Likewise.
	* sysdeps/posix/sprofil.c (add_region): int -> unsigned int for I.
	* sysdeps/unix/sysv/linux/ptsname.c (__ptsname_r): int -> unsigned int
	for PTYNO.

	* stdlib/msort.c (qsort): Add a cast to silence warning.
	* stdio-common/vfprintf.c (process_string_arg): Likewise.
	* libio/oldfileops.c (_IO_old_do_write): Likewise.
	* sysdeps/unix/sysv/linux/getcwd.c (__getcwd): Likewise.
	* sysdeps/unix/sysv/linux/ttyname.c (ttyname): Likewise.
	* sysdeps/unix/sysv/linux/gethostid.c (gethostid): Likewise.
	* argp/argp-fmtstream.c (__argp_fmtstream_printf): Likewise.
	* nscd/nscd_getgr_r.c (nscd_getgr_r): Likewise.
	* sysdeps/unix/grantpt.c (grantpt): Likewise.
	* libio/tst-widetext.c (main): Likewise.
	* libio/tst-mmap2-eofsync.c (do_test): Likewise.
	* rt/tst-aio.c (test_file): Likewise.
	* rt/tst-aio64.c (test_file): Likewise.
	* resolv/tst-aton.c (main): Likewise.

	* catgets/catgetsinfo.h (CATGETS_MAGIC): Use U suffix on the constant.

	* ctype/ctype.c (__ctype_tolower, __ctype_toupper): Cast to int32_t
	instead of uint32_t in these macros.

2002-09-22  Bruno Haible  <bruno@clisp.org>

	* iconv/iconv_prog.c (main): Provide an error message that identifies
	the wrong encoding.

	* iconvdata/tscii.c: New file.
	* iconvdata/testdata/TSCII: New file.
	* iconvdata/testdata/TSCII..UTF8: New file.
	* iconvdata/TSCII.precomposed: New file.
	* iconvdata/TSCII.irreversible: New file.
	* iconvdata/gconv-modules (TSCII): New module.
	* iconvdata/Makefile (modules): Add TSCII.
	(distribute): Add tscii.c.
	* iconvdata/tst-table-from.c (try, utf8_decode, main): Double output
	buffer size.
	* iconvdata/tst-tables.sh: Add TSCII.
	* iconvdata/TESTS: Add TSCII.

	Revert 2002-04-18 patch.
	* iconvdata/euc-jisx0213.c (EMIT_SHIFT_TO_INIT, BODY for
	FROM_DIRECTION): Make the FROM direction stateful again.
	* iconvdata/shift_jisx0213.c (EMIT_SHIFT_TO_INIT, BODY for
	FROM_DIRECTION): Likewise.

	* iconvdata/tst-e2big.c: New file.
	* iconvdata/Makefile (tests): Add tst-e2big.

2002-09-23  Roland McGrath  <roland@redhat.com>

	* elf/Makefile (test-extras): Define this instead of test-srcs.
	* Makerules (all-nonlib): Include $(test-extras) too.

2002-09-21  Carlos O'Donell  <carlos@baldric.uwo.ca>

	* sysdeps/hppa/abort-instr.h: New file.

2002-09-22  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/Versions (ld: GLIBC_2.0): Remove duplicate entry.

	* sysdeps/mach/hurd/dl-sysdep.c (_exit): Add alias __GI__exit.

2002-09-22  Andreas Schwab  <schwab@suse.de>

	* cppflags-iterator.mk (CPPFLAGS-$(cpp-src)): Append, not overwrite.

	* sysdeps/m68k/fpu/bits/mathinline.h (isgreater, isgreaterequal)
	(isless, islessequal, islessgreater, isunordered) [GCC >= 3.1]:
	Use GCC builtins.

2002-09-21  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/i386/dl-procinfo.h (_DL_HWCAP_PLATFORM):
	Correct the value so it covers all platforms, and is computed
	from _DL_PLATFORMS_COUNT rather than hard-wired.
	From Andrew Suffield <asuffield@debian.org>.

2002-09-20  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/getsysstats.c (get_proc_path): Avoid
	locking when using mount tab file.
	* sysdeps/unix/sysv/linux/internal_statvfs.c: Likewise.
	* sysdeps/unix/sysv/linux/statvfs.c: Include <stdio_ext.h>.
	* sysdeps/unix/sysv/linux/fstatvfs.c: Likewise.

	* elf/dl-init.c (_dl_init): Fix test of the size of the
	preinit_array section.
	(call_init): Optimize access to DT_INIT_ARRAY entry a bit.
	Reported by Brian Cabral <cabral@ikuni.com>.

2002-09-20  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/sysdep.h: Remove powerpc32 specific macros.
	* sysdeps/powerpc/powerpc32/sysdep.h: New file.  Define powerpc32
	specific macros copied from sysdeps/powerpc/sysdep.h.
	* sysdeps/powerpc/powerpc64/sysdep.h: New file.  Define powerpc64
	specific macros.
	* sysdeps/unix/powerpc/sysdep.h: Include <bits/wordsize.h>.
	[__WORDSIZE==64]: Include sysdeps/powerpc/powerpc64/sysdep.h.
	[!__WORDSIZE==64]: Include sysdeps/powerpc/powerpc32/sysdep.h.

2002-09-19  Bruno Haible  <bruno@clisp.org>

	* intl/dcigettext.c (DCIGETTEXT): Restore errno only right before
	returning.

2002-09-17  Bruno Haible  <bruno@clisp.org>

	* sysdeps/generic/utmp-equal.h: New file, extracted from utmp_file.c.
	* sysdeps/generic/utmp_file.c (setutent_file): Invalidate last_entry
	also on platforms with !HAVE_UT_TYPE.
	(proc_utmp_eq): Remove function.
	(internal_getut_r, pututline_file): Call __utmp_equal instead.

2002-09-20  Bruno Haible  <bruno@clisp.org>

	* abi-tags: Add support for FreeBSD with ABI OS value 3.
	* elf/cache.c (print_entry): Support the GNU/FreeBSD ABI tag.

2002-09-20  Roland McGrath  <roland@redhat.com>

	* sysdeps/generic/gmp-mparam.h: Include <bits/wordsize.h>.
	(BITS_PER_MP_LIMB, BYTES_PER_MP_LIMB, BITS_PER_LONGINT): Define in
	terms of __WORDSIZE.
	* sysdeps/x86_64/gmp-mparam.h: File removed.
	* sysdeps/sparc/gmp-mparam.h: File removed.
	* sysdeps/mips/mips64/gmp-mparam.h: File removed.
	* sysdeps/ia64/gmp-mparam.h: File removed.
	* sysdeps/alpha/gmp-mparam.h: File removed.

2002-09-20  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/elf/libc-start.c: Use long in place of int for argc
	load, so as to work on both 32-bit and 64-bit.  Remove unnecessary
	casts.  Align __libc_stack_end to 8 bytes.

2002-09-20  Roland McGrath  <roland@redhat.com>

	* sysdeps/powerpc/fpu/s_lrint.c: Use strong_alias/weak_alias macros
	instead of asm for lrintf, __lrintf aliases.

	* sysdeps/powerpc/fpu/s_lrint.c (__lrint): Change union long array to
	int array for 32-/64-bit compatibility.
	From Steven Munroe  <sjmunroe@us.ibm.com>.

2002-09-17  Bruno Haible  <bruno@clisp.org>

	* sysdeps/generic/ifreq.h (__if_nextreq): New function.
	* sysdeps/unix/sysv/linux/ifreq.h (__if_nextreq): New function.
	* sysdeps/mach/hurd/ifreq.h (__if_nextreq): New function.
	* sysdeps/gnu/ifaddrs.c (getifaddrs): Use __if_nextreq
	for iterating through the list of interfaces.
	* resolv/res_hconf.c (_res_hconf_reorder_addrs): Likewise.

2002-09-20  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/grantpt.c (pts_name): Set errno when __ptsname_r fails.
	Reported by Bruno Haible <bruno@clisp.org>.

	* sysdeps/unix/bsd/bsd4.4/isatty.c: New file.

	* sysdeps/unix/bsd/isatty.c (__isatty): Don't save and restore errno.
	* sysdeps/unix/bsd/ptsname.c (__ptsname_r): Return errno value from
	isatty unmodified.  Reported by Bruno Haible <bruno@clisp.org>.

2002-09-20  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/bits/setjmp.h [__WORDSIZE]: Add 64-bit jmpbuf.
	* sysdeps/powerpc/bits/wordsize.h: New file.
	* sysdeps/powerpc/fpu/bits/mathinline.h (lrint, lrintf): Change long
	array to int array for 32-/64-bit compatibility.

2002-09-20  Roland McGrath  <roland@redhat.com>

	* login/programs/utmpdump.c: Don't include <error.h>, <errno.h>.

	* sysdeps/generic/utimes.c (__utimes): Don't check TVP for null.
	Reported by Bruno Haible <bruno@clisp.org>.

	* sysdeps/generic/ifreq.h (__ifreq): Compute termination condition
	before doubling RQ_LEN.
	* sysdeps/unix/sysv/linux/ifreq.h (__ifreq): Likewise.
	Reported by Bruno Haible <bruno@clisp.org>.

2002-09-18  Bruno Haible  <bruno@clisp.org>

	* login/logout.c (logout): Don't assume ut_time has the same size as
	a time_t.
	* login/logwtmp.c (logwtmp): Likewise.

	* sysdeps/pthread/configure: New file, moved here from
	linuxthreads/sysdeps/unix/sysv/linux/configure.

2002-09-19  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/_exit.c: Include <errno.h>.
	(_exit): Don't use ABORT_INSTRUCTION if it is not defined.
	Reported by Glen Nakamura <glen@imodulo.com>.

2002-09-19  Neal H. Walfield  <neal@cs.uml.edu>

	* sysdeps/mach/hurd/fork.c (__fork): Do not free the signal
	thread's sigstate data structure if it has been allocated.

2002-09-19  Roland McGrath  <roland@redhat.com>

	* include/libc-symbols.h [HAVE_ASM_SET_DIRECTIVE]
	[! HAVE_ASM_GLOBAL_DOT_NAME] (__hidden_dot_def1): Fix typo'd name.

2002-09-18  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.2.94.

	* sysdeps/powerpc/fpu/Dist: Move fprrest.S and fprsave.S to...
	* sysdeps/powerpc/powerpc32/fpu/Dist: ...here.  New file.
	* sysdeps/unix/sysv/linux/powerpc/Dist: Move kernel_stat.h to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/Dist: ...here.

	* sysdeps/i386/Makefile: Remove obsolete db2 rules.

	* sysdeps/unix/sysv/linux/Makefile: Add exit-thread.S.

	* sysdeps/unix/sysv/linux/powerpc/Dist: Add ldd-rewrite.sh.

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/Dist: New file.

2002-09-19  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/wordsize-32/Makefile: New file.
	* sysdeps/arm/Makefile: Removed.
	* sysdeps/i386/Makefile (sysdep_routines, shared-only-routines):
	Don't add divdi3 here.
	* sysdeps/m68k/Makefile: Likewise.
	* sysdeps/powerpc/powerpc32/Makefile: Likewise.
	* sysdeps/sh/Makefile: Likewise.
	* sysdeps/s390/s390-32/Makefile: Likewise.

2002-09-18  Roland McGrath  <roland@redhat.com>

	* locale/lc-ctype.c (_nl_postload_ctype): Add compat_symbol decls for
	the __ctype_* compat symbols, so the relocs generated bind to the
	right versioned global symbol in the shared object.

	* elf/do-rel.h (elf_dynamic_do_rel): Mask off 0x8000 bit (hidden flag)
	from the value taken from the DT_VERSYM table.
	* elf/dl-runtime.c (fixup, profile_fixup): Likewise.
	* sysdeps/mips/dl-machine.h (__dl_runtime_resolve): Likewise.
	(RESOLVE_GOTSYM): Likewise.

	* sysdeps/unix/sysv/linux/sigaction.c (__libc_sigaction):
	Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/arm/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sigaction.c: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sigaction.c: Likewise.

2002-09-18  Ulrich Drepper  <drepper@redhat.com>

	* include/signal.h: Add libc_hidden_proto for __libc_sigaction.

	* sysdeps/unix/sysv/linux/sigaction.c: If SIGCANCEL is defined
	define sigaction and __sigaction as wrappers around
	__libc_sigaction which rejects changing SIGCANCEL.
	* sysdeps/unix/sysv/linux/i386/sigaction.c: Likewise.

	* sysdeps/unix/sysv/linux/i386/clone.S: Add support for SETTLS and
	SETTID/CLEARTID.

	* signal/allocrtsig.c: Move to...
	* sysdeps/generic/allocrtsig.c: ...here.  New file.

2002-09-17  Jakub Jelinek  <jakub@redhat.com>

	* elf/dl-lookup.c (_dl_debug_bindings): Print TLS lookups always.

	* elf/elf.h (R_386_TLS_TPOFF, R_386_TLS_IE, R_386_TLS_GOTIE,
	R_386_TLS_LE): Define.
	(R_386_TLS_IE_32, R_386_TLS_LE_32, R_386_TLS_TPOFF32): Update
	comments.
	* sysdeps/i386/dl-machine.h (elf_machine_type_class): Return
	ELF_RTYPE_CLASS_PLT for R_386_TLS_TPOFF.
	(elf_machine_rel): Handle R_386_TLS_TPOFF.
	(elf_machine_rela): Likewise.
	Remove unnecessary RTLD_BOOTSTRAP #ifdefs.

2002-09-17  Roland McGrath  <roland@redhat.com>

	* malloc/Makefile ($(objpfx)memusagestat.o: sysincludes): Define
	file-specific variable override so it compiles properly when using
	--with-headers.

2002-09-17  Steven Munroe  <sjmunroe@us.ibm.com>

	Ported to PowerPC64 running Linux.
	* sysdeps/powerpc/powerpc64/Dist: New file.
	* sysdeps/powerpc/powerpc64/Implies: New file.
	* sysdeps/powerpc/powerpc64/Makefile: New file.
	* sysdeps/powerpc/powerpc64/__longjmp.S: New file.
	* sysdeps/powerpc/powerpc64/atomicity.h: New file.
	* sysdeps/powerpc/powerpc64/backtrace.c: New file.
	* sysdeps/powerpc/powerpc64/bp-asm.h: New file.
	* sysdeps/powerpc/powerpc64/bsd-_setjmp.S: New file.
	* sysdeps/powerpc/powerpc64/bsd-setjmp.S: New file.
	* sysdeps/powerpc/powerpc64/dl-dtprocnum.h: New file.
	* sysdeps/powerpc/powerpc64/dl-lookupcfg.h: New file.
	* sysdeps/powerpc/powerpc64/dl-machine.c: New file.
	* sysdeps/powerpc/powerpc64/dl-machine.h: New file.
	* sysdeps/powerpc/powerpc64/memset.S: New file.
	* sysdeps/powerpc/powerpc64/ppc-mcount.S: New file.
	* sysdeps/powerpc/powerpc64/register-dump.h: New file.
	* sysdeps/powerpc/powerpc64/setjmp.S: New file.
	* sysdeps/powerpc/powerpc64/stpcpy.S: New file.
	* sysdeps/powerpc/powerpc64/strchr.S: New file.
	* sysdeps/powerpc/powerpc64/strcmp.S: New file.
	* sysdeps/powerpc/powerpc64/strcpy.S: New file.
	* sysdeps/powerpc/powerpc64/strlen.S: New file.
	* sysdeps/powerpc/powerpc64/elf/bzero.S: New file.
	* sysdeps/powerpc/powerpc64/elf/start.S: New file.
	* sysdeps/powerpc/powerpc64/fpu/s_copysign.S: New file.
	* sysdeps/powerpc/powerpc64/fpu/s_copysignf.S: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/Versions: New File.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/brk.S: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/clone.S: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/glob64.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/socket.S: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/syscalls.list: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/sysdep.h: New file.

	* include/libc-symbols.h [HAVE_ASM_GLOBAL_DOT_NAME]
	(C_SYMBOL_DOT_NAME): Insure that C_SYMBOL_DOT_NAME works for
	various gcc versions.  Dot names required for powerpc64.
	[HAVE_ASM_GLOBAL_DOT_NAME] (_weak_extern): Add .weakext '.'ed symbol.
	[HAVE_ASM_GLOBAL_DOT_NAME] (strong_alias): Add .global
	C_SYMBOL_DOT_NAME(alias).
	[HAVE_ASM_GLOBAL_DOT_NAME] (strong_data_alias): New macro. Same as
	original strong_alias macro.
	[HAVE_ASM_GLOBAL_DOT_NAME] (weak_alias): Add .weakext/.weak
	C_SYMBOL_DOT_NAME(alias).
	[HAVE_ASM_GLOBAL_DOT_NAME] (_symbol_version): Add .symver '.'ed name.
	[HAVE_ASM_GLOBAL_DOT_NAME] (_default_symbol_version): Add .symver
	'.'ed name.
	Add comments on libc_hidden_data_def and libc_hidden_data_weak usage.
	[HAVE_ASM_GLOBAL_DOT_NAME] (hidden_dot_def1): New macro.  Generate
	.global C_SYMBOL_DOT_NAME(alias).  Otherwise an empty macro.
	(hidden_def): Append hidden_dot_def1 macro to definition.
	(hidden_ver): Append hidden_dot_def1 macro to definition.
	(hidden_data_def): New macro.  Same as original hidden_def macro.
	(hidden_data_ver): New macro.  Same as original hidden_ver macro.
	[HAVE_ASM_GLOBAL_DOT_NAME] (hidden_dot_weak1): New macro.  Generate
	.weakext C_SYMBOL_DOT_NAME(alias).  Otherwise an empty macro.
	(hidden_weak): Append hidden_dot_weak1 macro to definition.
	(hidden_data_weak): New macro.  Same as original hidden_weak macro.
	[HAVE_ASM_GLOBAL_DOT_NAME] (HIDDEN_JUMPTARGET): Define as .__GI_name.
	Otherwise defined as __GI_name.
	(libc_hidden_data_def): New macro.  Use hidden_data_def.
	(libc_hidden_data_weak): New macro.  Use hidden_data_weak.
	(libc_hidden_data_ver): New macro.  Use hidden_data_ver.
	(rtld_hidden_data_def): New macro.  Use hidden_data_def.
	(rtld_hidden_data_weak): New macro.  Use hidden_data_weak.
	(rtld_hidden_data_ver): New macro.  Use hidden_data_ver.
	(libm_hidden_data_def): New macro.  Use hidden_data_def.
	(libm_hidden_data_weak): New macro.  Use hidden_data_weak.
	(libm_hidden_data_ver): New macro.  Use hidden_data_ver.
	* inet/in6_addr.c: Replace libc_hidden_def with libc_hidden_data_def.

2002-09-17  Ulrich Drepper  <drepper@redhat.com>

	* include/libc-symbols.h: Change *hidden_proto macros to accept
	option parameters and pass those to the attribute definition.
	* include/unistd.h (_exit): Add __noreturn__ to libc_hidden_proto call.

	* include/unistd.h: Declare __libc_pause.

	* include/sys/socket.h: Declare __libc_send, __libc_recv,
	__libc_sendto, __libc_sendmsg, __libc_recvmsg, and __libc_accept.

	* include/unistd.h: Declare __libc_fork.

2002-09-17  Roland McGrath  <roland@redhat.com>

	* sunrpc/xcrypt.c (passwd2des_internal): Renamed fom passwd2des.
	(passwd2des): Define it as an alias.
	(xencrypt, xdecrypt): Call passwd2des_internal instead of passwd2des.

2002-09-12  Bruno Haible  <bruno@clisp.org>

	* include/sys/sysctl.h (__sysctl): Add libc_hidden_proto.
	* sysdeps/unix/sysv/linux/sysctl.c (__sysctl): Add libc_hidden_def.

	* include/rpc/xdr.h (xdrstdio_create): Add libc_hidden_proto.
	* sunrpc/xdr_stdio.c (xdrstdio_create): Add libc_hidden_def.

2002-09-05  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/unix/sysv/linux/kernel-features.h [__powerpc64__]
	(__ASSUME_TRUNCATE64_SYSCALL, __ASSUME_STAT64_SYSCALL, __ASSUME_IPC64,
	__ASSUME_FCNTL64, __ASSUME_MMAP2_SYSCALL): Don't define these.
	PowerPC64 does not have separate 64-bit syscalls.

2002-09-16  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/mmap64.c (__mmap64): Add a cast.

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/sysdep.h (INLINE_SYSCALL):
	New macro.

	* elf/rtld.c [HP_TIMING_NONAVAIL]: Fix last change for this case.

	* include/unistd.h: Uncomment libc_hidden_proto for _exit.
	* sysdeps/mach/hurd/_exit.c: Add libc_hidden_def.
	* sysdeps/generic/_exit.c: Likewise.

2002-09-12  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc32/fpu/libm-test-ulps: Regenerate.

	* elf/rtld.c (struct dl_start_final_info): New.
	(_dl_start_final): Change second argument to struct
	dl_start_final_info *.  Set start_time from info.
	(_dl_start): Remove bootstrap_map variable, add info.
	Define bootstrap_map as macro.  If not DONT_USE_BOOTSTRAP_MAP,
	store HP_TIMING_NOW result into info.start_time.

2002-09-16  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/_exit.c: Add libc_hidden_def and weak_alias
	to _Exit.
	* sysdeps/unix/sysv/linux/i386/_exit.S: Likewise.

2002-09-15  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* sysdeps/powerpc/abort-instr.h: New file.

2002-09-14  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/libc-start.c (__libc_start_main): Remove bogus
	comment.

	* test-skeleton.c (main): Provide more information in case waitpid
	fails.

	* include/unistd.h: Declare __exit_thread.
	* sysdeps/generic/libc-start.c (__libc_start_main): Remove dummy_addr.
	Wrap call to main in setjmp if HAVE_CANCELBUF is defined.
	* sysdeps/unix/sysv/linux/exit-thread.S: New file.
	* sysdeps/unix/sysv/linux/_exit.c: New file.
	* sysdeps/unix/sysv/linux/i386/_exit.S: New file.
	* sysdeps/unix/sysv/linux/Makefile [subdir==posix] (sysdep_routines):
	Add exit-thread.

	* configure.in: Add dl_iterate_phdr to test using -nostdlib.

2002-09-12  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/i386/dl-machine.h (elf_machine_rel)
	(case R_386_TLS_DTPMOD32): Don't use addend.
	[case R_386_TLS_TPOFF32]: Remove redundant SYM_MAP != NULL check.
	(elf_machine_rela): Add support for TLS relocs.

2002-09-14  Roland McGrath  <roland@redhat.com>

	* Makefile (manual/%): Add this pattern target to the iconvdata/% rule.

2002-07-29  Steven Munroe  <sjmunroe@us.ibm.com>

	* stdlib/longlong.h [_ARCH_PPC && W_TYPE_SIZE!=32]: Add powerpc64
	specific asm macros for multiple percision integer math.

2002-06-04  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/generic/ldconfig.h (FLAG_POWERPC_LIB64) New macro.
	* elf/cache.c (print_entry): Add case for FLAG_POWERPC_LIB64.
	Remove per-machine conditionals for FLAG_* cases.
	* sysdeps/unix/sysv/linux/powerpc/ldconfig.h: New file.
	* sysdeps/unix/sysv/linux/powerpc/readelflib.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/dl-cache.h: New file.

2002-09-10  Alan Modra <amodra@bigpond.net.au>

	* csu/gmon-start.c [!TEXT_START]: Define TEXT_START if not already
	defined in entry.h.
	(__gmon_start__) [!ENTRY_POINT_DECL]: Use TEXT_START macro to obtain
	lowest address for profiling in  __monstartup call.
	* sysdeps/powerpc/powerpc64/elf/entry.h: New file.

2002-09-14  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/pread.c: __NR_pread64 may be defined
	instead of __NR_pread.
	* sysdeps/unix/sysv/linux/pread64.c: Likewise.
	* sysdeps/unix/sysv/linux/pwrite.c: __NR_pwrite64 may be defined
	instead of __NR_pwrite.
	* sysdeps/unix/sysv/linux/pwrite64.c: Likewise.

2002-09-13  Roland McGrath  <roland@redhat.com>

	* manual/libc.texinfo: @ifinfo -> @ifnottex around copyright notice.

2002-09-13  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/syscalls.list: Add readahead
	syscall.  Patch by Guido Guenther <agx@sigxcpu.org>.

2002-09-12  Ulrich Drepper  <drepper@redhat.com>

	* elf/elf.h: Correct DT_LOOS and DT_HIOS values.

2002-09-10  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/powerpc/fpu/s_isnan.c: #undef __isnanf and isnanf after
	reading the headers.

2002-09-12  Roland McGrath  <roland@redhat.com>

	* elf/rtld.c (_dl_start_final): Move _begin, _end decls outside the fn.
	(_dl_start) [DONT_USE_BOOTSTRAP_MAP]: Use &_begin instead of l_addr to
	find the ELF header.

	* elf/rtld.c (dl_main) [USE_TLS]: Adjust l_tls_initimage of main
	executable if needed, in case it's actually a shared object.

2002-09-11  Roland McGrath  <roland@redhat.com>

	* elf/dl-load.c (_dl_map_object_from_fd): Use l_addr instead of
	l_map_start to adjust l_tls_initimage.

	* nss/getnssent_r.c (__nss_getent_r): Use EAGAIN instead of errno
	when using h_errno and it's not set to NETDB_INTERNAL.
	* nss/getXXbyYY_r.c [NEED_H_ERRNO]: Likewise.

	* Makefile ($(common-objpfx)testrun.sh): New target.
	(others): Depend on it.
	(postclean-generated): Append it.

	* nss/bug-erange.c: New file.
	* nss/Makefile (tests): Add it.

	* nss/getXXbyYY_r.c (INTERNAL (REENTRANT_NAME)): Return errno
	instead of always EAGAIN when status is NSS_STATUS_TRYAGAIN.

	* sysdeps/generic/dl-environ.c (unsetenv): Redo last fix without
	strncmp, keeps the code smaller for a non-performance-critical case.

	* sysdeps/generic/dl-environ.c (unsetenv): Rewritten using strncmp,
	no longer wrongly matches arbitrary prefixes of NAME.
	Reported by Jakub Jelinek <jakub@redhat.com>.

2002-09-11  Jakub Jelinek  <jakub@redhat.com>

	* posix/bug-regex11.c (tests): New array.
	(main): Rewritten to run more different tests.

2002-09-10  Roland McGrath  <roland@redhat.com>

	* nscd/Makefile (CPPFLAGS-nscd, CPPFLAGS-nscd_conf, CPPFLAGS-dbg_log)
	(CPPFLAGS-connections, CPPFLAGS-hstcache): Variables removed.
	Instead, catch all of $(nscd-modules) via cppflags-iterator.mk.

	* sysdeps/powerpc/fpu/s_isnan.c: Do macro hackery on __GI___isnanf as
	well so we don't get it declared by include/math.h's hidden_proto.
	Then do hidden_proto for __isnanf locally so hidden_def works right.

	* posix/bug-regex5.c (main): Use `union locale_data_value' rather than
	a cast to turn nl_langinfo return value into an integer.

2002-09-10  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regexec.c (build_trtable): Fix the destination of
	newline to prevent wrong states from overwriting.
	Append break statements to optimization.

2002-09-10  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regcomp.c: Wrap #include wchar.h and wctype.h in #if.
	(build_range_exp): Add castings to strlen invocations.
	(build_collating_symbol): Restore the type of characters from "char"
	to "unsigned char", and supplement castings.
	(build_collating_symbol): Likewise.
	(build_equiv_class): Likewise.
	(build_charclass): Likewise.
	(seek_collating_symbol_entry): Likewise.
	(parse_bracket_exp): Likewise.
	(build_word_op): Supplement a casting.
	* posix/regex_internal.c: Wrap #include wchar.h and wctype.h in #if.
	(re_string_allocate): Fix castings.
	(re_string_construct): Likewise.
	(re_string_construct_common): Likewise.
	(re_string_realloc_buffers): Likewise.
	(build_wcs_buffer): Likewise.
	(build_wcs_upper_buffer): Likewise.
	(re_string_skip_chars): Likewise.
	(re_string_reconstruct): Likewise.
	* posix/regex_internal.h: Restore the type of characters in
	re_string_t and bracket_elem_t from "char" to "unsigned char".
	(re_string_elem_size_at): Fix castings.
	* posix/regexec.c: Wrap #include wchar.h and wctype.h in #if.
	(transit_state_bkref_loop): Restore the type of characters from
	"char" to "unsigned char", and append a cast to "char*" pointer in
	array subscript.
	(check_node_accept_bytes): Likewise.
	(find_collation_sequence_value): Likewise.

2002-09-10  Hartvig Ekner  <hartvige@mips.com>

	* sysdeps/mips/memcpy.S: New file.
	* sysdeps/mips/memset.S: New file.
	* sysdeps/mips/fpu/e_sqrt.c:  New file.
	* sysdeps/mips/fpu/e_sqrtf.c: New file.

	* fpu/fclrexcpt.c: Cleaned up the FPU exception stuff - was not
	functional before. Also removed all SHLIB_COMPAT stuff.
	* fpu/fegetenv.c: Likewise.
	* fpu/fesetenv.c:: Likewise.
	* fpu/feupdateenv.c: Likewise.
	* fpu/fgetexcptflg.c: Likewise.
	* fpu/fraiseexcpt.c: Likewise.

	* sysdeps/mips/fpu/fsetexcptflg.c: New file.

2002-09-09  Jakub Jelinek  <jakub@redhat.com>

	* include/math.h (__finite_internal, __finitef_internal,
	__finitel_internal, __isinf_internal, __isnan_internal): Remove.
	(isfinite): Remove.
	(__finite, __isinf, __isnan, __finitef, __isinff, __isnanf, __finitel,
	__isinfl, __isnanl): Add hidden_proto.
	(__fpclassify, __fpclassifyf, __fpclassifyl, __expm1l): Add
	libm_hidden_proto.
	* math/Makefile (libm-calls): Add s_isinf and s_isnan.
	* stdio-common/printf_fp.c (__printf_fp): Remove INTUSE from
	__is{inf,nan} calls.
	* stdio-common/printf_size.c (printf_size): Likewise.
	* sysdeps/generic/printf_fphex.c (__printf_fphex): Likewise.
	* sysdeps/generic/s_ldexp.c (__ldexp): Likewise.
	* sysdeps/generic/s_ldexpf.c (__ldexpf): Likewise.
	* sysdeps/generic/s_ldexpl.c (__ldexpl): Likewise.
	* sysdeps/generic/s_expm1l.c (__expm1l): Add libm_hidden_def.
	* sysdeps/i386/fpu/s_finite.S (__finite_internal): Remove alias.
	(__finite): Add hidden_def.
	* sysdeps/i386/fpu/s_finitef.S (__finitef_internal): Remove alias.
	(__finitef): Add hidden_def.
	* sysdeps/i386/fpu/s_finitel.S (__finitel_internal): Remove alias.
	(__finitel): Add hidden_def.
	* sysdeps/i386/fpu/s_isinfl.c (__isinfl): Remove INTDEF.  Add
	hidden_def.
	* sysdeps/i386/fpu/s_isnanl.c (__isnanl): Likewise.
	* sysdeps/i386/fpu/s_fpclassifyl.c (__fpclassifyl): Add
	libm_hidden_def.
	* sysdeps/i386/fpu/s_expm1l.S (__expm1l): Likewise.
	* sysdeps/ieee754/dbl-64/s_finite.c (__finite): Remove INTDEF.  Add
	hidden_def.
	* sysdeps/ieee754/dbl-64/s_isinf.c (__isinf): Likewise.
	(__isinfl): Remove INTDEF.
	* sysdeps/ieee754/dbl-64/s_isnan.c (__isnan): Remove INTDEF.  Add
	hidden_def.
	(__isnanl): Remove INTDEF.
	* sysdeps/ieee754/dbl-64/s_fpclassify.c (__fpclassify): Add
	libm_hidden_def.
	* sysdeps/ieee754/dbl-64/e_lgamma_r.c (sin_pi): Use __sin and __cos
	instead of sin and cos.
	* sysdeps/ieee754/flt-32/s_finitef.c (__finitef): Remove INTDEF.
	Add hidden_def.
	* sysdeps/ieee754/flt-32/s_isinff.c (__isinff): Likewise.
	* sysdeps/ieee754/flt-32/s_isnanf.c (__isnanf): Likewise.
	* sysdeps/ieee754/flt-32/s_fpclassifyf.c (__fpclassifyf): Add
	libm_hidden_def.
	* sysdeps/ieee754/ldbl-128/s_finitel.c (__finitel): Remove INTDEF.
	Add hidden_def.
	* sysdeps/ieee754/ldbl-128/s_isinfl.c (__isinfl): Likewise.
	* sysdeps/ieee754/ldbl-128/s_isnanl.c (__isnanl): Likewise.
	* sysdeps/ieee754/ldbl-128/s_fpclassifyl.c (__fpclassifyl): Add
	libm_hidden_def.
	* sysdeps/ieee754/ldbl-128/s_expm1l.c (__expm1l): Add
	libm_hidden_def.
	* sysdeps/ieee754/ldbl-96/s_finitel.c (__finitel): Remove INTDEF.
	Add hidden_def.
	* sysdeps/ieee754/ldbl-96/s_isinfl.c (__isinfl): Likewise.
	* sysdeps/ieee754/ldbl-96/s_isnanl.c (__isnanl): Likewise.
	* sysdeps/ieee754/ldbl-96/s_fpclassifyl.c (__fpclassifyl): Add
	libm_hidden_def.
	* sysdeps/ia64/fpu/s_finite.S (__finite_internal, __finitef_internal,
	__finitel_internal): Remove aliases.
	(__finite, __finitef, __finitel): Add hidden_def.
	* sysdeps/ia64/fpu/s_isnan.S (__isnan_internal, __isnanf_internal,
	__isnanl_internal): Remove aliases.
	(__isnan, __isnanf, __isnanl): Add hidden_def.
	* sysdeps/ia64/fpu/s_isinf.S (__isinf_internal, __isinff_internal,
	__isinfl_internal): Remove aliases.
	(__isinf, __isinff, __isinfl): Add hidden_def.
	* sysdeps/ia64/fpu/s_fpclassify.S (__fpclassify, __fpclassifyf,
	__fpclassifyl): Add libm_hidden_def.
	* sysdeps/ia64/fpu/s_expm1l.S (__expm1l): Likewise.
	* sysdeps/m68k/s_isinfl.c (__isinfl): Remove INTDEF.  Add hidden_def.
	* sysdeps/m68k/fpu/s_isinf.c (INTDEFX): Remove.
	(hidden_defx): Define and use.
	* sysdeps/m68k/fpu/s_fpclassifyl.c (__fpclassifyl): Add
	libm_hidden_def.
	* sysdeps/m68k/fpu/s_expm1l.c (__expm1l): Likewise.
	* sysdeps/m68k/s_isnanl.c (__isnanl): Add hidden_def.
	* sysdeps/powerpc/fpu/s_isnan.c (__isnan, __isnanf, __isnanl):
	Remove INTDEF.
	(__isnan, __isnanf): Add hidden_def.
	* sysdeps/x86_64/fpu/s_finitel.S (__finitel_internal): Remove alias.
	(__finitel): Add libm_hidden_def.
	* sysdeps/x86_64/fpu/s_expm1l.S (__expm1l): Likewise.

	* include/fenv.h (feraiseexcept, fesetenv): Add libm_hidden_proto.
	* sysdeps/alpha/fpu/fesetenv.c (fesetenv): Add libm_hidden_ver.
	* sysdeps/alpha/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/arm/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/arm/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/generic/fesetenv.c (fesetenv): Likewise.
	* sysdeps/generic/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/i386/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/i386/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/m68k/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/m68k/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/mips/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/mips/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/powerpc/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/powerpc/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/sparc/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/sparc/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/hppa/fpu/fesetenv.c (fesetenv): Add libm_hidden_def.
	* sysdeps/hppa/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/ia64/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/ia64/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/sh/sh4/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/sh/sh4/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/s390/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/s390/fpu/fraiseexcpt.c (feraiseexcept): Likewise.
	* sysdeps/x86_64/fpu/fesetenv.c (fesetenv): Likewise.
	* sysdeps/x86_64/fpu/fraiseexcpt.c (feraiseexcept): Likewise.

2002-09-09  Steven Munroe  <sjmunroe@us.ibm.com>

	* elf/elf.h: Add powerpc64 specific elf relocation and dynamic types.

2002-09-09  Jakub Jelinek  <jakub@redhat.com>

	* elf/dl-error.c (_dl_signal_cerror): Don't print anything if only
	LD_DEBUG=statistics or LD_TRACE_PRELINKING.

2002-09-09  Ulrich Drepper  <drepper@redhat.com>

	* string/stratcliff.c: Some more strncpy tests.
	Patch by Daniel Jacobowitz <drow@mvista.com>.

2002-09-08  Roland McGrath  <roland@redhat.com>

	* resolv/resolv.h: Include <sys/types.h> for u_long even in
	the [__need_res_state] case.
	Reported by Bruno Haible <bruno@clisp.org>.

2002-09-04  Bruno Haible  <bruno@clisp.org>

	* sysdeps/generic/bits/ustat.h: Comment fix.
	* io/sys/sendfile.h: Comment fix.
	* sysdeps/posix/pread.c: Comment fix.
	* sysdeps/posix/pread64.c: Comment fix.
	* sysdeps/posix/pwrite.c: Comment fix.
	* sysdeps/posix/pwrite64.c: Comment fix.

2002-09-06  Roland McGrath  <roland@redhat.com>

	* posix/sys/utsname.h (_UTSNAME_SYSNAME_LENGTH): New macro, defined
	to _UTSNAME_LENGTH if not already defined by <bits/utsname.h>.
	(_UTSNAME_RELEASE_LENGTH, _UTSNAME_VERSION_LENGTH): Likewise.
	(_UTSNAME_MACHINE_LENGTH): Likewise.
	(struct utsname): Use new macros instead of _UTSNAME_LENGTH.

2002-09-06  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/shm_open.c (where_is_shmfs): Correct
	test for filesystem type name of mount points.

	* include/errno.h: Use errno definition with __thread for now only
	in libc and ld.so.

	* test-skeleton.c (main): Improve error message for unexpected
	signal case.

2002-09-05  Roland McGrath  <roland@redhat.com>

	* ctype/ctype-info.c: Renamed __ctype_old_* symbols to __ctype_*.
	* locale/lc-ctype.c (_nl_postload_ctype): Likewise.

2002-09-05  Jakub Jelinek  <jakub@redhat.com>

	* wcsmbs/wcsmbsload.c (__wcsmbs_load_conv): Unlock and return in
	case of failure.

2002-09-04  Bruno Haible  <bruno@clisp.org>

	* sysdeps/unix/sysv/linux/sigset-cvt-mask.h (sigset_set_old_mask,
	sigset_get_old_mask): Turn into inline functions.
	* sysdeps/unix/sysv/aix/sigset-cvt-mask.h (sigset_set_old_mask,
	sigset_get_old_mask): Likewise.
	* sysdeps/unix/sysv/sysv4/sigset-cvt-mask.h (sigset_set_old_mask,
	sigset_get_old_mask): Likewise.
	* sysdeps/generic/sigset-cvt-mask.h (sigset_set_old_mask): Declutter
	syntax.

	* elf/readlib.c (process_file): Conditionalize check for QMAGIC.

	* sysdeps/generic/_strerror.c (_sys_errlist, _sys_nerr): Remove
	default definitions.
	(__strerror_r): Use _sys_errlist_internal instead of _sys_errlist,
	_sys_nerr_internal instead of _sys_nerr.

	* nscd/connections.c (handle_request): Declare CALLER inside #if.

2002-07-29  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/__longjmp.S: Moved to...
	* sysdeps/powerpc/powerpc32/__longjmp.S: ...here.
	* sysdeps/powerpc/add_n.S: Moved to...
	* sysdeps/powerpc/powerpc32/add_n.S: ...here.
	* sysdeps/powerpc/addmul_1.S: Moved to...
	* sysdeps/powerpc/powerpc32/addmul_1.S: ...here.
	* sysdeps/powerpc/atomicity.h: Moved to...
	* sysdeps/powerpc/powerpc32/atomicity.h: ...here.
	* sysdeps/powerpc/backtrace.c: Moved to...
	* sysdeps/powerpc/powerpc32/backtrace.c: ...here.
	* sysdeps/powerpc/bp-asm.h: Moved to...
	* sysdeps/powerpc/powerpc32/bp-asm.h: ...here.
	* sysdeps/powerpc/bsd-_setjmp.S: Moved to...
	* sysdeps/powerpc/powerpc32/bsd-_setjmp.S: ...here.
	* sysdeps/powerpc/bsd-setjmp.S: Moved to...
	* sysdeps/powerpc/powerpc32/bsd-setjmp.S: ...here.
	* sysdeps/powerpc/dl-machine.c: Moved to...
	* sysdeps/powerpc/powerpc32/dl-machine.c: ...here.
	* sysdeps/powerpc/dl-machine.h: Moved to...
	* sysdeps/powerpc/powerpc32/dl-machine.h: ...here.
	* sysdeps/powerpc/dl-start.S: Moved to...
	* sysdeps/powerpc/powerpc32/dl-start.S: ...here.
	* sysdeps/powerpc/gprrest0.S: Moved to...
	* sysdeps/powerpc/powerpc32/gprrest0.S: ...here.
	* sysdeps/powerpc/gprrest1.S: Moved to...
	* sysdeps/powerpc/powerpc32/gprrest1.S: ...here.
	* sysdeps/powerpc/gprsave0.S: Moved to...
	* sysdeps/powerpc/powerpc32/gprsave0.S: ...here.
	* sysdeps/powerpc/gprsave1.S: Moved to...
	* sysdeps/powerpc/powerpc32/gprsave1.S: ...here.
	* sysdeps/powerpc/lshift.S: Moved to...
	* sysdeps/powerpc/powerpc32/lshift.S: ...here.
	* sysdeps/powerpc/memset.S: Moved to...
	* sysdeps/powerpc/powerpc32/memset.S: ...here.
	* sysdeps/powerpc/mul_1.S: Moved to...
	* sysdeps/powerpc/powerpc32/mul_1.S: ...here.
	* sysdeps/powerpc/ppc-mcount.S: Moved to...
	* sysdeps/powerpc/powerpc32/ppc-mcount.S: ...here.
	* sysdeps/powerpc/register-dump.h: Moved to...
	* sysdeps/powerpc/powerpc32/register-dump.h: ...here.
	* sysdeps/powerpc/rshift.S: Moved to...
	* sysdeps/powerpc/powerpc32/rshift.S: ...here.
	* sysdeps/powerpc/setjmp.S: Moved to...
	* sysdeps/powerpc/powerpc32/setjmp.S: ...here.
	* sysdeps/powerpc/stpcpy.S: Moved to...
	* sysdeps/powerpc/powerpc32/stpcpy.S: ...here.
	* sysdeps/powerpc/strchr.S: Moved to...
	* sysdeps/powerpc/powerpc32/strchr.S: ...here.
	* sysdeps/powerpc/strcmp.S: Moved to...
	* sysdeps/powerpc/powerpc32/strcmp.S: ...here.
	* sysdeps/powerpc/strcpy.S: Moved to...
	* sysdeps/powerpc/powerpc32/strcpy.S: ...here.
	* sysdeps/powerpc/strlen.S: Moved to...
	* sysdeps/powerpc/powerpc32/strlen.S: ...here.
	* sysdeps/powerpc/sub_n.S: Moved to...
	* sysdeps/powerpc/powerpc32/sub_n.S: ...here.
	* sysdeps/powerpc/submul_1.S: Moved to...
	* sysdeps/powerpc/powerpc32/submul_1.S: ...here.
	* sysdeps/powerpc/elf/bzero.S: Moved to...
	* sysdeps/powerpc/powerpc32/elf/bzero.S: ...here.
	* sysdeps/powerpc/elf/start.S: Moved to...
	* sysdeps/powerpc/powerpc32/elf/start.S: ...here.
	* sysdeps/powerpc/fpu/__longjmp.S: Moved to...
	* sysdeps/powerpc/powerpc32/fpu/__longjmp.S: ...here.
	* sysdeps/powerpc/fpu/fprrest.S: Moved to...
	* sysdeps/powerpc/powerpc32/fpu/fprrest.S: ...here.
	* sysdeps/powerpc/fpu/fprsave.S: Moved to...
	* sysdeps/powerpc/powerpc32/fpu/fprsave.S: ...here.
	* sysdeps/powerpc/fpu/setjmp.S: Moved to...
	* sysdeps/powerpc/powerpc32/fpu/setjmp.S: ...here.
	* sysdeps/powerpc/fpu/s_copysign.S: Moved to...
	* sysdeps/powerpc/powerpc32/fpu/s_copysign.S: ...here.
	* sysdeps/powerpc/fpu/s_copysignf.S: Moved to...
	* sysdeps/powerpc/powerpc32/fpu/s_copysignf.S: ...here.
	* sysdeps/unix/sysv/linux/powerpc/brk.S: Moved to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/brk.S: ...here.
	* sysdeps/unix/sysv/linux/powerpc/clone.S: Moved to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/clone.S: ...here.
	* sysdeps/unix/sysv/linux/powerpc/glob64.c: Moved to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/glob64.c: ...here.
	* sysdeps/unix/sysv/linux/powerpc/kernel_stat.h: Moved to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/kernel_stat.h: ...here.
	* sysdeps/unix/sysv/linux/powerpc/socket.S: Moved to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/socket.S: ...here.
	* sysdeps/unix/sysv/linux/powerpc/sysdep.h: Moved to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/sysdep.h: ...here.
	* sysdeps/unix/sysv/linux/powerpc/syscalls.list: Moved to...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/syscalls.list: ...here.
	Support PowerPC64.  Separate powerpc into powerpc/powerpc32 and
	powerpc/powerpc64.

2002-07-29  Steven Munroe  <sjmunroe@us.ibm.com>

	* FAQ.in: Add powerpc64 to supported targets list. Also state the
	minimum gcc version is 3.2
	* README: Add powerpc64 to supported targets list.
	* configure.in: Change machine=powerpc to machine=powerpc/powerpc32.
	Add powerpc64 and machine=powerpc/powerpc64.
	(HAVE_ASM_GLOBAL_DOT_NAME): Define if linux*powerpc/powerpc64*.
	* shlib-versions: Set DEFAULT version to 2.2.5 for powerpc64.
	* sysdeps/powerpc/Dist: Remove dl-machine.c, dl-start.S, ppc-mcount.S,
	gprsave1.S, gprsave0.S, gprrest1.S, and gprrest0.S.
	* sysdeps/powerpc/powerpc32/Dist: New file.
	* sysdeps/powerpc/Implies: Remove wordsize-32 and powerpc/soft-fp.
	* sysdeps/powerpc/powerpc32/Implies: New file.
	* sysdeps/powerpc/Makefile(cflags): Remove powerpc32 specific cflags.
	($(with-fp) = no): Move test to powerpc32/Makefile.
	($(subdir) = misc): Move to powerpc32/Makefile.
	($(build-shared) = yes): Move to powerpc32/Makefile.
	($(subdir) = csu): Move to powerpc32/Makefile.
	(sysdep-rtld-routines): Remove dl-start.  Moved these bits to ...
	* sysdeps/powerpc/powerpc32/Makefile: New file.
	* sysdeps/powerpc/Versions: Remove libgcc functions.
	* sysdeps/powerpc/powerpc32/Versions: New file.
	* sysdeps/powerpc/fpu/Makefile: Remove fprsave and fprrest.
	* sysdeps/powerpc/powerpc32/fpu/Makefile: New file.
	* sysdeps/unix/sysv/linux/configure.in (powerpc*):
	Set arch_minimum_kernel=2.4.19 for powerpc/powerpc64. Also set
	libc_cv_gcc_unwind_find_fde=yes only if !powerpc/powerpc64.
	($machine): Add powerpc/powerpc64 to if ... | for
	libc_cv_slibdir=/libc64.
	(powerpc*): Set ldd_rewrite_script.
	* sysdeps/unix/sysv/linux/powerpc/ldd-rewrite.sed: New file.
	* sysdeps/unix/sysv/linux/powerpc/Dist: Remove clone.S.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/Dist: New file.
	Add clone.S.
	* sysdeps/unix/sysv/linux/powerpc/Makefile: Remove oldgetrlimit64.
	* sysdeps/unix/sysv/linux/powerpc/Versions: Remove GLIBC_2.0
	functions.  Remove GLIBC_2.2 functions except getrlimit and
	setrlimit.  Moved them to ...
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/Versions: New file.

2002-09-04  Ulrich Drepper  <drepper@redhat.com>

	* libio/tst-atime.c: Include <errno.h>.
	(do_test): Only perform fstatvfs check if ST_NOATIME is defined.

2002-09-03  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regcomp.c (regcomp): Append "__restrict" modifier to avoid
	warnings of some compilers.
	(build_collating_symbol): Change the type of characters from
	"unsigned char"	to "char", and append a cast to "char*" pointer in
	array subscript.
	(build_collating_symbol): Likewise.
	(build_equiv_class): Likewise.
	(build_charclass): Likewise.
	(re_compile_pattern): Remove incorrect cast.
	(re_compile_fastmap_iter): Change the type of characters from
	"unsigned char"	to "char", and append a cast to "char*" pointer
	in array subscript.
	(parse_bracket_exp): Likewise.
	* posix/regex_internal.c (re_string_construct_common): Likewise.
	(re_string_allocate): Likewise.
	(re_string_construct): Likewise.
	(re_string_realloc_buffers): Likewise.
	(build_wcs_buffer): Likewise.
	(re_string_reconstruct): Likewise.
	* posix/regex_internal.h: Change the type of characters in
	re_string_t and bracket_elem_t from "unsigned char" to "char".
	* posix/regexec.c (regexec): Append "__restrict" modifier to avoid
	warnings of some compilers.
	(transit_state_bkref_loop): Change the type of characters from
	"unsigned char"	to "char", and append a cast to "char*" pointer in
	array subscript.
	(check_node_accept_bytes): Likewise.
	(find_collation_sequence_value): Likewise.

2002-09-04  Roland McGrath  <roland@redhat.com>

	* resolv/nss_dns/dns-network.c (MAXPACKET): Increase minimum value
	from 1024 to 65536, to avoid buffer overrun.

2002-09-03  Gerhard Tonn  <ton@de.ibm.com>

	* sysdeps/s390/s390/fpu/libm-test-ulps: Regenerate.

2002-09-04  Ulrich Drepper  <drepper@redhat.com>

	* libio/tst-atime.c (do_test): Make sure noatime flag isn't set
	for filesystem.

2002-09-04  Jakub Jelinek  <jakub@redhat.com>

	* posix/bug-regex11.c: New test.
	* posix/Makefile (tests): Add bug-regex11.

2002-09-03  Jakub Jelinek  <jakub@redhat.com>

	* locale/tst-C_locale.c (run_test): Pass LC_ALL_MASK not LC_ALL to
	newlocale.

2002-09-02  Roland McGrath  <roland@redhat.com>

	* sysdeps/powerpc/elf/libc-start.c [! SHARED]: Call
	__pthread_initialize_minimal and __libc_check_standard_fds to
	match the generic version.

	* sysdeps/unix/sysv/linux/shmat.c (shmat): Add a cast to avoid a
	warning when INLINE_SYSCALL macro uses the __syscall_ipc function.

	* locale/localeconv.c (__localeconv): Cast -1 to char to avoid
	warnings on platorms where char is unsigned.

2002-09-02  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.2.93.

	* sysdeps/unix/sysv/linux/x86_64/Dist: Add __start_context.S.

2002-09-02  Jakub Jelinek  <jakub@redhat.com>

	* elf/rtld.c (dl_main): If prelinking succeeded, mark all objects
	as relocated.

2002-09-02  Jack Howarth  <howarth@bromo.msbb.uc.edu>

	* sysdeps/powerpc/fpu/libm-test-ulps: Regenerated.

2002-09-02  Jakub Jelinek  <jakub@redhat.com>

	* locale/localeinfo.h (struct locale_data): Add private.ctype.
	* wcsmbs/wcsmbsload.h (__wcsmbs_gconv_fcts, __wcsmbs_last_locale,
	__wcsmbs_to_wc, update_conversion_ptrs): Removed.
	(__wcsmbs_gconv_fcts_c, _nl_C_LC_CTYPE): New externs.
	(__wcsmbs_load_conv): Remove const from argument.
	(_nl_cleanup_ctype): New proto.
	(get_gconv_fcts): New function.
	* wcsmbs/wcsmbsload.c (__wcsmbs_last_locale): Removed.
	(__wcsmbs_to_wc): Rename back to...
	(to_wc): ... this.
	(__wcsmbs_gconv_fcts): Rename to...
	(__wcsmbs_gconv_fcts_c): ... this.  Make const.  Use to_wc.
	(lock): Removed.
	(__libc_setlocale_lock): New extern.
	(__wcsmbs_load_conv): Remove const from argument.
	Initialize new_category->private.ctype instead of a global
	variable.
	(__wcsmbs_clone_conv): Use get_gconv_fcts instead of
	update_function_ptrs.  No locking is necessary.
	(_nl_cleanup_ctype): New function.
	* wcsmbs/btowc.c (__btowc): Use get_gconv_fcts instead of
	update_function_ptrs and a global __wcsmbs_gconv_fcts variable.
	* wcsmbs/mbrtowc.c (__mbrtowc): Likewise.
	* wcsmbs/mbsnrtowcs.c (__mbsnrtowcs): Likewise.
	* wcsmbs/wcrtomb.c (__wcrtomb): Likewise.
	* wcsmbs/wcsnrtombs.c (__wcsnrtombs): Likewise.
	* wcsmbs/wcsrtombs.c (__wcsrtombs): Likewise.
	* wcsmbs/wctob.c (wctob): Likewise.
	* stdlib/mblen.c (mblen): Likewise.
	* stdlib/mbtowc.c (mbtowc): Likewise.
	* stdlib/wctomb.c (wctomb): Likewise.
	* wcsmbs/mbsrtowcs.c (__mbsrtowcs): Likewise.
	Remove calls to wcsmbs_get_towc_func and wcsmbs_free_funcs.
	* wcsmbs/mbsrtowcs_l.c (wcsmbs_get_towc_func, wcsmbs_free_funcs):
	Removed.

2002-09-02  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/Versions (ld: GLIBC_2.0): Add __fxstat64.

2002-09-01  Roland McGrath  <roland@redhat.com>

	* ctype/ctype.h (__ctype_b, __ctype_toupper, __ctype_tolower):
	Variable declarations removed.
	(__ctype_b_loc, __ctype_toupper_loc, __ctype_tolower_loc): Declare
	these functions to replace them.
	(__isctype, tolower, toupper, _tolower, _toupper): Use those accessor
	functions plus an indirection rather than the old global variables.
	* include/ctype.h (__isctype, tolower, _tolower, toupper, _toupper):
	Macros removed.
	(__ctype_b_loc, __ctype_toupper_loc, __ctype_tolower_loc): New extern
	inline functions.
	* ctype/ctype-info.c: Revert last reversion back the other way.
	Define tsd vars CTYPE_B, CTYPE_TOLOWER, CTYPE_TOUPPER.
	Define real function versions of include/ctype.h inlines here.
	* ctype/Versions (libc: GLIBC_2.3): Add __ctype_b_loc,
	__ctype_tolower_loc, __ctype_toupper_loc.
	* locale/lc-ctype.c: Revert last reversion back the other way.
	(_nl_postload_ctype): If current thread uses the global locale,
	update its tsd vars.
	* locale/uselocale.c (__uselocale): Update tsd vars from new locale.
	* hurd/hurd/threadvar.h (enum __hurd_threadvar_index): Add CTYPE_B,
	CTYPE_TOLOWER, CTYPE_TOUPPER.

	* sysdeps/generic/bits/libc-tsd.h (__libc_tsd_address): New macro.
	* sysdeps/mach/hurd/bits/libc-tsd.h (__libc_tsd_address): Renamed
	from __libc_tsd_threadvar_location.
	(__libc_tsd_set, __libc_tsd_get): Update uses.

2002-09-01  Ulrich Drepper  <drepper@redhat.com>

	* ctype/ctype.h: Undo the patch before the last one.  Put back the
	macro definitions for the standard functions to access the
	classification and mapping arrays.
	* include/ctype.h: Partly revert last patch.  Move the macro
	definitions for the exported functions back to the public header.
	#undef all the macros defined here before redefining.
	* ctype/ctype-info.c: Revert last patch.
	* locale/lc-ctype.c: Revert last patch.

	* ctype/Makefile (routines): Add isctype.
	* ctype/Versions (libc): Export isctype and __isctype for GLIBC_2.3.
	* ctype/ctype.h: Add declaration of isctype.
	* include/ctype.h: Declare __isctype.
	* ctype/isctype.c: New file.

2002-09-01  Roland McGrath  <roland@redhat.com>

	* sysdeps/generic/libc-tls.c (__pthread_initialize_minimal): Pass
	TLS_INIT_TCB_SIZE, TLS_INIT_TCB_ALIGN instead of 0, 1.

	* include/getopt.h: Include <features.h> before <posix/getopt.h>.

	* locale/findlocale.c (_nl_remove_locale): Don't search in
	_nl_locale_file_list if DATA->alloc is ld_archive.
	Use _nl_unload_locale to do the rest of the work.

	* locale/loadarchive.c (_nl_load_locale_from_archive): Set usage_count
	of new structure to UNDELETABLE.

	* wctype/wctype.h (iswalnum, iswalpha, iswcntrl, iswdigit, iswlower,
	iswgraph, iswprint, iswpunct, iswspace, iswupper, iswxdigit, iswblank,
	towlower, towupper): Macros removed.
	* ctype/ctype.h (__tobody): Put parens around macro argument.
	(__isctype): Macro removed.
	(__ctype_b, __ctype_tolower, __ctype_toupper): Decls removed.
	(isalnum, isalpha, iscntrl, isdigit, islower, isgraph, isprint,
	ispunct, isspace, isupper, isxdigit, isblank, _tolower, _toupper,
	tolower, toupper): Macros and inlines removed.
	* include/ctype.h [! NOT_IN_libc]
	(isalnum, isalpha, iscntrl, isdigit, islower, isgraph, isprint,
	ispunct, isspace, isupper, isxdigit, isblank, _tolower, _toupper,
	tolower, toupper): Define here instead, using _NL_CURRENT.
	* ctype/ctype.c (__ctype_tolower, __ctype_toupper): Define as macros
	using _NL_CURRENT.
	* ctype/ctype-extn.c (__ctype_tolower, __ctype_toupper): Likewise.
	* ctype/ctype-info.c (__ctype_b, __ctype_tolower, __ctype_toupper):
	Renamed these to __ctype_old_*. Define old names only for SHLIB_COMPAT.
	(__ctype32_b, __ctype32_tolower, __ctype32_toupper): Likewise.
	(__ctype32_wctrans, __ctype32_wctrans, __ctype32_width): Removed.
	* locale/lc-ctype.c (_nl_postload_ctype): Use renamed variables,
	conditional on SHLIB_COMPAT.  Don't set removed variables at all.
	* wctype/wcfuncs.c: Use _NL_CURRENT instead of those globals.
	* wcsmbs/wcwidth.h (internal_wcwidth): Likewise.
	* resolv/res_init.c [RESOLVSORT] (sort_mask): Renamed sort_mask_chars.
	(ISSORTMASK): Update use.
	* intl/localealias.c [__GNUC__]: #undef alloca before #define.
	* nss/nss_files/files-XXX.c (last_use): Rename `none' to `nouse'.
	(_nss_files_getENTNAME_r): Likewise.
	* nss/nss_files/files-alias.c (last_use, _nss_files_getaliasent_r):
	Likewise.

	* Makerules (all-nonlib): Renamed from all-tests.
	Include $(others) here too.
	* locale/Makefile (CPPFLAGS-locale, CPPFLAGS-localedef,
	CPPFLAGS-ld-ctype, CPPFLAGS-ld-time, CPPFLAGS-ld-numeric,
	CPPFLAGS-ld-monetary, CPPFLAGS-ld-collate, CPPFLAGS-ld-identification,
	CPPFLAGS-charmap, CPPFLAGS-locarchive, CPPFLAGS-linereader,
	CPPFLAGS-charmap-dir): Variables removed.  Instead, catch all
	the program modules via cppflags-iterator.mk.
	* sunrpc/Makefile (CPPFLAGS-rpc_main): Variable removed.
	Instead, catch all rpcgen-objs via cppflags-iterator.mk.

2002-08-31  Roland McGrath  <roland@redhat.com>

	* posix/tst-getconf.sh: If no third arg, work with static linking.

	* locale/categories.def (LC_TIME): No more _nl_postload_time.

	* locale/setlocale.c (_nl_category_postload): Use weak refs only under
	[_NL_CURRENT_INDIRECT].

2002-08-31  Ulrich Drepper  <drepper@redhat.com>

	* time/tst-ftime_l.c (main): Also test strftime with uselocale.

2002-08-31  Roland McGrath  <roland@redhat.com>

	* locale/newlocale.c (__newlocale): Don't use strdup for names.
	Instead, make the single allocation of the structure larger to hold
	the name strings.
	* locale/duplocale.c (__duplocale): Don't strdup names individually.
	Instead, calculate size for a single allocation and copy into it.
	* locale/freelocale.c (__freelocale): Don't free names individually.

	* locale/newlocale.c (__newlocale): Don't leak old data or names.

	* locale/xlocale.h (__locale_struct): Move __names member last,
	for binary compatibility.

	* locale/duplocale.c (__duplocale): Free names from the right array.

	* locale/uselocale.c (__uselocale): Return previous locale when
	setting a new one.

	* locale/newlocale.c: Commit changes from 2002-08-30
	batch where I failed to commit this file:
	(__newlocale): Fill in __names array.

2002-08-31  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/gnu/Makefile: Only depend on Versions.v.i for
	errlist-compat.c if versioning==yes.

2002-08-31  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/dl-machine.h (elf_machine_runtime_setup): Declare
	external functions with hidden attribute.
	(elf_machine_rela): Optimize.

	* sysdeps/x86_64/memset.S: New file.
	* sysdeps/x86_64/bzero.S: New file.
	* sysdeps/x86_64/stpcpy.S: New file.
	* sysdeps/x86_64/strcat.S: New file.
	* sysdeps/x86_64/strchr.S: New file.
	* sysdeps/x86_64/strcpy.S: New file.
	* sysdeps/x86_64/strcspn.S: New file.
	* sysdeps/x86_64/strlen.S: New file.
	* sysdeps/x86_64/strpbrk.S: New file.
	* sysdeps/x86_64/strspn.S: New file.
	* sysdeps/x86_64/strcmp.S: New file.
	* sysdeps/x86_64/strtok_r.S: New file.
	* sysdeps/x86_64/strtok.S: New file.
	* sysdeps/x86_64/memcpy.S: New file.
	* sysdeps/x86_64/mempcpy.S: New file.

	* sysdeps/x86_64/fpu/s_copysign.S: Fix algorithm.

	* sysdeps/x86_64/fpu/libm-test-ulps: Add ulps for double tests.

2002-08-31  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/Makefile (generated): Add errlist-compat.c.

	* locale/Makefile (extra-objs): Add $(localedef-aux:=.o).

	* locale/localeinfo.h: Pretty printing.

	* stdio-common/vfprintf.c (vfprintf): Remove duplicate ifs in
	form_number handling.

2002-08-31  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/fpu/libm-test-ulps: Add ulps for float and long
	double tests.

	* sysdeps/unix/sysv/linux/x86_64/Makefile (sysdep_routines): Add
	__start_context.

	* sysdeps/unix/sysv/linux/x86_64/__start_context.S: New file.

	* sysdeps/unix/sysv/linux/x86_64/makecontext.c: New file.

	* sysdeps/unix/sysv/linux/x86_64/ucontext_i.h: Add defines for
	registers used for passing args.

	* sysdeps/unix/sysv/linux/x86_64/swapcontext.S: Save and restore
	all needed registers.

	* sysdeps/unix/sysv/linux/x86_64/setcontext.S: Restore all
	registers.

	* sysdeps/unix/sysv/linux/x86_64/getcontext.S: Save all needed
	registers.

2002-08-30  Ulrich Drepper  <drepper@redhat.com>

	* elf/dynamic-link.h (elf_get_dynamic_info): Mark with
	always_inline attribute.

2002-08-30  Roland McGrath  <roland@redhat.com>

	* stdlib/tst-setcontext.c (main): If makecontext does nothing,
	presume it's the stub and bail without error.

	* nss/getnssent_r.c (__nss_getent_r): Return ENOENT if status is
	neither SUCCESS nor TRYAGAIN (see 2002-08-25 change [PR libc/4259]).

	* nss/getnssent_r.c (__nss_getent_r): Set *H_ERRNOP, not global one.

	* sysdeps/x86_64/hp-timing.h (HP_TIMING_NOW, HP_TIMING_ACCUM): New
	macros replace the i686 versions for 64-bit mode.

	* locale/duplocale.c: Include <string.h>.

	* intl/dcigettext.c (DCIGETTEXT) [_LIBC]: Check for bogus CATEGORY.
	[_LIBC] (category_to_name): Don't define the function.  Instead
	define a macro using _nl_category_names.

	* locale/xlocale.h (struct __locale_struct): New member `__names'.
	* locale/xlocale.c (_nl_C_locobj): Update initializer.
	* locale/global-locale.c (_nl_global_locale): Likewise.
	* locale/duplocale.c (__duplocale): strdup __names elements.
	* locale/freelocale.c (__freelocale): Free __names elements.
	* locale/localename.c (_nl_current_names): Variable removed.
	(__current_locale_name): Use _NL_CURRENT_LOCALE->__names instead.
	* locale/localeinfo.h (_nl_current_names): Removed decl.
	* locale/setlocale.c: Use _nl_global_locale->__names in place of
	_nl_current_names throughout.

	* locale/setlocale.c (setlocale): strdup -> __strdup (not ISO C).

	* sysdeps/gnu/errlist-compat.awk: Emit link_warnings for sys_errlist
	and sys_nerr in the output file.

	* sunrpc/Makefile (rpcgen-cmd): Pass CPP in rpcgen's environment.
	* scripts/cpp: Just use the environment variable.

	* libio/tst-mmap-setvbuf.c (main): Use 'm' fopen flag.
	* libio/tst-mmap-offend.c (do_test): Likewise.
	* libio/tst-mmap-fflushsync.c (do_test): Likewise.
	* libio/tst-mmap-eofsync.c (do_test): Likewise.
	* libio/tst-mmap2-eofsync.c (do_test): Likewise.

	* locale/localename.c: If the current locale is the global locale, use
	_nl_current_names; otherwise use the locale object.

2002-08-29  Ulrich Drepper  <drepper@redhat.com>

	* libio/fileops.c (_IO_new_file_fopen): Recognize new mode specifier
	'm' to enable mmap I/O.
	* libio/libio.h (_IO_FILE): Rename _blksize field to _flags2.  The
	former wasn't used (anymore?).
	(_IO_FLAGS2_MMAP): New define.
	* libio/genops.c (_IO_no_init): Initialize _flags2 field.
	* libio/iofopen.c (__fopen_maybe_mmap): Use mmap callbacks only if
	_IO_FLAGS2_MMAP bit is set.
	* libio/iofdopen.c (_IO_new_fdopen): Recognize 'm' mode specifier.
	Enable mmap-using mode only if 'm' was set.

2002-08-29  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/bits/local_lim.h (NAME_MAX): New macro.

	* sysdeps/mach/hurd/i386/init-first.c (_hurd_stack_setup: doinit):
	Change argument type from int to intptr_t.

	* locale/global-locale.c (__libc_tsd_LOCALE_data): Conditionalize the
	initializer on [! _HURD_THREADVAR_H] (bad kludge).
	* sysdeps/mach/hurd/i386/init-first.c (init): Initialize
	_HURD_THREADVAR_LOCALE slot to &_nl_global_locale.
	* hurd/hurdsig.c (_hurdsig_init): Likewise.  Zero other slots.

	* sysdeps/mach/_strerror.c (__strerror_r): Add libc_hidden_def.

	* sysdeps/mach/hurd/pwrite64.c: No libc_hidden_def (__libc_pwrite64).

	* sysdeps/mach/hurd/dl-sysdep.c (__GI_abort): Define alias for abort.

	* include/assert.h (__assert_perror_fail): Declare it, do hidden_proto.
	* assert/assert-perr.c: Add libc_hidden_def.
	* elf/dl-minimal.c [! NDEBUG] (__assert_perror_fail): New function.

	* sysdeps/gnu/errlist-compat.awk: Don't fail if there are no versions
	found at all.
	* sysdeps/gnu/Versions: File removed.  Moved all #errlist-compat
	sys_errlist stuff to ...
	* sysdeps/unix/sysv/linux/Versions: ... here.

	* mach/mach.h: Include <features.h>.

2002-08-29  Roland McGrath  <roland@redhat.com>

	* elf/dl-runtime.c (IN_DL_RUNTIME): Define this macro first thing.
	* sysdeps/i386/dl-machine.h: Only declare fixup, profile_fixup and
	define ELF_MACHINE_RUNTIME_TRAMPOLINE under #ifdef IN_DL_RUNTIME.

	* sysdeps/generic/readelflib.c (process_elf_file): Fix typo.

	* iconv/gconv_int.h: Include <stdlib.h> for alloca decl.
	(norm_add_slashes): alloca -> __alloca

2002-08-29  Jakub Jelinek  <jakub@redhat.com>

	* stdio-common/vfprintf.c (vfprintf): Add builtin_expect for
	string_malloced, it is unlikely to be set.
	Only call free with non-NULL workspace.
	* sysdeps/sparc/sparc32/sparcv9/Makefile (sysdep-CFLAGS): Use
	-mcpu=ultrasparc, not only tune for it.
	(ASFLAGS*): Set unconditionally.

	* sysdeps/generic/readelflib.c (process_elf_file): Make LOADADDR
	ElfW(Addr).  Don't mask upper 32-bits and lower 12 bits off from
	p_vaddr/p_offset when computing LOADADDR.

2002-08-29  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.2.92.

	* time/Makefile (tst-ftime_l-ENV): New variable.

	* iconvdata/ibm870.c: All bytes are now used, no holes anymore.

	* localedata/charmaps/IBM870: Add correct mapping for <U017E>,
	<U017A>, <U017D> and <U0179>. Add missing mappings.
	Patch by Antonin Kopecky <akopecky@tajmac-zps.cz>.

	* gmon/sys/gmon.h (ARCDENSITY): Bump to 3.
	Define ARCINDEX.  Bump MAXARCS to 1 << 20.
	(struct tostruct): Use ACRINDEX as type for link field.
	(statuc gmonparam): Likewise for froms.
	* gmon/gmon.c (__monstartup): Use currect cast for assignments to
	kcount and froms.
	(write_call_graph): Use correct type for from_index and to_index.
	* gmon/mcount.c: Use correct types for frompcindex and toindex
	variables.
	Patches by Dan Kegel <dank@kegel.com>.

	* sysdeps/posix/getaddrinfo.c (gaih_inet): Fix code to determine
	canonical name.

	* time/strptime.c (ISSPACE): New #define.  Use isspace or
	__isspace_l.  Replace calls to isspace.
	(match_string): Define variant for USE_IN_EXTENDED_LOCALE_MODEL.

2002-08-29  Roland McGrath  <roland@redhat.com>

	* string/tst-strxfrm.c: Remove __ from function names.

2002-08-28  Ulrich Drepper  <drepper@redhat.com>

	* include/wchar.h: Declare __mbsrtowcs_l.
	* wcsmbs/Makefile (routines): Add mbsrtowcs_l.
	* wcsmbs/mbsrtowcs.c: Add support for compilation with
	USE_IN_EXTENDED_LOCALE_MODEL.
	* wcsmbs/mbsrtowcs_l: New file.
	* wcsmbs/wcsmbsload.c (__wcsmbs_to_wc): Renamed from to_wc.  Don't
	define as static.  Change all uses.
	(__wcsmbs_getfct): Renamed from getfct.  Don't define as static.
	Change all callers.
	* wcsmbs/wcsmbsload.h: Declare __wcsmbs_to_wc and __wcsmbs_getfct.
	* time/strftime.c: When translating for the extended locale model
	use the _l functions.
	* time/Makefile (tests): Add tst-ftime_l.
	* time/tst-ftime_l.c: New file.

2002-08-28  Roland McGrath  <roland@redhat.com>

	* locale/findlocale.c [NL_CURRENT_INDIRECT] (_nl_C): New variable.
	* locale/setlocale.c (setlocale) [NL_CURRENT_INDIRECT]: Null return
	from _nl_find_locale ok if for _nl_C_name.

	* locale/nl_langinfo.c [NL_CURRENT_INDIRECT]: Use a categories.def
	iterator to refer to each category's _nl_current_LC_FOO symbol, so
	we know they are all linked in.

	* NEWS: Added 2.2.6 text from 2.2 branch version.

	* time/strptime.c (strptime_internal): Remove spurious const.

	* locale/lc-time.c (_nl_init_era_entries, _nl_get_era_entry,
	_nl_select_era_entry): Moved to ...
	* time/era.c: ... here, new file.
	(_nl_init_era_entries, _nl_get_era_entry, _nl_select_era_entry):
	Add internal_function to definitions.  Take an additional argument
	giving the `struct locale_data *' to use.
	* locale/lc-time.c (_get_alt_digit, _nl_get_walt_digit,
	_nl_parse_alt_digit): Moved to ...
	* time/alt_digit.c: ... here, new file.
	* time/lc-time-cleanup.c: New file.
	* locale/lc-time.c (_nl_postload_time, free_mem): Functions removed.
	* locale/localeinfo.h (_nl_postload_time): Remove decl.
	(_nl_cleanup_time): Declare it.
	(_nl_get_era_entry, _nl_select_era_entry): Update decls.
	(_get_alt_digit, _nl_get_walt_digit, _nl_parse_alt_digit): Likewise.
	* time/Makefile (aux): New variable: era, alt_digit, lc-time-cleanup.
	* time/strftime.c: Pass locale data to helper functions.
	* time/strptime.c: Likewise.

	* locale/localeinfo.h (struct locale_data): New member `private'
	* locale/loadlocale.c (_nl_intern_locale_data): Initialize it.
	(_nl_unload_locale): Call LOCALE->private.cleanup if it is set.
	* locale/C-collate.c: Update initializer.
	* locale/C-identification.c: Likewise.
	* locale/C-measurement.c: Likewise.
	* locale/C-telephone.c: Likewise.
	* locale/C-address.c: Likewise.
	* locale/C-name.c: Likewise.
	* locale/C-paper.c: Likewise.
	* locale/C-time.c: Likewise.
	* locale/C-numeric.c: Likewise.
	* locale/C-monetary.c: Likewise.
	* locale/C-messages.c : Likewise.
	* locale/C-ctype.c: Likewise.

	* time/strptime.c [USE_IN_EXTENDED_LOCALE_MODEL] (_NL_CURRENT_WORD):
	Redefine this too.

2002-08-28  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/ldsodefs.h (__rtld_global_attribute__): Define.
	(_rtld_global): Use it.

	* sysdeps/gnu/Dist: Remove errlist-compat.c.
	* sysdeps/gnu/Makefile (errlist-compat.c): Build this file in the
	object directory.  Pass all Versions files to the awk script.
	* sysdeps/gnu/errlist-compat.c: Removed.
	* sysdeps/gnu/errlist.awk: Use #errlist-compat comments from the
	first Versions file in the search path which has them.
	Allow multiple errlist symbol versions to have the same count of
	errors.
	* sysdeps/gnu/errlist-compat.awk: Include <errlist-compat.c> instead
	of "errlist-compat.c".
	* sysdeps/gnu/errlist.c: Regenerated.
	* sysdeps/unix/sysv/linux/mips/Versions (libc): Add #errlist-compat
	comments at GLIBC_2.0, GLIBC_2.1 and GLIBC_2.3.
	* sysdeps/unix/sysv/linux/alpha/Versions: Likewise.
	(librt): Add aio_cancel and aio_cancel64 as GLIBC_2.3.
	* sysdeps/unix/sysv/linux/hppa/Versions: Likewise.
	* sysdeps/unix/sysv/linux/sparc/Versions: New file.
	* sysdeps/unix/sysv/linux/alpha/bits/errno.h: New file.
	* sysdeps/unix/sysv/linux/hppa/bits/errno.h (ECANCELED): Define to
	ECANCELLED if not defined by kernel headers.
	* sysdeps/unix/sysv/linux/bits/errno.h: Don't redefine ECANCELED if
	already defined by kernel headers.
	* sysdeps/unix/sysv/linux/sparc/bits/errno.h: New file.
	* sysdeps/pthread/aio_cancel.c: Don't include aio.h and its
	aio_cancel64 renaming hack nor provide weak_alias if aio_cancel
	is a macro.
	* Versions.def (GLIBC_2.3) [librt]: Add.

	* sysdeps/unix/sysv/linux/alpha/pipe.S: New file.

2002-08-28  Ulrich Drepper  <drepper@redhat.com>

	* include/libc-symbols.h [!__ASSEMBLER__] (declare_symbol_1): Add
	missing comma to .type directive.

2002-08-28  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ia64/elf/configure.in (PI_STATIC_AND_HIDDEN): Define
	unconditionally.
	* sysdeps/alpha/elf/configure.in (libc_cv_alpha_hidden_gprel): New
	check.
	(PI_STATIC_AND_HIDDEN): Define if check succeeded.

2002-08-28  Jakub Jelinek  <jakub@redhat.com>

	* locale/loadarchive.c (_nl_load_locale_from_archive): Add fd >= 0
	check to close_and_out close.  Replace return NULL statements where
	fd might be >= 0 with goto close_and_out.  Close the file descriptor
	when it is no longer needed.

2002-08-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/s390/s390-64/dl-machine.h: Avoid unescaped newlines in
	string constants.
	* sysdeps/sparc/sparc32/dl-machine.h: Likewise.
	* sysdeps/arm/dl-machine.h: Likewise.
	* sysdeps/cris/dl-machine.h: Likewise.
	* sysdeps/unix/sysv/linux/m68k/register-dump.h: Likewise.
	* sysdeps/unix/sysv/aix/gettimeofday.c: Likewise.

2002-08-28  Roland McGrath  <roland@redhat.com>

	* Makeconfig (default_cflags): Revert unintended change.

2002-08-28  Ulrich Drepper  <drepper@redhat.com>

	* version.h (VERSION): Bump to 2.2.91.

	* configure.in: Disable TLS support by default for now.

	* sysdeps/i386/fpu/libm-test-ulps: Adjust ulp for yn for float.

	* sysdeps/generic/strtol.c (strtol): Add some more casts to avoid
	warnings.

	* stdlib/strtod.c (STRTOF): Correct type in cast of last patch.

	* stdlib/fmtmsg.c (fmtmsg): Use correct test for failure of
	fprintf/fwprintf calls.

2002-08-28  Roland McGrath  <roland@redhat.com>

	* Makeconfig (run-program-prefix): Fix bogus use of $(findstring ...)
	to use $(filter ...) instead.  Same bug fixed in aix conditionals.

	* locale/setlocale.c: Declare postload functions weak.

	* elf/tst-tls1-static.c: New file.
	* elf/tst-tls2-static.c: New file.
	* elf/Makefile ($(tests-static):%=$(objfpx)%.o): Remove rule.

	Make uselocale support static linking.
	* locale/xlocale.c: Revert changes putting _nl_global_locale here.
	This file again just defines _nl_C_locobj.
	(_nl_C_locobj): Use a categories.def iterator in the initializer.
	* locale/global-locale.c: New file.  Define _nl_global_locale here,
	using all weak references in the initializer.
	* locale/Makefile (aux): Add global-locale.
	* locale/localeinfo.h (_nl_global_locale, _NL_CURRENT_LOCALE): Make
	these unconditional, along with the tsd decl.
	[!SHARED && HAVE___THREAD && HAVE_WEAK_SYMBOLS] (NL_CURRENT_INDIRECT):
	Define it under these conditions.
	[NL_CURRENT_INDIRECT]: Test this instead of [! SHARED].
	Don't declare _nl_current.  Declare _nl_current_LC_FOO as
	`extern __thread struct locale_data *const *'.
	[NL_CURRENT_INDIRECT]
	(_NL_CURRENT_DATA, _NL_CURRENT, _NL_CURRENT_WSTR): Add indirection.
	[NL_CURRENT_INDIRECT] (_NL_CURRENT_DEFINE): Rewritten.  Define
	the thread variable _nl_current_LC_FOO and also a special absolute
	symbol _nl_current_LC_FOO_used.
	* locale/uselocale.c (__uselocale) [NL_CURRENT_INDIRECT]:
	Set each _nl_current_LC_FOO symbol to point into the new locale,
	using weak references to test if _nl_current_LC_FOO_used was linked in.
	* locale/setlocale.c [! SHARED]: Replace this conditional ...
	[NL_CURRENT_INDIRECT]: ... with this one.
	(_nl_current, _nl_C): Variables removed.
	[NL_CURRENT_INDIRECT] (_nl_current_used): New variable, table of
	weak references to _nl_current_LC_FOO_used.
	[NL_CURRENT_INDIRECT] (CATEGORY_USED): Define using that table.
	(free_category): New function, broken out of ...
	(free_mem): ... here.  Call that.
	(free_mem) [NL_CURRENT_INDIRECT]: Use a categories.def iterator
	instead of a loop.

	* sysdeps/generic/libc-tls.c (__libc_setup_tls): Don't check for
	PT_LOAD program headers and don't try to relocate PT_TLS's p_vaddr;
	it is already absolute.

	* elf/Makefile (tests): List tst-tls1 and tst-tls2 unconditionally.
	[$(build-static) = yes] (tests): Add tst-tls1-static, tst-tls2-static.
	[$(build-static) = yes] (tests-static): New variable.
	($(tests-static):%=$(objfpx)%.o)): New static pattern rule.

2002-08-26  Christoph Hellwig  <hch@lst.de>

	* sysdeps/unix/sysv/linux/sys/personality.h: Remark origin, fix
	formating braindamage, add missing PER_HPUX and PER_OSF1 values.

2002-08-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/Dist: Add _mcount.S and bits/link.h.

	* sysdeps/s390/Dist: Add bits/link.h.

	* sysdeps/sh/Dist: New file.

	* sysdeps/ia64/Dist: Add ia64libgcc.S.

	* sysdeps/wordsize-32/Dist: New file.

	* sysdeps/unix/sysv/linux/alpha/Dist: Add dl-brk.S.
	* sysdeps/unix/sysv/linux/powerpc/Dist: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/Dist: Likewise.

	* sysdeps/unix/sysv/linux/Dist: Add dl-brk.c, dl-sbrk.c, and
	sys/personality.h.

	* sysdeps/unix/Dist: Add i386/dl-brk.S, mips/dl-brk.S, and
	sparc/dl-brk.S.

	* sysdeps/unix/bsd/Dist: Add vax/dl-brk.S.

	* sysdeps/unix/bsd/sun/Dist: New file.

	* sysdeps/unix/bsd/osf/Dist: New file.

	* sysdeps/unix/bsd/hp/Dist: New file.

	* sysdeps/unix/arm/Dist: New file.

	* sysdeps/powerpc/Dist: Add divdi3.c and libgcc-compat.S.

	* sysdeps/mach/hurd/Dist: Add set-init.c.

	* sysdeps/i386/Dist: Add bits/link.h.

	* sysdeps/gnu/Dist: Add errlist-compat.c errlist-compat.awk.

	* sysdeps/generic/Dist: Add dl-brk.c and dl-sbrk.c.

	* locale/Makefile (distribute): Add hashval.h.

	* iconvdata/Makefile (distribute): Add tcvn5712-1.c and armscii-8.c.

	* sysdeps/unix/sysv/linux/Dist: Remove errlist.h.

	* misc/sys/cdefs.h: Define __BEGIN_NAMESPACE_STD, __END_NAMESPACE_STD,
	__USING_NAMESPACE_STD, __BEGIN_NAMESPACE_C99, __END_NAMESPACE_C99, and
	__USING_NAMESPACE_C99 depending on _GLIBCPP_USE_NAMESPACES.
	* ctype/ctype.h: Prepare headers for use in ISO C++ compliant
	implementations.
	* libio/stdio.h: Likewise.
	* locale/locale.h: Likewise.
	* math/math.h: Likewise.
	* math/bits/mathcalls.h: Likewise.
	* setjmp/setjmp.h: Likewise.
	* signal/signal.h: Likewise.
	* stdlib/stdlib.h: Likewise.
	* string/string.h: Likewise.
	* time/time.h: Likewise.
	* wcsmbs/wchar.h: Likewise.
	* wctype/wctype.h: Likewise.

2002-08-28  Roland McGrath  <roland@redhat.com>

	* locale/tst-C-locale.c (run_test): Remove __ from function names.

2002-08-28  Jakub Jelinek  <jakub@redhat.com>
	    Roland McGrath <roland@redhat.com>

	* locale/hashval.h (compute_hashval): Use prototype defn.
	(hashval_t): New macro, defined to unsigned long int
	if not already defined.
	(compute_hashval): Return hashval_t instead of unsigned long int.
	* locale/loadarchive.c (hashval_t): New macro.
	* locale/programs/locarchive.c: Include hashval.h directly instead
	of simple-hash.h.
	(compute_hashval, hashval_t): Define these macros first.
	(insert_name): Use archive_hashval instead of compute_hashval.
	(add_locale, delete_locales_from_archive): Likewise.

2002-08-28  Jakub Jelinek  <jakub@redhat.com>

	* locale/programs/locarchive.c (insert_name): Suppress warnings about
	hash collisions if be_quiet.

2002-08-27  Roland McGrath  <roland@redhat.com>

	* locale/locale.h (__newlocale, __duplocale, __freelocale,
	__uselocale): Don't declare these any more.
	* include/locale.h (__uselocale): Declare here instead, using __typeof.

	* sysdeps/unix/readdir.c: If getdents fails with ENOENT, restore errno
	and treat it as an EOF return.
	* sysdeps/unix/readdir_r.c: Likewise.

	* sysdeps/gnu/errlist-compat.awk: Include <bits/wordsize.h> in output.
	From Alexandre Oliva <aoliva@redhat.com>.
	* sysdeps/gnu/errlist-compat.c: Regenerated.

2002-08-27  Brian Youmans  <3diff@gnu.org>

	* sysdeps/ieee754/flt-32/e_asinf.c: Modified copying permission
	wording at request of copyright holder Stephen Moshier.
	* sysdeps/ieee754/ldbl-128/e_acosl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_asinl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_coshl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_jnl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_powl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_sinhl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/k_tanl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/s_erfl.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_asinl.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_j0l.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_j1l.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_jnl.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_lgammal_r.c: Likewise.
	* sysdeps/ieee754/ldbl-96/s_erfl.c: Likewise.

2002-08-28  Jakub Jelinek  <jakub@redhat.com>

	* ctype/ctype.h (isascii_l, toascii_l): Define to __*_l counterparts.
	* ctype/ctype-extn.c (isblank_l): Add weak alias.
	* sysdeps/generic/strtol_l.c (strtol_l): Likewise.
	* sysdeps/generic/strtoll_l.c (strtoll_l): Likewise.
	* sysdeps/generic/strtoul_l.c (strtoul_l): Likewise.
	* sysdeps/generic/strtoull_l.c (strtoull_l): Likewise.
	* wctype/iswctype_l.c (iswctype_l): Likewise.

2002-08-27  Roland McGrath  <roland@redhat.com>

	* time/strftime.c [USE_IN_EXTENDED_LOCALE_MODEL]: No libc_hidden_def.

	* ctype/ctype.h (__exctype_l): Don't declare __ name.
	* stdlib/stdlib.h: Don't declare __*_l names.
	* include/stdlib.h: Declare them here instead.
	* include/string.h: Don't declare __*_l names.
	* string/string.h: Declare them here instead.
	* time/time.h: Don't declare __*_l names.
	* include/time.h: Declare them here instead.
	* wcsmbs/wchar.h: Don't declare __*_l names.
	* include/wchar.h: Declare them here instead.
	* wctype/wctype.h: Declare iswalnum_l, not __iswalnum_l.
	Don't declare __*_l names.
	* include/wctype.h: Declare them here instead.
	* stdlib/monetary.h: Declare strfmon_l, not __strfmon_l.
	* stdlib/strfmon_l.c (strfmon_l): Define as weak alias.
	* locale/langinfo.h: Don't declare __nl_langinfo_l.
	* include/langinfo.h: Declare it here with __typeof.

	* time/strptime.c [USE_IN_EXTENDED_LOCALE_MODEL]: Define __strptime_l
	instead, taking an extra __locale_t argument.
	* time/Makefile (routines): Add strptime_l.
	* time/time.h (__strptime_l, strptime_l): Declare them.
	* time/strptime_l.c: New file.

	* time/time.h (__strftime_l, strftime_l): Declare them.
	* wcsmbs/wchar.h (__wcsftime_l, wcsftime_l): Declare them.
	* time/strftime_l.c: New file.
	* time/wcsftime_l.c: New file.
	* time/Makefile (routines): Add strftime_l, wcsftime_l.
	* time/Versions (libc: GLIBC_2.3): Add __strftime_l, __wcsftime_l,
	strftime_l, wcsftime_l.
	* time/strftime.c [USE_IN_EXTENDED_LOCALE_MODEL]: Define __strftime_l
	or __wcsftime_l instead, taking an extra __locale_t argument.

	* locale/Versions (libc: GLIBC_PRIVATE): Move __uselocale to ...
	(libc: GLIBC_2.3): ... here.

2002-08-27  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/Makefile: Fix typo in stdio_lim.h installation rule.

	* Makefile (distribute): Add LICENSES.

	* sysdeps/unix/sysv/linux/x86_64/Dist: Add ucontext_i.h and
	sys/debugreg.h.

	* sysdeps/unix/sysv/linux/s390/Dist: Add new/route.h.

	* sysdeps/unix/sysv/linux/ia64/Dist: Add dl-brk.S and sys/user.h.

	* sysdeps/unix/sysv/linux/mips/Dist: Add sys/user.h.

	* sysdeps/unix/sysv/linux/Dist: Add readahead.c.

	* sysdeps/mach/hurd/alpha/Dist: New file.

	* sysdeps/arm/Dist: Add bits/link.h.

	* sunrpc/Makefile: Distribute thrsvc.

	* stdio-common/Makefile: Remove more left-overs from old stdio.

	* include/linewrap.h: Removed.

	* libio/bug-mmap-fflush.c: Rewrite to not touch source directory.

	* intl/Makefile (distribute): Add plural-eval.c.

2002-08-27  Roland McGrath  <roland@redhat.com>

	* manual/sysinfo.texi (Mount Information): Correct file name to macro
	assocations for _PATH_MNTTAB, MNTTAB, _PATH_MOUNTED, MOUNTED.
	Say mtab is in either /var/run or /etc.

2002-08-26  Roland McGrath  <roland@redhat.com>

	* manual/errno.texi (Error Codes): Added ECANCELED (118 for Hurd).
	* sysdeps/mach/hurd/bits/errno.h: Regenerated.

	* sysdeps/gnu/Versions: New file.
	* sysdeps/unix/sysv/linux/Versions (libc: GLIBC_2.1): Remove
	_sys_errlist; sys_errlist; _sys_nerr; sys_nerr; from here.
	* sysdeps/gnu/Makefile ($(..)sysdeps/gnu/errlist-compat.c): New target.
	($(objpfx)errlist.d): Depend on $(..)sysdeps/gnu/errlist-compat.c.
	* sysdeps/gnu/errlist.awk: Make output define _sys_errlist_internal
	and _sys_nerr_internal instead of anything else.  Make it include
	"errlist-compat.c" if [!NOT_IN_libc && !ERRLIST_NO_COMPAT].
	Make it emit some asm magic if [EMIT_ERR_MAX].
	* sysdeps/gnu/errlist.c: Regenerated.
	* sysdeps/gnu/errlist-compat.awk: New file.
	* sysdeps/gnu/errlist-compat.c: New file (generated).
	* sysdeps/mach/hurd/errlist.c (ERRLIST_NO_COMPAT): New macro.
	(_sys_errlist_internal): Define this as	a macro for _hurd_errlist.
	(_sys_nerr_internal): Define this is a macro for _hurd_nerr.
	(SYS_ERRLIST, SYS_NERR): Macros removed.
	(sys_nerr, _sys_nerr): Remove these weak aliases.
	* sysdeps/unix/sysv/linux/errlist.c: File removed.
	* sysdeps/unix/sysv/linux/errlist.h: File removed.
	* sysdeps/unix/sysv/linux/arm/errlist.c: File removed.

	* include/libc-symbols.h (declare_symbol): New macro.
	* config.h.in (ASM_TYPE_DIRECTIVE_PREFIX): New #undef.
	* configure.in: New check to define it.
	* configure: Regenerated.

2002-08-27  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/Makefile (headers): Remove bits/stdio_lim.h.  This
	file isn't distributed.  Add special rules to install bits/stdio_lim.h.

	* Make-dist: Remove traces of old stdio.
	* Makeconfig: Likewise.

	* locale/Makefile (localedef-aux): New variable.  Only md5
	assigned to it.  These files are not ddistributed in this directory.

	* sysdeps/unix/sysv/linux/s390/Dist: Add sys/procfs.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/Dist: Remove sys/procfs.h.
	* sysdeps/unix/sysv/linux/s390/s390-32/Dist: Likewise.

	* sysdeps/unix/sysv/linux/Dist: Remove sys/sendfile.h.

	* nss/getXXbyYY_r.c (REENTRANT_NAME): If no service is available
	set h_errno to NO_RECOVERY [PR libc/4360].

2002-08-26  Ulrich Drepper  <drepper@redhat.com>

	* libio/Makefile (tests): Add bug-fopena+.
	* libio/bug-fopena+.c: New file.
	* libio/fileops.c (_IO_file_open): Only set file pointer to end of the
	file for _IO_IS_APPENDING if file isn't opened for reading, too.

	* stdio-common/tst-swprintf.c (main): Add casts to avoid warnings.

	* locale/xlocale.c: Fix the last change.  The variable still has
	to end in _data.
	* sysdeps/generic/bits/libc-tsd.h [!(USE_TLS && HAVE___THREAD)]
	(__libc_tsd_set): Add _data prefix to variable name.

2002-08-26  Roland McGrath  <roland@redhat.com>

	* sysdeps/generic/sigset-cvt-mask.h (sigset_set_old_mask): Replace
	macro with inline function.
	(sigset_get_old_mask): Likewise.
	* sysdeps/posix/sigblock.c (__sigblock): Update callers.
	* sysdeps/posix/sigsetmask.c (__sigsetmask): Likewise.
	* sysdeps/posix/sigpause.c (__sigpause): Likewise.
	* sysdeps/posix/sigvec.c (__sigvec, sigvec_wrapper_handler): Likewise.
	* sysdeps/unix/sysv/aix/sigset-cvt-mask.h
	(sigset_set_old_mask, sigset_get_old_mask): Make these macros return
	values.
	* sysdeps/unix/sysv/linux/sigset-cvt-mask.h: Likewise.
	* sysdeps/unix/sysv/sysv4/sigset-cvt-mask.h: Likewise.

2002-07-06  Bruno Haible  <bruno@clisp.org>

	* sysdeps/generic/sigset-cvt-mask.h (sigset_set_old_mask,
	sigset_get_old_mask): Make it work with larger sigset_t.
	* sysdeps/posix/sigblock.c (__sigblock): Use those macros.
	* sysdeps/posix/sigsetmask.c (__sigsetmask): Likewise.
	* sysdeps/posix/sigpause.c (__sigpause): Likewise.

2002-08-26  Roland McGrath  <roland@redhat.com>

	* time/sys/time.h [__USE_BSD] (lutimes, futimes): Declare them.
	* manual/filesys.texi (File Times): Document lutimes and futimes.
	* misc/Makefile (routines): Add them.
	* misc/Versions (libc: GLIBC_2.3): Likewise.
	* sysdeps/generic/lutimes.c: New file.
	* sysdeps/generic/futimes.c: New file.
	* sysdeps/mach/hurd/lutimes.c: New file.
	* sysdeps/mach/hurd/futimes.c: New file.

	* manual/filesys.texi (File Times): Add explicit note about null
	pointer argument to utimes.

2002-08-26  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/ifreq.h (__if_freereq): Add missing semicolon.
	(__ifreq): Add a cast.  Remove an unused variable.

	* hurd/hurd/threadvar.h (enum __hurd_threadvar_index): Add
	_HURD_THREADVAR_LOCALE.

2002-08-26  Jakub Jelinek  <jakub@redhat.com>

	* posix/regexec.c (re_search_stub): Return correct match length
	if start != 0.
	* posix/bug-regex10.c: New test.
	* posix/Makefile (tests): Add bug-regex10.

2002-08-26  Brian Youmans  <3diff@gnu.org>

	* COPYING.LIB: Replaced with fresh copy from
	ftp://ftp.gnu.org/gnu/Licenses/COPYING.LIB-2.1;
	suggested copying permission notice now says version 2.1 instead
	of version 2.

	* crypt/crypt.c: Changed copying permission notice to Lesser GPL
	from Library GPL.
	* crypt/crypt_util.c: Likewise.
	* crypt/ufc.c: Likewise.
	* elf/dl-conflict.c: Likewise.
	* elf/dl-iteratephdr.c: Likewise.
	* iconv/iconvconfig.h: Likewise.
	* malloc/arena.c: Likewise.
	* malloc/hooks.c: Likewise.
	* malloc/malloc.c: Likewise.
	* posix/glob/Makefile.ami: Likewise.
	* posix/glob/Makefile.in: Likewise.
	* stdlib/gmp-impl.h: Likewise.
	* stdlib/gmp.h: Likewise.
	* sysdeps/generic/dl-iteratephdr-static.c: Likewise.
	* sysdeps/generic/strnlen.c: Likewise.
	* sysdeps/mach/hurd/powerpc/bits/sigcontext.h: Likewise.
	* sysdeps/mach/hurd/recvmsg.c: Likewise.
	* sysdeps/mach/hurd/sendmsg.c: Likewise.
	* sysdeps/mach/hurd/spawni.c: Likewise.
	* sysdeps/mach/powerpc/machine-sp.h: Likewise.
	* sysdeps/mach/powerpc/sysdep.h: Likewise.
	* sysdeps/mach/powerpc/thread_state.h: Likewise.
	* sysdeps/unix/bsd/bsd4.4/bits/socket.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/dl-iteratephdr-static.c: Likewise.
	* sysdeps/x86_64/gmp-mparam.h: Likewise.

	* sysdeps/ieee754/dbl-64/MathLib.h: Corrected version number in
	Lesser GPL copying permission notice from 2 to 2.1.
	* sysdeps/ieee754/dbl-64/asincos.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/atnat.h: Likewise.
	* sysdeps/ieee754/dbl-64/atnat2.h: Likewise.
	* sysdeps/ieee754/dbl-64/branred.c: Likewise.
	* sysdeps/ieee754/dbl-64/branred.h: Likewise.
	* sysdeps/ieee754/dbl-64/dla.h: Likewise.
	* sysdeps/ieee754/dbl-64/doasin.c: Likewise.
	* sysdeps/ieee754/dbl-64/doasin.h: Likewise.
	* sysdeps/ieee754/dbl-64/dosincos.c: Likewise.
	* sysdeps/ieee754/dbl-64/dosincos.h: Likewise.
	* sysdeps/ieee754/dbl-64/e_asin.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_atan2.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_exp.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_log.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_pow.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_remainder.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_sqrt.c: Likewise.
	* sysdeps/ieee754/dbl-64/halfulp.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpa.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpa.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpa2.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpatan.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpatan.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpatan2.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpexp.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpexp.h: Likewise.
	* sysdeps/ieee754/dbl-64/mplog.c: Likewise.
	* sysdeps/ieee754/dbl-64/mplog.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpsqrt.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpsqrt.h: Likewise.
	* sysdeps/ieee754/dbl-64/mptan.c: Likewise.
	* sysdeps/ieee754/dbl-64/mydefs.h: Likewise.
	* sysdeps/ieee754/dbl-64/powtwo.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/root.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/s_atan.c: Likewise.
	* sysdeps/ieee754/dbl-64/s_sin.c: Likewise.
	* sysdeps/ieee754/dbl-64/s_tan.c: Likewise.
	* sysdeps/ieee754/dbl-64/sincos.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/sincos32.c: Likewise.
	* sysdeps/ieee754/dbl-64/sincos32.h: Likewise.
	* sysdeps/ieee754/dbl-64/slowexp.c: Likewise.
	* sysdeps/ieee754/dbl-64/slowpow.c: Likewise.
	* sysdeps/ieee754/dbl-64/uasncs.h: Likewise.
	* sysdeps/ieee754/dbl-64/uatan.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/uexp.h: Likewise.
	* sysdeps/ieee754/dbl-64/uexp.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/ulog.h: Likewise.
	* sysdeps/ieee754/dbl-64/ulog.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/upow.h: Likewise.
	* sysdeps/ieee754/dbl-64/upow.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/urem.h: Likewise.
	* sysdeps/ieee754/dbl-64/uroot.h: Likewise.
	* sysdeps/ieee754/dbl-64/usncs.h: Likewise.
	* sysdeps/ieee754/dbl-64/utan.h: Likewise.
	* sysdeps/ieee754/dbl-64/utan.tbl: Likewise.

	* sysdeps/ieee754/flt-32/e_asinf.c: Added copyright notice for Stephen
	Moshier and Lesser GPL copying permission notice, per license from
	Moshier.
	* sysdeps/ieee754/ldbl-128/e_acosl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_asinl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_coshl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_jnl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_powl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_sinhl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/k_tanl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/s_erfl.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_asinl.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_j0l.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_j1l.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_jnl.c: Likewise.
	* sysdeps/ieee754/ldbl-96/e_lgammal_r.c: Likewise.
	* sysdeps/ieee754/ldbl-96/s_erfl.c: Likewise.

	* sysdeps/ieee754/ldbl-128/e_j0l.c: Added Lesser GPL copying permission
	notice, per license from copyright holder Stephen Moshier.
	* sysdeps/ieee754/ldbl-128/e_j1l.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_lgammal_r.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_log10l.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_log2l.c: Likewise.
	* sysdeps/ieee754/ldbl-128/e_logl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/s_atanl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/s_cbrtl.c: Likewise.
	* sysdeps/ieee754/ldbl-128/s_expm1l.c: Likewise.
	* sysdeps/ieee754/ldbl-128/s_log1pl.c: Likewise.

2002-08-26  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/sh/Makefile (sysdeps_routines): Add divdi3 in csu dir.
	(shared-only-routines): Likewise.

2002-08-26  Roland McGrath  <roland@redhat.com>

	* locale/programs/ld-ctype.c (ctype_read): When given a repertoire
	name of "", store a null pointer instead.

	* configure.in (elf): Set to yes for freebsd*, netbsd*.
	* configure: Regenerated.

	* locale/xlocale.c [! (USE_TLS && HAVE___THREAD)] (__libc_tsd_LOCALE):
	Initialize this instead of __libc_tsd_LOCALE_data.

	* sysdeps/unix/grantpt.c (pts_name): Convert ENOTTY return from
	ptsname_r to EINVAL.

	* sysdeps/generic/ptsname.c (__ptsname_r): Return ENOSYS instead of 0.

	* rt/Makefile: Revert last change, it was inappropriate to presume aio
	implementations depend on pthreads.
	* rt/tst-aio.c (do_test): Exit happy if first failure is ENOSYS.
	* rt/tst-aio64.c (do_test): Likewise.
	* rt/tst-aio2.c (do_test): Likewise.
	* rt/tst-aio3.c (do_test): Likewise.
	* rt/tst-aio4.c (do_test): Likewise.
	* rt/tst-aio5.c (do_test): Likewise.
	* rt/tst-aio6.c (do_test): Likewise.
	* rt/tst-aio7.c (do_test): Likewise.

	* sysdeps/generic/bits/libc-lock.h (__libc_setspecific): Use a cast to
	void so as to avoid compiler warnings.

	* libio/oldstdfiles.c [! _IO_MTSAFE_IO] (DEF_STDFILE): Don't define
	_IO_wide_data_FD, which is never used here.

	* libio/iofread.c
	[! _IO_MTSAFE_IO] (fread_unlocked): Add libc_hidden_ver defn.
	* libio/iofputs.c [! _IO_MTSAFE_IO] (fputs_unlocked): Likewise.
	* libio/iofgets.c [! _IO_MTSAFE_IO] (fgets_unlocked): Likewise.

	* include/resolv.h [! _LIBC_REENTRANT] (_res): #undef it before decl.
	* include/netdb.h [! _LIBC_REENTRANT] (h_errno): Declare normal extern.

	* misc/syslog.c (openlog): Conditionalize locking on [_LIBC_REENTRANT].
	(closelog): Likewise.

2002-07-06  Bruno Haible  <bruno@clisp.org>

	* sysdeps/alpha/fpu/fpu_control.h: Comment fix.

	* sysdeps/unix/sysv/linux/alpha/pipe.S: Moved to ...
	* sysdeps/unix/alpha/pipe.S: ... here.
	* sysdeps/unix/bsd/osf/alpha/pipe.S: File removed.

	* sysdeps/unix/i386/brk.S: Rename local label to '.Lhere' in ELF.

	* sysdeps/unix/i386/brk.S: Add PSEUDO_END invocation.
	* sysdeps/unix/i386/fork.S: Likewise.
	* sysdeps/unix/i386/pipe.S: Likewise.
	* sysdeps/unix/i386/wait.S: Likewise.

	* sysdeps/unix/fork.S: Fix PSEUDO_END argument.
	* sysdeps/unix/arm/fork.S: Likewise.

	* sysdeps/unix/sysv/linux/arm/sysdep.h (PSEUDO): Swap DO_CALL
	arguments.
	(DO_CALL): Swap argument order.
	* sysdeps/unix/sysv/linux/hppa/sysdep.h (PSEUDO): Swap DO_CALL
	arguments.
	(DO_CALL): Swap argument order.
	* sysdeps/unix/sysv/linux/i386/sysdep.h (PSEUDO): Swap DO_CALL
	arguments.
	(DO_CALL): Swap argument order.
	* sysdeps/unix/sysv/linux/s390/s390-32/sysdep.h (PSEUDO): Swap DO_CALL
	arguments.
	(DO_CALL): Swap argument order.
	* sysdeps/unix/sysv/linux/s390/s390-64/sysdep.h (PSEUDO): Swap DO_CALL
	arguments.
	(DO_CALL): Swap argument order.
	* sysdeps/unix/sysv/linux/sh/sysdep.h (PSEUDO): Swap DO_CALL
	arguments.
	(DO_CALL): Swap argument order.
	* sysdeps/unix/sysv/linux/x86_64/sysdep.h (PSEUDO): Swap DO_CALL
	arguments.
	(DO_CALL): Swap argument order.

	* sysdeps/i386/sysdep.h (PSEUDO): Fix syntax error.
	(L): Define right for ELF.
	* sysdeps/unix/sysv/linux/i386/sysdep.h (L): Remove definition.
	Now defined in sysdeps/i386/sysdep.h.

	* sysdeps/posix/readv.c: Ansify function definition.
	* sysdeps/posix/writev.c: Likewise.

	* stdio-common/tst-fseek.c (main): Don't assume that off_t and size_t
	have the same size. Avoid direct cast from size_t to off_t.

	* login/tst-utmp.c (simulate_login): Don't leave garbage after the
	nul byte in entry[n].ut_user.
	(simulate_logout): Likewise.

	* login/programs/utmpdump.c (print_entry): Test _HAVE_UT_TYPE,
	_HAVE_UT_PID, _HAVE_UT_ID, _HAVE_UT_HOST, instead of assuming the
	existence of corresponding members of 'struct utmp'.
	* login/tst-utmp.c: Trivialize the test if testing 'struct utmp' and
	!_HAVE_UT_TYPE.

	* sysdeps/unix/opendir.c (__opendir): If st_blksize is 0 or too small,
	allocate a buffer of at least BUFSIZ bytes, not just of
	sizeof (struct dirent).

	* sysdeps/generic/glob.c: Include <limits.h>.
	(NAME_MAX): Define a fallback.
	(glob_in_dir): Allocate enough room for a 'struct dirent64' on the
	stack.
	* posix/tst-dir.c: Include <stddef.h>, for offsetof.
	(main): Allocate enough room for a 'struct dirent64' on the stack.
	* posix/tst-gnuglob.c (my_DIR): Allocate enough room for a
	'struct dirent'.

	* sysdeps/unix/sysv/linux/init-first.c: Don't include
	kernel-features.h.

	* inet/htontest.c: Include <sys/types.h>.

	* sysdeps/generic/sys/sysinfo.h: Surround with __{BEGIN,END}_DECLS.

	* include/sys/sysctl.h: Comment fix.

	* elf/rtld.c (_rtld_global) [! _LIBC_REENTRANT]: Don't initialize
	_dl_load_lock.
	* libio/fileno.c (fileno_unlocked): Define regardless of _IO_MTSAFE_IO.

	* sysdeps/unix/bsd/bsd4.4/syscalls.list (__sigaltstack): New alias.

	* sysdeps/unix/inet/syscalls.list (__connect_internal): New alias.
	(__getpeername): New alias.
	(__getsockname): New alias.
	(__socket): New alias.

	* sysdeps/unix/common/syscalls.list (getpgid): Remove.

	* sysdeps/unix/syscalls.list (__chown_internal): New alias.
	(__fcntl_internal): New alias.
	(__profil): New alias.

2002-08-26  Ulrich Drepper  <drepper@redhat.com>

	* nscd/hstcache.c (cache_addhst): Add new parameter saying whether
	entry was for getaddr* lookup or not.  Add only matching cache
	entry.  Change all callers [PR libc/4317].

	* libio/wfileops.c (_IO_wfile_seekoff): Set fp->_offset after
	finding the read position [PR libc/4265].
	* libio/Makefile (tests): Add bug-rewind2.
	* libio/bug-rewind2.c: New file.

	* libio/bug-rewind.c: Fix creation of temp file.

2002-08-25  Ulrich Drepper  <drepper@redhat.com>

	* nss/getXXbyYY_r.c (REENTRANT_NAME): Return ENOENT if status is
	neither SUCCESS nor TRYAGAIN [PR libc/4259].
	* nss/nss_files/files-XXX.c (internal_getent): Don't set *errnop
	to ENOENT if no entry is found.
	* nis/nss_compat/compat-grp.c: Don't set errno in case of lookup
	failure.
	* nis/nss_compat/compat-initgroups.c: Likewise.
	* nis/nss_compat/compat-pwd.c: Likewise.
	* nis/nss_compat/compat-spwd.c: Likewise.
	* nis/nss_nis/nis-alias.c: Likewise.
	* nis/nss_nis/nis-ethers.c: Likewise.
	* nis/nss_nis/nis-grp.c: Likewise.
	* nis/nss_nis/nis-hosts.c: Likewise.
	* nis/nss_nis/nis-initgroups.c: Likewise.
	* nis/nss_nis/nis-netgrp.c: Likewise.
	* nis/nss_nis/nis-network.c: Likewise.
	* nis/nss_nis/nis-proto.c: Likewise.
	* nis/nss_nis/nis-publickey.c: Likewise.
	* nis/nss_nis/nis-pwd.c: Likewise.
	* nis/nss_nis/nis-rpc.c: Likewise.
	* nis/nss_nis/nis-service.c: Likewise.
	* nis/nss_nis/nis-spwd.c: Likewise.
	* resolv/nss_dns/dns-host.c: Likewise.
	* resolv/nss_dns/dns-network.c: Likewise.
	* nis/nss_nisplus/nisplus-alias.c: Save errno around NIS calls.
	* nis/nss_nisplus/nisplus-ethers.c: Likewise.
	* nis/nss_nisplus/nisplus-grp.c: Likewise.
	* nis/nss_nisplus/nisplus-hosts.c: Likewise.
	* nis/nss_nisplus/nisplus-network.c: Likewise.
	* nis/nss_nisplus/nisplus-proto.c: Likewise.
	* nis/nss_nisplus/nisplus-pwd.c: Likewise.
	* nis/nss_nisplus/nisplus-rpc.c: Likewise.
	* nis/nss_nisplus/nisplus-service.c: Likewise.
	* nis/nss_nisplus/nisplus-spwd.c: Likewise.
	* hesiod/nss_hesiod/hesiod-pwd.c (lookup): Preserve errno value.
	* hesiod/nss_hesiod/hesiod-proto.c (lookup): Likewise.
	* hesiod/nss_hesiod/hesiod-grp.c (lookup): Likewise.
	* hesiod/nss_hesiod/hesiod-service.c (lookup): Likewise.

	* sysdeps/unix/sysv/linux/i386/sigaction.c: Avoid warnings by
	declaring __restore and __restore_rt as hidden (if possible).

2002-08-25  Roland McGrath  <roland@redhat.com>

	* manual/llio.texi (Access Modes): Fix typos in O_READ/O_WRITE defns.

	* sysdeps/generic/utmp_file.c (LOCK_FILE): Check for error from fcntl.
	(getutent_r_file, internal_getut_r): Updated all callers.
	(getutline_r_file, pututline_file, updwtmp_file): Likewise.

2002-08-25  Ulrich Drepper  <drepper@redhat.com>

	* locale/programs/locale.c: Don't print aliases for non-existing
	locales for 'locale -a'.
	Patch by Noah Levitt <nlevitt@columbia.edu> [PR libc/4166].

2002-07-19  H.J. Lu  <hjl@gnu.org>

	* sysdeps/unix/sysv/linux/mips/bits/msq.h: New file.

2002-07-16  H.J. Lu  <hjl@gnu.org>

	* sysdeps/unix/sysv/linux/Makefile (sysdep_headers): Add
	sys/personality.h.
	* sysdeps/unix/sysv/linux/sys/personality.h: New file.

2002-08-25  Ulrich Drepper  <drepper@redhat.com>

	* elf/tst-tlsmod1.c (in_dso): Make sure the TLS variable access is
	not moved ahead of the fputs call.
	* elf/tst-tlsmod2.c (in_dso): Likewise.
	* elf/tst-tlsmod3.c (in_dso2): Likewise.
	* elf/tst-tlsmod4.c (in_dso): Likewise.

2002-08-25  Andreas Schwab  <schwab@suse.de>

	* elf/dl-reloc.c (_dl_reloc_bad_type): Nul-terminate message.

2002-08-25  Roland McGrath  <roland@redhat.com>

	* sysdeps/generic/utmp_file.c (UNLOCK_FILE): Clear alarm before
	resetting handler, to avoid the possibility of a spurious SIGALRM
	delivered to the user's handler.
	Reported by Amit D. Chaudhary <amitc@brocade.com>,

	* misc/Makefile (CFLAGS-init-misc.c): Variable removed.  It served to
	set -fkeep-inline-functions, which is not needed for the current file.

	* sysdeps/generic/ldsodefs.h: Add attribute_hidden to *_internal decls.
	(_dl_setup_hash): Add attribute_hidden.
	(_dl_sysdep_start, _dl_sysdep_start_cleanup): Likewise.
	(_dl_sysdep_read_whole_file, _dl_dprintf): Likewise.
	(_dl_new_object, _dl_map_object_deps): Likewise.
	(_dl_map_object_deps_internal): Remove decl.
	* elf/rtld.c (__mempcpy, _exit): Redeclare locally as hidden.

	* sysdeps/i386/dl-machine.h [PI_STATIC_AND_HIDDEN
	&& HAVE_VISIBILITY_ATTRIBUTE && HAVE_HIDDEN
	&& !HAVE_BROKEN_VISIBILITY_ATTRIBUTE]
	(elf_machine_dynamic, elf_machine_load_address): Rewritten without asm,
	instead relying on the compiler to produce only GOTOFF variable refs.

2002-08-25  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c: Fix typo in comment.  Add a few more __builtin_expect.

	* sysdeps/generic/dl-cache.h (_dl_cache_libcmp): Define as static
	inline to avoid defining it in every file which includes this header.

	* elf/rtld.c: Also test for HAVE_VISIBILITY_ATTRIBUTE before
	defining DONT_USE_BOOTSTRAP_MAP.

	* libio/tst-freopen.c (main): Use correct formats for __LINE__.
	* libio/tst-mmap-setvbuf.c (main): Likewise.
	* libio/tst-widetext.c (main): Likewise.

	* libio/tst-mmap-eofsync.c (do_test): Use correct format in error
	message.
	* libio/tst-mmap-fflushsync.c (do_test): Likewise.
	* libio/tst-mmap2-eofsync.c (do_test): Likewise.

	* sysdeps/i386/elf/configure.in: Unconditionally define
	PI_STATIC_AND_HIDDEN.
	* elf/rtld.c (DONT_USE_BOOTSTRAP_MAP): Define only if
	PI_STATIC_AND_HIDDEN is defined as well.
	* config.h.in: Add PI_STATIC_AND_HIDDEN entry.

2002-08-24  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/ia64/bzero.S: Define __bzero as well.

	* locale/programs/charmap.c (charmap_new_char): Don't use
	ULONG_MAX as maximum UCS4 value.

	* sysdeps/unix/sysv/linux/ia64/sys/user.h: New file.

	* sysdeps/generic/strtol.c: We don't need the isascii test in glibc.

	* malloc/hooks.c (public_sET_STATe): use size_t as type for i.
	* malloc/malloc.c (mALLINFo): Likewise.

	* libio/wstrops.c (_IO_wstr_pbackfail): Use WEOF in comparison.

	* libio/wfileops.c (_IO_wfile_overflow): Use EOF not WEOF when
	examining result of _IO_do_flush call.

	* stdio-common/vfprintf.c (vfprintf): Use correct type in va_arg.
	Use prec not spec when sizing buffers.

	* catgets/open_catalog.c (__open_catalog): Add casts to avoid warnings.
	* locale/loadarchive.c (_nl_load_locale_from_archive): Likewise.
	* locale/loadlocale.c (_nl_intern_locale_data): Likewise.
	* stdio-common/vfscanf.c (inchar): Likewise.
	* misc/efgcvt_r.c (fcvt_r): Likewise.
	* elf/dl-misc.c (_dl_debug_vdprintf): Likewise.
	* elf/readlib.c (process_file): Likewise.
	* elf/sprof.c (load_profdata): Likewise.
	* sysdeps/ia64/hp-timing.h (HP_TIMING_PRINT): Likewise.
	* locale/programs/linereader.c (get_toplvl_escape): Likewise.
	* locale/programs/charmap.c (charmap_read): Likewise.
	* libio/fileops.c: Likewise.
	* libio/fmemopen.c: Likewise.
	* stdlib/strtod.c: Likewise.
	* elf/dl-load.c: Likewise.
	* iconv/iconvconfig.c: Likewise.
	* iconv/iconv_prog.c (process_block): Likewise.
	* elf/rtld.c (dl_main): Likewise.

	* sysdeps/unix/sysv/linux/ia64/Makefile: Define _ASM_IA64_CURRENT_H
	macro to calm down the compiler.

	* iconv/gconv_cache.c (__gconv_load_cache): Add cast to avoid warning.

	* sysdeps/ia64/elf/initfini.c: Don't use newlines embedded in string.

	* sysdeps/unix/sysv/linux/i386/sysdep.S: Update comment regarding
	placement of errno definition.
	* sysdeps/unix/sysv/linux/m68k/sysdep.S: Likewise.
	* sysdeps/unix/sysv/linux/mips/sysdep.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sysdep.S: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/sysdep.S: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sysdep.S: Likewise.

	* resolv/nss_dns/dns-host.c (MAXPACKET): Increase minimum value
	from 1024 to 65536, to avoid buffer overrun.

2002-08-16  Paul Eggert  <eggert@twinsun.com>

	* resolv/gethnamaddr.c (MAXPACKET): Increase minimum value
	from 1024 to 65536, to avoid buffer overrun.
	* resolv/res_query.c (MAXPACKET): Likewise.

2002-08-24  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/i386/Versions: Remove *xattr syscalls.

2002-08-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/ieee754/dbl-64/e_pow.c (log1): Define and initialize
	two52 locally.
	(log2): Likewise.
	* sysdeps/ieee754/dbl-64/upow.h: Remove definition of two52.
	Patch by Simon Gee <simong@agile.tv>.

	* sysdeps/unix/sysv/linux/getsysstats.c (__get_nprocs_conf):
	Prefer reading /proc/stat since it is more uniform across
	architectures.

	* manual/texinfo.tex: Update to latest official version.

	* sysvipc/sys/shm.h: Remove SHMLBA definition.
	* sysdeps/generic/bits/shm.h: Define SHMLBA here.
	* sysdeps/gnu/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/alpha/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/shm.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/shm.h: Define SHMLBA to 2^20
	since this is what the kernel says.

	* misc/sys/xattr.h: Include <sys/types.h> instead of <stddef.h>
	since ssize_t is needed as well.  Replace const with __const.

2002-08-23  Roland McGrath  <roland@redhat.com>

	* malloc/hooks.c (__malloc_initialize_hook, __free_hook,
	__malloc_hook, __realloc_hook, __memalign_hook,
	__after_morecore_hook): Variable definitions moved to ...
	* malloc/malloc.c: ... here, so as to be before all references.

	* sysdeps/i386/dl-machine.h (elf_machine_load_address): Add a dummy
	global variable reference in an unused asm parameter, to ensure the
	compiler has set up the GOT register before we use it.

	* malloc/hooks.c: Move variable definitions ahead of uses.
	* libio/fileops.c: Move versioned_symbol defns ahead of _IO_jump_t
	initializers that make reference to variables they define.

2002-08-23  Andreas Jaeger  <aj@suse.de>

	* locale/loadarchive.c: Include <stdlib.h> for prototypes of
	alloca, free, qsort.

	* dlfcn/bug-dlsym1-lib1.c (foo): Add prototype to avoid warning.

	* sysdeps/ieee754/flt-32/e_jnf.c: Remove unused variable.
	* sysdeps/ieee754/ldbl-96/e_j0l.c: Likewise.

	* misc/sys/xattr.h: New file, contributed by Christoph Hellwig
	<hch@lst.de>.
	* sysdeps/generic/fgetxattr.c: New file.
	* sysdeps/generic/flistxattr.c: New file.
	* sysdeps/generic/fremovexattr.c: New file.
	* sysdeps/generic/fsetxattr.c: New file.
	* sysdeps/generic/getxattr.c: New file.
	* sysdeps/generic/listxattr.c: New file.
	* sysdeps/generic/lgetxattr.c: New file.
	* sysdeps/generic/llistxattr.c: New file.
	* sysdeps/generic/lremovexattr.c: New file.
	* sysdeps/generic/lsetxattr.c: New file.
	* sysdeps/generic/removexattr.c: New file.
	* sysdeps/generic/setxattr.c: New file.
	* misc/Makefile (headers): Add sys/xattr.h.
	(routines): Add *xattr calls.
	* misc/Versions: Add *xattr calls with version 2.3.
	* sysdeps/unix/sysv/linux/m68k/Versions: Remove *xattr syscalls.
	* sysdeps/unix/sysv/linux/s390/s390-32/Versions: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/Versions: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/Versions: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/Versions: Likewise.
	* sysdeps/unix/sysv/linux/ia64/Versions: Likewise.
	* sysdeps/unix/sysv/linux/alpha/Versions: Likewise.
	* sysdeps/unix/sysv/linux/arm/Versions: Likewise.

2002-08-22  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/powerpc/elf/libc-start.c
	(__cache_line_size): Declare.
	(__aux_init_cache): New function.
	(__libc_start_main): Change type of `auxvec' parameter to
	`ElfW(auxv_t) *'.  Correct walking of aux vector.  Call
	__aux_init_cache.
	* sysdeps/unix/sysv/linux/powerpc/dl-sysdep.c
	(__cache_line_size): Declare.
	(__aux_init_cache): New function.
	(DL_PLATFORM_INIT): Define.
	* sysdeps/powerpc/memset.S: Define __cache_line_size and use its
	value to select the correct stride for dcbz.

2002-08-22  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/x86_64/syscalls.list: Fix arguments of
	shmat.

2002-08-22  Roland McGrath  <roland@redhat.com>

	* locale/loadarchive.c (_nl_load_locale_from_archive): Check max file
	position indicated by locrectab against file bounds before rounding to
	page size.  In mapping loop, always set TO before breaking out of
	contiguous range coalescing loop.

	* locale/loadarchive.c (_nl_load_locale_from_archive): Use MAP_PRIVATE
	(or MAP_COPY if available) instead of MAP_SHARED.

	* scripts/firstversions.awk: When encountering a version newer than
	the specified earliest version, be sure to emit the specified earliest
	version first if any renaming of an older version to that has been.

2002-08-21  Roland McGrath  <roland@redhat.com>

	* configure.in: Make GCC version check require 3.[2-9]* and no others.
	* manual/install.texi (Tools for Compilation): Say 3.2 is required.
	(Configuring and compiling): Don't mention older GCC versions any more.
	* INSTALL: Regenerated.

	* manual/install.texi (Configuring and compiling, Installation,
	Running make install, Linux): Linux -> GNU/Linux where appropriate.

	* elf/rtld.c (_dl_start_final): Move defn before _dl_start so it can
	be inlined.  Declare it with always_inline if [DONT_USE_BOOTSTRAP_MAP]
	and with noinline otherwise.  Remove hack alloca use to prevent
	inlining, we can ask for it explicitly nowadays.

	* dlfcn/bug-dlsym1.c: New file.
	* dlfcn/bug-dlsym1-lib1.c, dlfcn/bug-dlsym1-lib2.c: New files.
	* dlfcn/Makefile (distribute): Add them.
	(tests): Add bug-dlsym1 here.
	(modules-names): Add bug-dlsym1-lib1 and bug-dlsym1-lib2 here.
	($(objpfx)bug-dlsym1, $(objpfx)bug-dlsym1.out): New targets.
	($(objpfx)bug-dlsym1-lib1.so, $(objpfx)bug-dlsym1-lib2.so): Likewise.

2002-08-21  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c (start_time): New global variable.  Moved from _dl_start.
	(DONT_USE_BOOTSTRAP_MAP): Define if we can use non-exported symbols
	before relocation.
	(_dl_start): Don't use local bootstrap_map variable if
	DONT_USE_BOOTSTRAP_MAP is defined.  Use GL(dl_rtld_map).  Don't
	pass bootstrap_map to _dl_start_final in this case either.  Don't
	pass start_time to _dl_start_final ever.
	(_dl_start_final): Don't copy bootstrap_map if DONT_USE_BOOTSTRAP_MAP.

	* elf/dl-deps.c (_dl_map_object_deps): Revert patch from 2002-05-28.
	This cripples the scope lists necessary to search for symbols in
	dependencies which are not in the global scope.

	* include/setjmp.h (__libc_longjmp): Add declaration.

2002-08-21  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/_mcount.S: Fix assembler.

	* sysdeps/unix/sysv/linux/x86_64/Makefile: Generate bits/syscall.h
	with biarch support.

2002-08-21  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/sysdep.h (CALL_MCOUNT): Fix it.

	* sysdeps/x86_64/Makefile (sysdep_routines): Add _mcount.

	* sysdeps/x86_64/machine-gmon.h: New file.
	* sysdeps/x86_64/_mcount.S: New file.

2002-08-20  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c (_dl_start): Pass zero to TLS_INIT_TP.  Set
	bootstrap_map.l_tls_tp_initialized to 1 if TLS_INIT_TP was called.
	(_dl_start_final): Copy l_tls_tp_initialized to GL(dl_rtld_map).
	(dl_main): If HAVE___THREAD is not defined pass l_tls_tp_initialized
	to TL_INIT_TP.  Otherwise pass 1.
	* include/link.h (struct link_map): Add l_tls_tp_initialized.
	* sysdeps/generic/libc-tls.c (__libc_setup_tls): Pass 0 to TL_INIT_TP.

2002-08-15  Jakub Jelinek  <jakub@redhat.com>

	* locale/programs/localedef.c (add_to_readlist): Error about
	circular dependencies only if the locale in question hasn't
	been finished.
	* locale/programs/linereader.c (get_string): Pass LC_CTYPE not
	CTYPE_LOCALE to load_locale.
	* locale/programs/locfile.c (locfile_read): Don't include
	unneeded but available locales in locale_mask.

	* locale/programs/locarchive.c (enlarge_archive): If quiet, don't
	print any messages about enlarging archive.

2002-08-20  Brian Youmans  <3diff@gnu.org>

	* manual/contrib.texi: Removed licenses, added acknowledgements
	for contributions by Intel, IBM, Craig Metz.
	* LICENSES: New file, contains the text of all non-FSF licenses in the
	distribution that require putting the notice in the accompanying
	documentation.
	* README.template, README: Mention LICENSES.

	* sysdeps/mach/hurd/net/if_ppp.h: Replaced CMU license with a
	new one modelled on the modern BSD license, per recent letter
	of permission from CMU.
	* sysdeps/unix/sysv/linux/net/if_ppp.h: Likewise.

	* sysdeps/ieee754/dbl-64/MathLib.h: Changed the copyright holder
	from IBM to FSF, per the recent Software Letter.  Changed the
	distribution terms from GPL to LGPL.

	* sysdeps/ieee754/dbl-64/asincos.tbl: Added FSF copyright and
	copying permission notice (Lesser GPL), per recent IBM Software Letter.
	* sysdeps/ieee754/dbl-64/powtwo.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/root.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/sincos.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/uatan.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/uexp.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/ulog.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/upow.tbl: Likewise.
	* sysdeps/ieee754/dbl-64/utan.tbl: Likewise.

	* sysdeps/ieee754/dbl-64/atnat.h: Changed the copyright holder
	from IBM to FSF, per the recent Software Letter.  Corrected the
	text of the copying permission notice to say Lesser GPL instead
	of GPL in warranty disclaimer paragraph.
	* sysdeps/ieee754/dbl-64/atnat2.h: Likewise.
	* sysdeps/ieee754/dbl-64/branred.h: Likewise.
	* sysdeps/ieee754/dbl-64/dla.h: Likewise.
	* sysdeps/ieee754/dbl-64/doasin.h: Likewise.
	* sysdeps/ieee754/dbl-64/dosincos.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpa.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpa2.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpatan.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpexp.h: Likewise.
	* sysdeps/ieee754/dbl-64/mplog.h: Likewise.
	* sysdeps/ieee754/dbl-64/mpsqrt.h: Likewise.
	* sysdeps/ieee754/dbl-64/mydefs.h: Likewise.
	* sysdeps/ieee754/dbl-64/sincos32.h: Likewise.
	* sysdeps/ieee754/dbl-64/uasncs.h: Likewise.
	* sysdeps/ieee754/dbl-64/uexp.h: Likewise.
	* sysdeps/ieee754/dbl-64/ulog.h: Likewise.
	* sysdeps/ieee754/dbl-64/upow.h: Likewise.
	* sysdeps/ieee754/dbl-64/urem.h: Likewise.
	* sysdeps/ieee754/dbl-64/uroot.h: Likewise.
	* sysdeps/ieee754/dbl-64/usncs.h: Likewise.
	* sysdeps/ieee754/dbl-64/utan.h: Likewise.

	* sysdeps/ieee754/dbl-64/branred.c: Corrected the text of the copying
	permission notice to say Lesser GPL instead of GPL in warranty
	disclaimer paragraph.
	* sysdeps/ieee754/dbl-64/doasin.c: Likewise.
	* sysdeps/ieee754/dbl-64/dosincos.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_asin.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_atan2.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_exp.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_log.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_pow.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_remainder.c: Likewise.
	* sysdeps/ieee754/dbl-64/e_sqrt.c: Likewise.
	* sysdeps/ieee754/dbl-64/halfulp.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpa.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpatan.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpatan2.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpexp.c: Likewise.
	* sysdeps/ieee754/dbl-64/mplog.c: Likewise.
	* sysdeps/ieee754/dbl-64/mpsqrt.c: Likewise.
	* sysdeps/ieee754/dbl-64/mptan.c: Likewise.
	* sysdeps/ieee754/dbl-64/s_atan.c: Likewise.
	* sysdeps/ieee754/dbl-64/s_sin.c: Likewise.
	* sysdeps/ieee754/dbl-64/s_tan.c: Likewise.
	* sysdeps/ieee754/dbl-64/sincos32.c: Likewise.
	* sysdeps/ieee754/dbl-64/slowexp.c: Likewise.
	* sysdeps/ieee754/dbl-64/slowpow.c:  Likewise.

2002-08-20  Roland McGrath  <roland@redhat.com>

	Fix ABI compatibility with libc compiled with old tools on powerpc.
	Changes contributed by Franz Sirl <Franz.Sirl-kernel@lauterbach.com>
	and Jack Howarth <howarth@bromo.med.uc.edu>.
	* sysdeps/powerpc/Makefile [$(have-protected) = yes]
	(CPPFLAGS-divdi3.c, CPPFLAGS-libgcc-compat.S): New variables,
	pass -DHAVE_DOT_HIDDEN for these files.
	* sysdeps/powerpc/Versions (libc: GLIBC_2.0): Added __floatdidf,
	__floatdisf.
	* sysdeps/powerpc/divdi3.c: New file.
	* sysdeps/powerpc/libgcc-compat.S: New file, replacement for ...
	* sysdeps/powerpc/libgcc-compat.c: ... this, file removed.

2002-08-20  Jakub Jelinek  <jakub@redhat.com>

	* locale/loadarchive.c (_nl_load_locale_from_archive): Handle
	partially overlapping mappings.	 Remove unneeded (char *) casts.
	Never allow duplication of ranges in mapped areas.

2002-08-20  Roland McGrath  <roland@redhat.com>

	* elf/Makefile ($(objpfx)ld.so): Separate commands in rule so errors
	can be detected by make.  Reported by H.J. Lu <hjl@gnu.org>.

2002-08-20  Ulrich Drepper  <drepper@redhat.com>

	* include/unistd.h: Don't hide _exit.

	* elf/rtld.c (_dl_start): Pass extra argument 1 to TLS_INIT_TP.
	(dl_main): Pass extra argument 0 to TLS_INIT_TP.
	* sysdeps/generic/libc-tls.c (__libc_setup_tls): Pass extra
	argument 1 to TLS_INIT_TP.
	* sysdeps/generic/tls.h (TLS_INIT_TP): Describe new parameter.

	* sysdeps/generic/dl-tls.c (allocate_dtv): Optimize a bit.

	* elf/Versions [ld] (GLIBC_PRIVATE): Add _dl_get_tls_static_info.
	* sysdeps/generic/dl-tls.c (_dl_allocate_tls_storage): Move dtv
	memory allocation to...
	(allocate_dtv): ...here.  New function.
	(_dl_allocate_tls): Change to take parameter.  If parameter is non-NULL
	call allocate_dtv instead of _dl_allocate_tls_storage.
	(_dl_deallocate_tls): New parameter.  Deallocate TCB only if true.
	(_dl_get_tls_static_info): New function.
	* sysdeps/generic/ldsodefs.h: Adjust prototypes of _dl_allocate_tls
	and _dl_deallocate_tls.  Add prototype for _dl_get_tls_static_info.

2002-08-19  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/dl-tls.c (_dl_allocate_tls_init): Return
	immediately if result == NULL.

2002-08-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/alpha/fpu/libm-test-ulps: Regenerate.

2002-08-18  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/mkdir.c (__mkdir): Use __directory_name_split
	instead of __file_name_split.
	* sysdeps/mach/hurd/unlink.c (__unlink): Likewise.

	* sysdeps/mach/hurd/dl-sysdep.c
	[HP_TIMING_AVAIL] (_dl_cpuclock_offset): New variable.
	[HP_TIMING_AVAIL] (_dl_sysdep_start): Set it with HP_TIMING_NOW.

2002-08-16  Jakub Jelinek  <jakub@redhat.com>

	* locale/loadarchive.c (_nl_load_locale_from_archive): Braino fix
	in change before last: MAX -> MIN.

2002-08-15  Roland McGrath  <roland@redhat.com>

	* libio/fileops.c (_IO_file_seekoff_mmap): Leave read pointers at EOF
	if seek would go past it.
	(mmap_remap_check): If file position is at or past EOF after check,
	leave read pointers at EOF and don't seek.

	* libio/tst-mmap-offend.c: New file.
	* libio/Makefile (tests): Add it.

	* locale/loadarchive.c (_nl_load_locale_from_archive): Store strdup of
	the name as passed, rather than the name in the archive dictionary.

2002-08-15  Ulrich Drepper  <drepper@redhat.com>

	* csu/Makefile: Define elide-routines.os not static-only-routines.

	* include/sched.h (__clone): Add varargs at the end.

	* elf/rtld.c (_dl_start): Allow TLS_INIT_TP to fail, and stop in that
	case.
	(TLS_INIT_HELPER): If defined, use it.
	* sysdeps/generic/libc-tls.c (TLS_INIT_HELPER): Likewise.

2002-08-15  Roland McGrath  <roland@redhat.com>

	* elf/dl-load.c (lose): Remove [!SHARED] conditional from null check
	on L->l_prev; it can happen under rtld --verify too.

	* locale/loadarchive.c (_nl_load_locale_from_archive): Don't read the
	header separately, just map an initial window of 2MB from the file
	and remap if that is not large enough to cover the whole header.

2002-08-15  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/m68k/Versions: Add *xattr syscalls with
	version 2.3.
	* sysdeps/unix/sysv/linux/arm/Versions: Likewise.
	* sysdeps/unix/sysv/linux/alpha/Versions: Likewise.
	* sysdeps/unix/sysv/linux/ia64/Versions: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/Versions: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/Versions: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/Versions: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/Versions: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/Versions: Likewise.
	* sysdeps/unix/sysv/linux/mips/Versions: Likewise.
	Patch by Andreas Gruenbacher <agruen@suse.de>.

	* sysdeps/unix/sysv/linux/syscalls.list: Add *xattr syscalls.

2002-08-14  Roland McGrath  <roland@redhat.com>

	* locale/locarchive.h (struct locale_category_data): Give this name to
	the type of locale_data_t's elements.
	* locale/programs/locarchive.c (cmpcategorysize): New static function.
	(add_locale): Use that to sort the categories by size and put all
	those that fit into two pages into the LC_ALL block, instead of
	hard-coding it to do everything but LC_CTYPE and LC_COLLATE.
	(show_archive_content): Detect categories inside LC_ALL block
	directly, instead of hard-coding.
	(oldlocrecentcmp): Compare just on file locations used.

2002-08-14  Jakub Jelinek  <jakub@redhat.com>

	* locale/programs/locarchive.c (struct oldlocrecent): New type.
	(oldlocrecentcmp): New function.
	(enlarge_archive): Re-add locales in the order they were added
	to the archive.
	(add_locale): Put all the small locale files together, if the small
	locale file block would occupy less pages if page size aligned, align
	it.
	(show_archive_content): Adjust for locale archives optimized for speed.

2002-08-14  Roland McGrath  <roland@frob.com>

	* configure.in: Use "MISSING" as not-found value for MIG.
	* sysdeps/mach/configure.in: Fatal if mig not found.
	* configure, sysdeps/mach/configure: Regenerated.

2002-08-13  Jakub Jelinek  <jakub@redhat.com>

	* locale/loadarchive.c (archfname): Add missing slash.

	* sysdeps/generic/strtold.c (__strtold_internal): Add libc_hidden_def.
	* wcsmbs/wcstold.c (__wcstold_internal): Add libc_hidden_def.

2002-08-12  Roland McGrath  <roland@redhat.com>

	* include/sys/wait.h (__waitpid): Add libc_hidden_proto.
	* sysdeps/unix/sysv/sco3.2.4/waitpid.S: Add libc_hidden_def.
	* sysdeps/unix/sysv/sysv4/waitpid.c: Add libc_hidden_weak.
	* sysdeps/unix/sysv/linux/waitpid.c: Likewise.
	* sysdeps/unix/sysv/aix/waitpid.c: Likewise.
	* sysdeps/unix/bsd/bsd4.4/waitpid.c: Likewise.
	* sysdeps/generic/waitpid.c: Likewise.

	* include/net/if.h: New file.  Use libc_hidden_proto
	for if_nametoindex and if_indextoname.
	* sysdeps/generic/if_index.c: Add libc_hidden_def.
	* sysdeps/mach/hurd/if_index.c: Likewise.
	* sysdeps/unix/sysv/linux/if_index.c: Likewise.

	* include/grp.h (setgroups): Add libc_hidden_proto.
	* sysdeps/generic/setgroups.c: Add libc_hidden_def.
	* sysdeps/mach/hurd/setgroups.c: Likewise.
	* sysdeps/unix/sysv/irix4/setgroups.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/setgroups.c: Likewise.

2002-08-13  Jakub Jelinek  <jakub@redhat.com>

	* include/unistd.h (seteuid, setegid): Add libc_hidden_proto.
	* sysdeps/generic/seteuid.c (seteuid): Add libc_hidden_def.
	* sysdeps/generic/setegid.c (setegid): Likewise.
	* sysdeps/mach/hurd/seteuid.c (seteuid): Likewise.
	* sysdeps/mach/hurd/setegid.c (setegid): Likewise.
	* sysdeps/unix/bsd/seteuid.c (seteuid): Likewise.
	* sysdeps/unix/bsd/setegid.c (setegid): Likewise.
	* sysdeps/unix/sysv/aix/seteuid.c (seteuid): Likewise.
	* sysdeps/unix/sysv/aix/setegid.c (setegid): Likewise.
	* sysdeps/unix/sysv/linux/i386/setegid.c (setegid): Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/seteuid.c (seteuid): Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/setegid.c (setegid): Likewise.
	* sysdeps/unix/sysv/linux/seteuid.c (seteuid): Likewise.
	* sysdeps/unix/sysv/linux/setegid.c (setegid): Likewise.
	* sysdeps/unix/sysv/linux/i386/seteuid.c (seteuid): Likewise.
	Remove fallback if __ASSUME_SETRESUID_SYSCALL.

	* include/sys/stat.h (__fxstat_internal, __fxstat64_internal,
	__lxstat_internal, __lxstat64_internal): Remove.
	(__fxstat, __fxstat64, __lxstat, __lxstat64, __xstat, __xstat64):
	Add hidden_proto.
	* sysdeps/generic/fxstat.c (__fxstat): Add hidden_def.
	Remove INTDEF where present, remove #undef at the beginning.
	* sysdeps/generic/fxstat64.c (__fxstat64): Likewise.
	* sysdeps/generic/lxstat.c (__lxstat): Likewise.
	* sysdeps/generic/lxstat64.c (__lxstat64): Likewise.
	* sysdeps/generic/xstat.c (__xstat): Likewise.
	* sysdeps/generic/xstat64.c (__xstat64): Likewise.
	* sysdeps/mach/hurd/dl-sysdep.c (__xstat64, __fxstat64): Likewise.
	* sysdeps/mach/hurd/fxstat.c (__fxstat): Likewise.
	* sysdeps/mach/hurd/fxstat64.c (__fxstat64): Likewise.
	* sysdeps/mach/hurd/lxstat.c (__lxstat): Likewise.
	* sysdeps/mach/hurd/lxstat64.c (__lxstat64): Likewise.
	* sysdeps/mach/hurd/xstat.c (__xstat): Likewise.
	* sysdeps/mach/hurd/xstat64.c (__xstat64): Likewise.
	* sysdeps/unix/fxstat.c (__fxstat): Likewise.
	* sysdeps/unix/common/lxstat.c (__lxstat): Likewise.
	* sysdeps/unix/sysv/aix/fxstat.c (__fxstat): Likewise.
	* sysdeps/unix/sysv/aix/fxstat64.c (__fxstat64): Likewise.
	* sysdeps/unix/sysv/aix/lxstat.c (__lxstat): Likewise.
	* sysdeps/unix/sysv/aix/lxstat64.c (__lxstat64): Likewise.
	* sysdeps/unix/sysv/aix/xstat.c (__xstat): Likewise.
	* sysdeps/unix/sysv/aix/xstat64.c (__xstat64): Likewise.
	* sysdeps/unix/sysv/linux/ia64/fxstat.c (__fxstat): Likewise.
	* sysdeps/unix/sysv/linux/ia64/lxstat.c (__lxstat): Likewise.
	* sysdeps/unix/sysv/linux/ia64/xstat.c (__xstat): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/fxstat.c (__fxstat): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/lxstat.c (__lxstat): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/xstat.c (__xstat): Likewise.
	* sysdeps/unix/sysv/linux/i386/fxstat.c (__fxstat): Likewise.
	* sysdeps/unix/sysv/linux/i386/lxstat.c (__lxstat): Likewise.
	* sysdeps/unix/sysv/linux/i386/xstat.c (__xstat): Likewise.
	* sysdeps/unix/sysv/linux/xstat.c (__xstat): Likewise.
	* sysdeps/unix/sysv/linux/xstat64.c (__xstat64): Likewise.
	* sysdeps/unix/sysv/linux/fxstat.c (__fxstat): Likewise.
	* sysdeps/unix/sysv/linux/fxstat64.c (__fxstat64): Likewise.
	* sysdeps/unix/sysv/linux/lxstat.c (__lxstat): Likewise.
	* sysdeps/unix/sysv/linux/lxstat64.c (__lxstat64): Likewise.
	* sysdeps/unix/xstat.c (__xstat): Likewise.

	* include/sys/statvfs.h (statvfs, fstatvfs): Add libc_hidden_proto.
	* sysdeps/generic/statvfs.c (statvfs): Add libc_hidden_def.
	* sysdeps/generic/fstatvfs.c (fstatvfs): Likewise.
	* sysdeps/mach/hurd/statvfs.c (statvfs): Likewise.
	* sysdeps/mach/hurd/fstatvfs.c (fstatvfs): Likewise.
	* sysdeps/unix/sysv/linux/statvfs.c (statvfs): Likewise.
	* sysdeps/unix/sysv/linux/fstatvfs.c (fstatvfs): Likewise.

	* include/unistd.h (tcgetpgrp): Add libc_hidden_proto.
	* include/termios.h (tcsetattr, cfsetispeed, cfsetospeed): Likewise.
	* sysdeps/generic/tcgetpgrp.c (tcgetpgrp): Add libc_hidden_def.
	* sysdeps/generic/tcsetattr.c (tcsetattr): Likewise.
	* sysdeps/generic/speed.c (cfsetispeed, cfsetospeed): Likewise.
	* sysdeps/unix/bsd/bsd4.4/tcsetattr.c (tcgetpgrp): Likewise.
	* sysdeps/unix/bsd/sun/sunos4/tcsetattr.c (tcsetattr): Likewise.
	* sysdeps/unix/bsd/sun/sunos4/speed.c (cfsetispeed, cfsetospeed):
	Likewise.
	* sysdeps/unix/bsd/tcgetpgrp.c (tcgetpgrp): Likewise.
	* sysdeps/unix/bsd/tcsetattr.c (tcsetattr): Likewise.
	* sysdeps/unix/sysv/aix/tcsetattr.c (tcsetattr): Likewise.
	* sysdeps/unix/sysv/aix/speed.c (cfsetispeed, cfsetospeed): Likewise.
	* sysdeps/unix/sysv/linux/tcsetattr.c (tcsetattr): Likewise.
	* sysdeps/unix/sysv/linux/speed.c (cfsetispeed, cfsetospeed): Likewise.
	* sysdeps/unix/sysv/tcgetpgrp.c (tcgetpgrp): Likewise.
	* sysdeps/unix/sysv/tcsetattr.c (tcsetattr): Likewise.

	* include/string.h (strcoll): Add libc_hidden_proto.
	* string/strcoll.c (strcoll): Add libc_hidden_def.

	* misc/err.c (vwarn): Fix pasto in libc_hidden_def.

2002-08-11  Philip Blundell  <philb@gnu.org>

	* sysdeps/arm/Makefile: New file.

2002-08-08  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (parse_reg_exp): If '|' is immediately followed
	by another '|', end of regex or enclosing ')', clear branch.
	* posix/bug-regex9.c: New test.
	* posix/Makefile (tests): Add bug-regex9.

2002-08-12  Roland McGrath  <roland@redhat.com>

	* sysdeps/generic/dl-tls.c (_dl_allocate_tls_init): Fix inner loop
	start count condition, use TOTAL instead of variable that was never
	set.  Fix outer loop termination condition to TOTAL >= after update.

	* sysdeps/generic/libc-tls.c (__libc_setup_tls): Initialize
	dl_tls_static_align and dl_tls_static_nelem.

2002-08-11  Roland McGrath  <roland@redhat.com>

	* elf/tst-tlsmod4.c (in_dso): Insert a random library call before use
	of the TLS macros, otherwise the compiler might not have initialized
	the PIC register yet when we use the PLT via asm.
	* elf/tst-tlsmod3.c (in_dso2): Likewise.
	* elf/tst-tlsmod2.c (in_dso): Likewise.

	* sunrpc/svc_authux.c (_svcauth_unix): Remove spurious printf (ugh!).

	* sysdeps/i386/bits/byteswap.h (__bswap_16, __bswap_32, __bswap_64):
	Evaluate argument exactly once.  Remove __volatile__ from asm's.

	* include/unistd.h: Use libc_hidden_proto for getdomainname
	and getlogin_r.
	* sysdeps/generic/getdomain.c: Add libc_hidden_def.
	* sysdeps/mach/hurd/getdomain.c: Likewise.
	* sysdeps/unix/getlogin_r.c: Likewise.
	* sysdeps/mach/hurd/getlogin_r.c: Likewise.
	* sysdeps/generic/getlogin_r.c: Likewise.

	* include/rpc/auth_des.h: Use libc_hidden_proto for rtime.
	* sunrpc/rtime.c: Add libc_hidden_def.

	* include/string.h: Use libc_hidden_proto for basename.
	* string/basename.c [_LIBC]: Add libc_hidden_def.

	* sysdeps/unix/sysv/linux/opensock.c (__opensock): socket -> __socket.

	* locale/loadarchive.c: munmap -> __munmap throughout.

	* include/netdb.h: Use libc_hidden_proto for gai_strerror.
	* sysdeps/posix/gai_strerror.c: Add libc_hidden_def.
	* sysdeps/generic/gai_strerror.c: Likewise.

	* include/sys/errno.h: New file.

	* include/signal.h: No libc_hidden_proto for raise,
	__libc_current_sigrtmin, __libc_current_sigrtmax.
	These need to be overridden by linuxthreads.
	* sysdeps/posix/raise.c: Reverted.
	* sysdeps/generic/raise.c: Reverted.
	* signal/allocrtsig.c: Reverted.

	* locale/loadarchive.c (LOCALEDIR): Remove debugging defn.  Oops.

2002-08-10  Roland McGrath  <roland@redhat.com>

	* locale/loadarchive.c (_nl_archive_subfreeres): New function.
	* locale/localeinfo.h: Declare it.
	* locale/setlocale.c (free_mem): Don't call _nl_unload_locale on the
	current locale if it's not in the file list.
	Call _nl_archive_subfreeres.

2002-08-10  Andreas Jaeger  <aj@suse.de>

	* sysdeps/i386/strchr.S: Add comment.

2002-08-10  Roland McGrath  <roland@redhat.com>

	* include/wchar.h (putwc): Use libc_hidden_proto.
	* include/stdio.h (dprintf, fprintf, vfprintf, sprintf,
	sscanf, fwrite, perror, remove, rewind, open_memstream): Likewise.
	* stdio-common/dprintf.c: Add libc_hidden_def.
	* stdio-common/fprintf.c: Likewise.
	* stdio-common/sprintf.c: Likewise.
	* stdio-common/sscanf.c: Likewise.
	* libio/iofwrite.c: Likewise.
	* libio/memstream.c: Likewise.
	* libio/putwc.c: Likewise.
	* stdio-common/perror.c: Likewise.
	* sysdeps/posix/remove.c: Likewise.
	* sysdeps/generic/remove.c: Likewise.
	* libio/rewind.c: Likewise.  Use <stdio.h> instead of "stdio.h".
	* stdio-common/vfprintf.c: Add libc_hidden_def.  Include <stdio.h>.

2002-08-09  Jakub Jelinek  <jakub@redhat.com>

	* include/wctype.h (iswalpha, iswdigit, iswlower, iswspace, iswxdigit,
	towlower, towupper): Add prototypes here too.  Add libc_hidden_proto.
	* wctype/wcfuncs.c (iswalpha, iswdigit, iswlower, iswspace, iswxdigit,
	towlower, towupper): Add libc_hidden_weak.

	* include/bits/dlfcn.h: New file.
	* elf/dl-profstub.c (_dl_mcount_wrapper_check): Add libc_hidden_def.

	* include/grp.h (_nss_files_parse_grent): Add libc_hidden_proto.
	* include/netinet/ether.h (_nss_files_parse_etherent): Likewise.
	* include/rpc/netdb.h (_nss_files_parse_rpcent): Likewise.
	* include/pwd.h (_nss_files_parse_pwent): Likewise.
	* include/shadow.h (_nss_files_parse_spent): Likewise.
	* include/netdb.h (_nss_files_parse_protoent,
	_nss_files_parse_servent, _nss_files_parse_netent): Likewise.
	* nss/nss_files/files-parse.c (nss_files_parse_hidden_def): Define.
	(LINE_PARSER): Use it.
	* nss/nsswitch.h (__nss_hostname_digits_dots): Add libc_hidden_proto.
	* nss/digits_dots.c (__nss_hostname_digits_dots): Add libc_hidden_def.

	* libio/oldiopopen.c: Move #if SHLIB_COMPAT after _IO_HAVE_SYS_WAIT
	#endif.

	* manual/debug.texi (%MENU%): Remove trailing dot.
	Reported by <hayastan132@hotmail.com>.

	* sysdeps/unix/sysv/linux/ia64/syscalls.list (llseek): Add lseek
	aliases.
	(lseek): Dummy.
	* sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list (llseek, lseek):
	Likewise.

2002-08-09  Roland McGrath  <roland@redhat.com>

	* locale/loadarchive.c (_nl_load_locale_from_archive): Parse locale
	name to find codeset name (if any) and normalize it.  If the
	normalized name differs, look up only that in the archive.
	* locale/programs/locarchive.c (add_locale_to_archive): If the name
	contains a codeset, normalize the codeset store only the normalized
	name in the archive.  If not, add an alias containing the locale's
	normalized codeset name.  Apply codeset name normalization when
	matching entries in the alias file.

	* locale/programs/locarchive.c (delete_locales_from_archive): Don't
	decrement HEAD->namehash_used here.
	(add_locale): Only need to insert name string when name_offset != 0.

	* locale/programs/localedef.c (options): Add -A/--alias-file.
	(alias_file): New variable.
	(parse_opt): Grok -A, set that.
	* locale/programs/localedef.h: Declare it.

	* locale/locarchive.h (struct locrecent): Add `refs' member.
	* locale/programs/locarchive.c (insert_name): New function, broken out
	of ...
	(add_locale_to_archive): ... here.  Call that.
	(add_alias): New function.
	(add_locale): New static function, add_locale_to_archive renamed.
	(add_locale_to_archive): Call that and use add_alias to add an alias
	for the name with codeset if the given name lacks it.
	(enlarge_archive): Call add_locale instead of add_locale_to_archive.

	* locale/Makefile (routines): Add loadarchive.
	* locale/loadarchive.c: New file, started from code by Ulrich Drepper.
	(_nl_load_locale_from_archive): New function.
	* locale/localeinfo.h: Declare it.
	* locale/findlocale.c (_nl_find_locale): If using default locale path,
	try _nl_load_locale_from_archive first.

	* locale/loadlocale.c (_nl_intern_locale_data): New function,
	broken out of _nl_load_locale.
	(_nl_load_locale): Call that.
	* locale/localeinfo.h: Declare it.
	(struct locale_data): Replace member `mmaped' with `alloc', an enum.
	(struct locale_data): Remove unused member `options'.
	* locale/findlocale.c (_nl_remove_locale): Update uses.
	* locale/loadlocale.c (_nl_load_locale, _nl_unload_locale): Likewise.
	* locale/C-collate.c: Update initializer.
	* locale/C-identification.c: Likewise.
	* locale/C-measurement.c: Likewise.
	* locale/C-telephone.c: Likewise.
	* locale/C-address.c: Likewise.
	* locale/C-name.c: Likewise.
	* locale/C-paper.c: Likewise.
	* locale/C-time.c: Likewise.
	* locale/C-numeric.c: Likewise.
	* locale/C-monetary.c: Likewise.
	* locale/C-messages.c : Likewise.
	* locale/C-ctype.c: Likewise.

	* locale/hashval.h [! LONGBITS]: Include <limits.h> here and
	use CHAR_BIT instead of BITSPERBYTE.

	* locale/localeinfo.h (_nl_find_locale, _nl_load_locale,
	_nl_unload_locale): Add `internal_function attribute_hidden' to decls.
	* locale/findlocale.c (_nl_find_locale): Add internal_function to defn.
	(_nl_remove_locale): Likewise.
	* locale/loadlocale.c (_nl_load_locale, _nl_unload_locale): Likewise.

	* locale/findlocale.c (_nl_default_locale_path): New variable.
	(_nl_find_locale): If LOCALE_PATH is null, default to that.
	* locale/localeinfo.h: Declare it.
	* locale/setlocale.c (setlocale): Use _nl_default_locale_path
	in place of LOCALEDIR.  If no LOCPATH, pass null to _nl_find_locale.
	* locale/newlocale.c (__newlocale): Likewise.

	* misc/err.c (vwarnx, vwarn): Fix typos in libc_hidden_def uses.
	* inet/rexec.c (rexec_af): Add libc_hidden_def.
	* sysdeps/generic/morecore.c: Likewise.
	* signal/allocrtsig.c (__libc_current_sigrtmin): Likewise.
	(__libc_current_sigrtmax): Likewise.

2002-08-08  Roland McGrath  <roland@redhat.com>

	* locale/loadlocale.c (_nl_load_locale): Don't use MAP_INHERIT.
	* catgets/open_catalog.c (__open_catalog): Likewise.

	* locale/programs/locarchive.c (INITIAL_NUM_NAMES): Renamed
	from typo INITIAL_NUM_NANES.
	(create_archive): Update use.

2002-08-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/sigwait.c: New file.

2002-08-08  Roland McGrath  <roland@frob.com>

	* resolv/netdb.h: Don't declare h_errno as a plain global any more.

2002-08-08  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/wordsize-64/wcstol_l.c (wcstoll_l): Define to something
	else and undefine after including wcstol_l.c.
	* sysdeps/wordsize-64/wcstoul_l.c (wcstoull_l): Similarly.

2002-08-08  Ulrich Drepper  <drepper@redhat.com>

	* gmon/gmon.c (write_gmon): Use O_NOFOLLOW in open calls if available.

2002-08-08  Alexandre Oliva  <aoliva@redhat.com>

	* configure.in: Make the test for broken_alias_attribute stricter.

2002-05-24  Robert Love  <rml@tech9.net>

	* posix/Makefile (routines): Add sched_getaffinity and
	sched_setaffinity.
	* posix/sched.h: Add declarations for sched_getaffinity and
	sched_setaffinity.
	* sysdeps/generic/sched_getaffinity.c: New file.
	* sysdeps/generic/sched_setaffinity.c: New file.
	* sysdeps/unix/sysv/linux/syscalls.list: Add sched_getaffinity and
	sched_setaffinity.

2002-08-06  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/utime.c: If TIMES is NULL pass it through to utimes.

2002-08-07  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c (_dl_map_object_from_fd): Add missing \n in error
	message.

	* stdlib/isomac.c (get_null_defines): Treat NOT_IN_libc special.
	It is known to be defined.

	* include/string.h: Define index and rindex only if _ISOMAC is not
	defined.

	* elf/rtld.c: Include <errno.h>.
	* sysdeps/generic/libc-tls.c: Likewise.

2002-08-07  Roland McGrath  <roland@redhat.com>

	* resolv/res_debug.c (latlon2ul): Add const to argument type, and use
	it internally.
	(precsize_aton): Likewise.

	* inet/getnetgrent_r.c (endnetgrent, __getnetgrent_r): Actually call
	the static symbols added in the last change (doofus is me).

	* locale/newlocale.c (__newlocale): Use a bit mask instead of a second
	loop to notice missing categories in a composite name.

	* locale/locale.h (LC_CTYPE_MASK, LC_NUMERIC_MASK, LC_TIME_MASK,
	LC_COLLATE_MASK, LC_MONETARY_MASK, LC_MESSAGES_MASK, LC_ALL_MASK,
	LC_PAPER_MASK, LC_NAME_MASK, LC_ADDRESS_MASK, LC_TELEPHONE_MASK,
	LC_MEASUREMENT_MASK, LC_IDENTIFICATION_MASK, LC_ALL_MASK): New macros.

2002-08-07  Ulrich Drepper  <drepper@redhat.com>

	* malloc/tst-calloc.c: Add tests for one or both parameters being zero.

2002-08-07  Roland McGrath  <roland@redhat.com>

	* sysdeps/i386/dl-machine.h (elf_machine_rel): Add to, don't clobber,
	unrelocated initial value for DTPOFF32 and TPOFF32 relocs.
	Reported by Jakub Jelinek  <jakub@redhat.com>.

2002-08-07  Jakub Jelinek  <jakub@redhat.com>

	* malloc/malloc.c (public_cALLOc): Check ELEM_SIZE != 0 before
	division.

2002-08-06  Roland McGrath  <roland@redhat.com>

	* include/getopt.h: Put private decls inside [_GETOPT_H].
	Use libc_hidden_proto for getopt_long, getopt_long_only.
	* posix/getopt1.c [_LIBC]: Include <getopt.h> instead of "getopt.h".
	Add libc_hidden_def.

	* sysdeps/generic/unwind-dw2-fde-glibc.c [_LIBC] (dl_iterate_phdr):
	Define as a macro for __dl_iterate_phdr.

	* inet/getnetgrent_r.c (internal_setnetgrent): Renamed from __ name,
	made static.  Add __ name as a strong alias.
	(internal_endnetgrent): Likewise.
	(internal_getnetgrent_r): Likewise.

	* locale/Versions (libc: GLIBC_2.3): Add all the *_l functions
	with no __ prefix.
	* locale/langinfo.h [__USE_GNU]: Declare nl_langinfo_l.
	* ctype/ctype.h [__USE_GNU]: Add declarations and macros for
	all *_l functions with no __ prefix.
	* wctype/wcfuncs_l.c: Define weak aliases without __ for all fns.
	* ctype/ctype_l.c: Likewise.
	* locale/nl_langinfo.c: Likewise.
	* string/string.h [__USE_GNU]: Add decls for all *_l fns with no __.
	* stdlib/stdlib.h [__USE_GNU]: Likewise.
	* wcsmbs/wchar.h [__USE_GNU]: Likewise.
	* wctype/wctype.h [__USE_GNU]: Likewise.
	* string/strcoll_l.c (strcoll_l): Define as weak alias.
	* string/strxfrm_l.c (strxfrm_l): Define as weak alias.
	* sysdeps/generic/strcasecmp_l.c (strcasecmp_l): Define as weak alias.
	* sysdeps/generic/strncase_l.c (strncasecmp_l): Define as weak alias.
	* stdlib/strtod_l.c (strtod_l): Define as weak alias.
	* stdlib/strtof_l.c (strtof_l): Define as weak alias.
	* stdlib/strtold_l.c (strtold_l): Define as weak alias.
	* wcsmbs/wcscasecmp_l.c (wcscasecmp_l): Define as weak alias.
	(__wcscasecmp_l): Add libc_hidden_def.
	* wcsmbs/wcsncase_l.c (wcsncasecmp_l): Define as weak alias.
	(__wcsncasecmp_l): Add libc_hidden_def.
	* wcsmbs/wcstof_l.c (wcstof_l): Define as weak alias.
	* wcsmbs/wcstod_l.c (wcstod_l): Define as weak alias.
	* wcsmbs/wcstold_l.c (wcstold_l): Define as weak alias.
	* wcsmbs/wcscoll_l.c (wcscoll_l): Define as weak alias.
	* wcsmbs/wcsxfrm_l.c (wcsxfrm_l): Define as weak alias.
	* sysdeps/generic/wcstol_l.c (wcstol_l): Define as weak alias.
	* sysdeps/generic/wcstoll_l.c (wcstoll_l): Define as weak alias.
	* sysdeps/generic/wcstoul_l.c (wcstoul_l): Define as weak alias.
	* sysdeps/generic/wcstoull_l.c (wcstoull_l): Define as weak alias.
	* sysdeps/wordsize-64/wcstol_l.c (wcstoll_l): Define as weak alias.
	* sysdeps/wordsize-64/wcstoul_l.c (wcstoull_l): Define as weak alias.
	* wctype/wctrans_l.c (wctrans_l) Define as weak alias.
	* wctype/towctrans_l.c (towctrans_l) Define as weak alias.
	* wctype/wctype_l.c (wctype_l) Define as weak alias.

2002-08-05  Roland McGrath  <roland@redhat.com>

	* include/rpc/auth.h: Use libc_hidden_proto for getnetname,
	netname2user, host2netname, user2netname, key_gendes.
	* sunrpc/netname.c: Add libc_hidden_def.
	* sunrpc/key_call.c: Likewise.

	* include/netdb.h: Use libc_hidden_proto for getaddrinfo, getnameinfo,
	freeaddrinfo.
	* inet/getnameinfo.c: Add libc_hidden_def.
	* sysdeps/generic/getaddrinfo.c: Likewise.
	* sysdeps/posix/getaddrinfo.c: Likewise.

	* include/wchar.h: Use libc_hidden_proto for wmemchr, wmemset.
	* wcsmbs/wmemchr.c: Add libc_hidden_def.
	* wcsmbs/wmemset.c: Add libc_hidden_def.

	* include/string.h: Move libc_hidden_proto's inside #ifndef _STRING_H.
	(index, rindex): Define as macros for strchr, strrchr.

	* string/envz.c (envz_strip): index -> strchr

	* include/rpc/rpc_msg.h: Use libc_hidden_proto for _seterr_reply.
	* sunrpc/rpc_prot.c: Add libc_hidden_def.

	* include/wchar.h: Use libc_hidden_proto for mbrtowc.
	* wcsmbs/mbrtowc.c: Add libc_hidden_weak.

	* include/stdlib.h: Use libc_hidden_proto for wctomb.
	* stdlib/wctomb.c: Add libc_hidden_def.

	* include/netdb.h: Use libc_hidden_proto for innetgr, rcmd_af,
	rexec_af, rresvport_af, ruserok_af, iruserok_af, ruserpass, hstrerror.
	* resolv/herror.c: Likewise.
	* inet/rcmd.c: Add libc_hidden_def.
	* inet/ruserpass.c: Likewise.
	* inet/getnetgrent_r.c: Likewise.

	* include/rpc/svc.h: Use libc_hidden_proto for svc_register,
	svc_unregister, remove *_internal decls.  Use libc_hidden_proto
	for svcerr_auth, svcerr_noprog, svcerr_progvers.
	* sunrpc/svc.c (svc_register, svc_unregister): Change INTDEF to
	libc_hidden_def.
	(svcerr_auth, svcerr_noprog, svcerr_progvers): Add libc_hidden_def.
	* sunrpc/svc_simple.c (registerrpc): Nix INTUSE for svc_register.

	* sysdeps/posix/system.c (do_system): New function, guts broken out of
	__libc_system.
	(__libc_system): Call it, putting just the line == NULL test here.

	* include/libc-symbols.h (__hidden_proto): Add extern keywords so
	variables work right.

	* elf/dl-open.c (dl_open_worker): Use _ macro instead of gettext.
	* elf/dl-close.c (_dl_close): Likewise.

	* include/netinet/in.h: Use libc_hidden_proto for bindresvport,
	in6addr_any, in6addr_loopback.  Remove decls for
	bindresvport_internal, in6addr_any_internal, in6addr_loopback_internal.
	* sunrpc/svc_udp.c (svcudp_bufcreate): Nix INTUSE for bindresvport.
	* sunrpc/svc_tcp.c (svctcp_create): Likewise.
	* sunrpc/clnt_udp.c (clntudp_bufcreate): Likewise.
	* sunrpc/bindrsvprt.c: Change INTDEF to libc_hidden_def.
	* inet/in6_addr.c: Change INTVARDEF to libc_hidden_def.
	* sysdeps/posix/getaddrinfo.c (gaih_inet): Nix INTUSE for
	in6addr_loopback.
	* inet/gethstbyad_r.c (PREPROCESS): Nix INTUSE for in6addr_any.

	* include/netinet/ether.h: Use libc_hidden_proto for ether_ntoa_r,
	ether_aton_r.
	* inet/ether_aton_r.c: Add libc_hidden_def.
	* inet/ether_ntoa_r.c: Likewise.

	* include/rpc/svc.h: Use libc_hidden_proto for xprt_register,
	xprt_unregister.
	* sunrpc/svc.c: Add libc_hidden_def.
	* include/rpc/pmap_clnt.h: Use libc_hidden_proto for pmap_getport,
	pmap_set, pmap_unset.
	* sunrpc/pmap_clnt.c: Add libc_hidden_def.
	* sunrpc/pm_getport.c: Likewise.
	* include/rpc/auth_des.h: Use libc_hidden_proto for getpublickey.
	* sunrpc/publickey.c: Add libc_hidden_def.

2002-08-05  Ulrich Drepper  <drepper@redhat.com>

	* elf/rtld.c (_dl_start): Don't use memset.  Use same tricks as for
	the other memset call in this function.

	* sysdeps/generic/dl-tls.c (_dl_allocate_tls_init): Store dtv pointer
	at correct index.  Clear BSS region now that memalign is used.

2002-08-05  Roland McGrath  <roland@redhat.com>

	* include/sys/utsname.h: Use libc_hidden_proto for uname, __uname.
	* sysdeps/generic/uname.c: Add libc_hidden_def.
	* sysdeps/mach/hurd/uname.c: Likewise.

2002-08-05  Jakub Jelinek  <jakub@redhat.com>

	* include/wchar.h (wcrtomb, wcscmp, wcsftime, wcsspn, wcschr, wcscoll,
	wcspbrk): Add libc_hidden_proto.
	* time/strftime.c (my_strftime): Add libc_hidden_def.
	(strftime): Remove libc_hidden_def.
	* wcsmbs/wcschr.c (wcschr): Add libc_hidden_def.
	* wcsmbs/wcspbrk.c (wcspbrk): Likewise.
	* wcsmbs/wcsspn.c (wcsspn): Likewise.
	* wcsmbs/wcscmp.c (wcscmp): Likewise.
	* wcsmbs/wcrtomb.c (wcrtomb): Add libc_hidden_weak.
	* wcsmbs/wcscoll.c (wcscoll): Likewise.

	* include/rpc/rpc.h (__rpc_thread_svc_max_pollfd,
	__rpc_thread_svc_pollfd, __rpc_thread_svc_fdset,
	__rpc_thread_createerr): Add libc_hidden_proto.
	* sunrpc/rpc_thread.c (__rpc_thread_svc_max_pollfd,
	__rpc_thread_svc_pollfd, __rpc_thread_svc_fdset,
	__rpc_thread_createerr): Add libc_hidden_def.

	* include/rpc/clnt.h (clnt_sperrno, clnt_spcreateerror,
	clnt_perror, clnt_sperror, _rpc_dtablesize): Add libc_hidden_proto.
	* sunrpc/clnt_perr.c (clnt_sperrno, clnt_spcreateerror,
	clnt_perror, clnt_sperror): Add libc_hidden_def.
	* sunrpc/rpc_dtable.c (_rpc_dtablesize): Likewise.

	* include/rpc/des_crypt.h (des_setparity, ecb_crypt, cbc_crypt): Add
	libc_hidden_proto.
	* sunrpc/des_crypt.c (ecb_crypt, cbc_crypt): Add libc_hidden_proto.
	* sunrpc/des_soft.c (des_setparity): Likewise.

	* include/rpc/auth.h (key_encryptsession_pk, key_decryptsession_pk):
	Add libc_hidden_proto.
	* sunrpc/key_call.c (key_encryptsession_pk, key_decryptsession_pk):
	Add libc_hidden_def.

2002-08-05  Roland McGrath  <roland@redhat.com>

	* sysdeps/generic/ldsodefs.h (struct rtld_global): Replace member
	`bool _dl_initial_dtv_malloced' with `void *_dl_initial_dtv'.
	* elf/rtld.c (dl_main): Set it to the new dtv for the main thread.
	* sysdeps/generic/dl-tls.c (__tls_get_addr): When reallocating the
	dtv, check if it matches _dl_initial_dtv; if so, malloc and copy the
	old data, abandoning the original memory allocated by rtld at startup,
	instead of calling realloc normally.

2002-08-05  Ulrich Drepper  <drepper@redhat.com>

	* po/fr.po: Update from translation team.

2002-08-04  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/make-syscalls.sh: If the syscall name field is -
	then generate a dummy module under the given name, obeying the
	normal rules for the "caller" field.

	* sysdeps/generic/libc-tls.c (__libc_setup_tls): Make the phdr loop
	actually iterate over the elements.  Fix typo p_type -> p_vaddr.

	* include/pthread.h: Don't declare __pthread_initialize_minimal as
	weak here; we declare it weak or strong in the one place we use it.
	* sysdeps/generic/libc-start.c: ... which is here.
	Don't make the decl weak if [USE_TLS], since static programs need TLS
	setup even when single-threaded.

	* stdlib/isomac.c (fmt): Add -DNOT_IN_libc to the compiler command.

	* elf/Makefile (test-srcs): Add $(modules-names) to it.
	(CFLAGS-vismod2.c, CFLAGS-failobj.c, CFLAGS-constload2.c,
	CFLAGS-reldepmod3.c, CFLAGS-reldepmod4.c, CFLAGS-ltglobmod2.c): Remove
	all these variables.

2002-08-04  Ulrich Drepper  <drepper@redhat.com>

	* include/stdio.h: Don't define macro magic to redirect function
	calls if _ISOMAC is defined.

	* sysdeps/i386/fpu/libm-test-ulps: Add epsilons for inlined
	ldouble asin tests.

2002-08-04  Roland McGrath  <roland@redhat.com>

	* stdlib/lrand48_r.c: Add libc_hidden_def.

	* sysdeps/generic/dl-tls.c (_dl_allocate_tls_storage): Allocate the
	TCB with __libc_memalign instead of mmap.
	(_dl_deallocate_tls): Free it with free instead of munmap.

	* Makerules (cpp-srcs-left): When setting this to run
	cppflags-iterator.mk, must append .c to $(tests) and $(xtests)
	words.  Combine the two loops into one on the concatenated list,
	including those as well as $(test-srcs).

	* elf/dl-minimal.c (__libc_memalign): Guts of malloc moved here,
	since we align here with optimally minimal waste anyway.
	(malloc): Just call that.

	* sysdeps/generic/libc-tls.c (__libc_setup_tls): Set l_tls_offset to
	the right variable.

	* elf/dl-load.c (_dl_map_object_from_fd): Use p_vaddr, not p_offset,
	to compute memory location for l_tls_initimage.
	* elf/rtld.c (_dl_start): Likewise.
	* sysdeps/generic/libc-tls.c (__libc_setup_tls): Likewise.

	* libio/oldiopopen.c: Move #include's before #if SHLIB_COMPAT,
	because the .d file is generated in the non-shared case and
	so fails to catch them otherwise.

	* sysdeps/generic/dl-tls.c (_dl_allocate_tls_storage): New function,
	split out of _dl_allocate_tls.
	(_dl_allocate_tls_init): Likewise.
	(_dl_allocate_tls): Call those.
	* sysdeps/generic/ldsodefs.h: Declare them with attribute_hidden.
	* elf/rtld.c (dl_main): Call them separately instead of calling
	_dl_allocate_tls.  Delay _dl_allocate_tls_init until after relocation
	is finished, so that the initializer data has been relocated before we
	copy it into the main thread's TLS block.

	* sysdeps/generic/dl-tls.c (_dl_allocate_tls): Fix off-by-one error in
	loop conditions, prevented the last used module from being initialized.

2002-08-04  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/generic/glob.c (glob, globfree): Only use libc_hidden_def
	if glob resp. globfree are not macros.
	* sysdeps/gnu/glob64.c (globfree64): Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/alpha/glob.c (glob, globfree, globfree64):
	Add libc_hidden_ver.
	* sysdeps/unix/sysv/linux/i386/glob64.c (globfree64): Add
	libc_hidden_def.
	* sysdeps/wordsize-64/glob.c (globfree64): Use libc_hidden_ver
	instead of libc_hidden_weak.
	* sysdeps/wordsize-64/strtol.c (__strtoll_internal): Use
	libc_hidden_ver instead of libc_hidden_def.
	* sysdeps/wordsize-64/wcstol.c (__wcstoll_internal): Use
	libc_hidden_ver instead of libc_hidden_def.
	(wcstoll, wcstoq): Remove libc_hidden_weak.
	* sysdeps/wordsize-64/strtol_l.c (____strtoll_l_internal): Add
	libc_hidden_ver.
	* sysdeps/wordsize-64/strtoul.c (__strtoull_internal): Add
	libc_hidden_ver.
	* sysdeps/wordsize-64/strtoul_l.c (____strtoull_l_internal): Add
	libc_hidden_ver.
	* sysdeps/wordsize-64/wcstoul.c (__wcstoull_internal): Add
	libc_hidden_ver.

2002-08-04  Ulrich Drepper  <drepper@redhat.com>

	* stdio-common/psignal.c: Declare _sys_siglist_internal.  Use USEINT
	to access _sys_siglist.
	* string/strsignal.c: Likewise.
	* sysdeps/generic/siglist.c: Add _sys_siglist_internal alias.
	* sysdeps/gnu/siglist.c: Likewise.
	* sysdeps/unix/siglist.c: Likewise.
	* sysdeps/unix/sysv/linux/arm/siglist.c: Likewise.

	* libio/fileops.c: Add missing INTUSEs for _IO_file_jumps.

	* libio/wfileops.c: Add missing INTUSE for _IO_file_close.

	* intl/dcigettext.c: Define _nl_default_dirname_internal as hidden
	alias and use it.
	* intl/bindtextdom.c: Use _nl_default_dirname_internal.

	* include/netinet/in.h: Add declaration of in6addr_loopback_internal.
	* inet/in6_addr.c: Add INTVARDEF for in6addr_loopback.
	* sysdeps/posix/getaddrinfo.c: Use INTUSE for in6addr_loopback access.

	* include/time.h: Add libc_hidden_proto for __gmtime_r.
	* time/gmtime.c (__gmtime_r): Add libc_hidden_def.

	* iconv/Versions: Replace __gconv_alias_db, __gconv_modules_db,
	and __gconv_cache with __gconv_get_alias_db, __gconv_get_modules_db,
	and __gconv_get_cache respectively.
	* iconv/gconv_cache.c (gconv_cache): Renamed for __gconv_cache and
	defined static.  Change all users.
	(__gconv_get_cache): New function.
	* iconv/gconv_db.c (__gconv_get_modules_db): New function.
	(__gconv_get_alias_db): New function.
	* iconv/gconv_int.h (__gconv_alias_db): Declare as hidden.
	(__conv_modules_db): Likewise.
	Add prototypes for __gconv_get_cache, __gconv_get_modules_db,
	and __gconv_get_alias_db.
	* iconv/iconv_prog.c: Use the new functions instead of accessing the
	variables.

	* include/stdlib.h: Add prototype and libc_hidden_proto for
	__default_morecore.
	* sysdeps/generic/morecore.c: Include <stdlib.h>.

	* malloc/obstack.c: Remove fputs macro.

	* malloc/mtrace.c: Remove fopen macro.

2002-08-04  Jakub Jelinek  <jakub@redhat.com>

	* manual/debug.texi: Fix spelling to programmatically.
	Reported by <hayastan132@hotmail.com>.

2002-08-04  Ulrich Drepper  <drepper@redhat.com>

	* include/libio.h: Add libc_hidden_proto for __uflow.
	* include/stdio.h: Map fopen, fdopen, fclose, fputs, fsetpos, and
	fgetpos to _IO_* names.
	Add libc_hidden_proto for fileno, fwrite, fseek, fflush_unlocked,
	fread_unlocked, fwrite_unlocked, fgets_unlocked, fputs_unlocked.
	* include/wchar.h: Add libc_hidden_proto for fputws_unlocked,
	putwc_unlocked, vswscanf.
	* libio/iolibio.h: Add libc_hidden_proto for _IO_fputs.
	* libio/fileno.c: Use <stdio.h> and libc_hidden_def.
	* libio/fseek.c: Likewise.
	* libio/fmemopen.c: Include "libioP.h".  Call _IO_fopencookie and
	not fopencookie.
	* libio/genops.c (__uflow): Add libc_hidden_def.
	* libio/iofflush_u.c (fflush_unlocked): Likewise.
	* libio/iofgets_u.c (fgets_unlocked): Likewise.
	* libio/iofputs_u.c (fputs_unlocked): Likewise.
	* libio/iofputws_u.c (fputws_unlocked): Likewise.
	* libio/iofread_u.c (fread_unlocked): Likewise.
	* libio/iofwrite_u.c (fwrite_unlocked): Likewise.
	* libio/iovswscanf.c (vswscanf): Likewise.
	* libio/putwc_u.c (putwc_unlocked): Likewise.
	* libio/iofputs.c: Use libc_hidden_def instead of INTDEF.
	* malloc/malloc.c: Redirect fwrite calls to _IO_fwrite.
	* malloc/mtrace.c: Likewise.

	* sunrpc/clnt_perr.c: Remove fputs macro.
	* sunrpc/svc_simple.c: Likewise.
	* sunrpc/svc_tcp.c: Likewise.
	* sunrpc/svc_udp.c: Likewise.
	* sunrpc/xdr_rec.c: Likewise.
	* sunrpc/xdr_ref.c: Likewise.

	* iconv/Makefile: Add CPPFLAGS definitions with -DNOT_in_libc for
	iconv_prog, linereader, and charmap-dir.
	* locale/Makefile: Likewise for locale and charmap-dir.
	* malloc/Makefile: Likewise for memusagestat.
	* nscd/Makefile: Likewise for nscd, nscd_conf, and dbg_log.
	* sunrpc/Makefile: Likewise for rpc_main.
	* sysdeps/unix/sysv/linux/Makefile: Likewise for lddlibc4.
	* timezone/Makefile: Likewise for zic.

	* stdio-common/perror.c: Avoid multiple calls to fileno_unlocked.

	* elf/dl-addr.c (_dl_addr): Add libc_hidden_def.
	* elf/dl-close.c (_dl_close): Add libc_hidden_def.
	* elf/dl-open.c (_dl_open): Add libc_hidden_def.
	* include/dlfcn.h: Add libc_hidden_proto for _dl_addr, _dl_open,
	_dl_close.

	* include/libio.h: Add libc_hidden_proto for __underflow, __wuflow,
	__wunderflow.
	* libio/genops.c (__underflow): Add libc_hidden_def.
	* libio/wgenops.c (__wuflow): Likewise.
	(__wunderflow): Likewise.

	* include/obstack.h: Add libc_hidden_proto for _obstack_newchunk.
	* malloc/obstack.c (_obstack_newchunk): Add libc_hidden_def.

	* include/stdio.h: Add libc_hidden_proto for __vfscanf.
	* stdio-common/vfscanf.c (__vfscanf): Add libc_hidden_def.

	* include/string.h: Add libc_hidden_proto for __strverscmp.
	* string/strverscmp.c (__strverscmp): Add libc_hidden_def.

	* include/unistd.h: Add libc_hidden_proto for __sysconf.
	* sysdeps/generic/sysconf.c (__sysconf): Add libc_hidden_def.
	* sysdeps/posix/sysconf.c: Likewise.
	* sysdeps/unix/sysv/irix4/sysconf.c: Likewise.
	* sysdeps/unix/sysv/sysv4/sysconf.c: Likewise.

	* include/wctype.h: Use libc_hidden_proto for __iswctype, __iswalnum_l,
	__iswalpha_l, __iswblank_l, __iswcntrl_l, __iswdigit_l, __iswlower_l,
	__iswgraph_l, __iswprint_l, __iswpunct_l, __iswspace_l, __iswupper_l,
	__iswxdigit_l, __towlower_l, __towupper_l.
	* wcsmbs/wcstype.c (__iswctype): Use libc_hidden_def.
	* wcsmbs/wcfuncs_l.c: Use libc_hidden_def for all functions.

	* include/sys/wait.h: Add libc_hidden_proto for __xmknod.
	* sysdeps/generic/xmknod.c (__xmknod): Add libc_hidden_def.
	* sysdeps/mach/hurd/xmknod.c: Likewise.
	* sysdeps/unix/xmknod.c: Likewise.
	* sysdeps/unix/sysv/linux/xmknod.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/xmknod.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/xmknod.c: Likewise.

	* sunrpc/svc.c: Add missing INTUSE for _authenticate.

2002-08-03  Roland McGrath  <roland@redhat.com>

	* include/sys/resource.h: Use libc_hidden_proto for getpriority,
	setpriority.
	* sysdeps/unix/sysv/linux/getpriority.c: Add libc_hidden_def.
	* sysdeps/unix/sysv/irix4/getpriority.c: Likewise.
	* sysdeps/unix/sysv/irix4/setpriority.c: Likewise.
	* sysdeps/mach/hurd/setpriority.c: Likewise.
	* sysdeps/mach/hurd/getpriority.c: Likewise.
	* sysdeps/generic/setpriority.c: Likewise.
	* sysdeps/generic/getpriority.c: Likewise.

	* include/mcheck.h: Use libc_hidden_proto for mcheck_check_all.
	* malloc/mcheck.c: Add libc_hidden_def.

	* include/search.h: Use libc_hidden_proto for hcreate_r, hdestroy_r.
	* misc/hsearch_r.c: Add libc_hidden_def.

	* include/fnmatch.h: Use libc_hidden_proto for fnmatch.
	* posix/fnmatch.c: Add libc_hidden_weak.

	* include/unistd.h: Use libc_hidden_proto for _exit, alarm, confstr,
	execl, execle, execlp, execvp, getpid, getsid.
	* sysdeps/generic/alarm.c: Add libc_hidden_def.
	* sysdeps/unix/alarm.c: Likewise.
	* posix/confstr.c: Likewise.
	* posix/execvp.c: Likewise.
	* posix/execlp.c: Likewise.
	* posix/execle.c: Likewise.
	* posix/execl.c: Likewise.
	* sysdeps/generic/getsid.c: Likewise.
	* sysdeps/mach/hurd/getsid.c: Likewise.
	* sysdeps/generic/getpid.c: Add libc_hidden_weak.
	* sysdeps/mach/hurd/getpid.c: Likewise.

	* include/stdlib.h: Use libc_hidden_proto for ecvt_r, fcvt_r,
	qecvt_r, qfcvt_r, lrand48_r.
	* misc/efgcvt_r.c: Add libc_hidden_def.

	* include/wordexp.h: Use libc_hidden_proto for wordfree.
	* sysdeps/generic/wordexp.c: Add libc_hidden_def.

	* include/langinfo.h: Use libc_hidden_proto for nl_langinfo.
	* locale/nl_langinfo.c: Add libc_hidden_def.

	* include/glob.h: Use libc_hidden_proto for glob, globfree, globfree64.
	* sysdeps/generic/glob.c: Add libc_hidden_def.
	* sysdeps/generic/glob64.c: Likewise.
	* sysdeps/wordsize-64/glob.c (globfree64): Add libc_hidden_weak.

	* locale/nl_langinfo.c: Use _NL_CURRENT_DATA.

	* elf/Makefile (CFLAGS-vismod2.c): New variable.

	* locale/setlocale.c (_nl_current_names): Variable moved ...
	* locale/localename.c (_nl_current_names): ... here, new file.
	Make it global, with attribute_hidden.
	* locale/localeinfo.h: Declare it.
	* locale/Makefile (aux): Add localename.
	* locale/localename.c (__current_locale_name): New function.
	* include/locale.h (__current_locale_name): Declare it.
	* intl/dcigettext.c (guess_category_value): Use that instead of
	calling setlocale.

	* locale/locale.h [__USE_GNU] (locale_t): New type alias of __locale_t.
	[__USE_GNU] (newlocale, duplocale, freelocale, uselocale): New decls.
	[__USE_GNU] (LC_GLOBAL_LOCALE): New macro.
	* locale/newlocale.c: Add alias to __ name.
	* locale/duplocale.c: Likewise.
	* locale/freelocale.c: Likewise.
	* locale/uselocale.c: New file.
	* locale/Makefile (routines): Add it.
	* locale/Versions (libc: GLIBC_2.3): New set.
	Add newlocale, duplocale, freelocale, uselocale.
	(libc: GLIBC_PRIVATE): Add __uselocale.

	* locale/localeinfo.h [SHARED]
	(_NL_CURRENT_LOCALE): New macro, defined to fetch a tsd value.
	(_NL_CURRENT_DATA): Define using that.
	(_NL_CURRENT, _NL_CURRENT_WSTR, _NL_CURRENT_WORD): Define using that.
	(_NL_CURRENT_DEFINE): Define to empty.
	[! SHARED]: Decls of _nl_current_CATEGORY and _nl_current
	conditionalized on this.
	* locale/xlocale.c (NL_C_INTIIALIZER): New macro,
	taking initializer of _nl_C_locobj.
	[SHARED] (_nl_global_locale): New variable, using that initializer.
	(_nl_C_locobj): Use new macro for initialzier.
	* locale/setlocale.c [! SHARED] (_nl_current): Conditionalize on this.
	[! SHARED] (CATEGORY_USED): New macro.
	[SHARED] (CATEGORY_USED, _nl_C): New macros.
	(setdata, setlocale): Use that macro instead of examining _nl_current.
	(setdata): Set the slot in _nl_global_locale.
	Conditionalize setting of _nl_current on [! SHARED].
	* locale/findlocale.c [SHARED] (_nl_C): Define as a macro instead of
	declaration as an extern.
	* locale/newlocale.c (__newlocale): Use _nl_C_locobj instead of _nl_C.

	* include/locale.h: Use libc_hidden_proto for setlocale.
	* locale/setlocale.c: Add libc_hidden_def.

	* locale/setlocale.c (free_mem): Use _NL_CURRENT_DATA.

	* include/search.h: Use libc_hidden_proto for hsearch_r, lfind.
	* misc/hsearch_r.c: Add libc_hidden_def.
	* misc/lsearch.c: Likewise.

	* include/ttyent.h: Use libc_hidden_proto for getttyent, setttyent,
	endttyent.
	* misc/getttyent.c: Add libc_hidden_def.

	* include/mcheck.h: Use libc_hidden_proto for mcheck.
	* malloc/mcheck.c: Add libc_hidden_def.

	* include/envz.h: Use libc_hidden_proto for envz_entry, enz_remove.
	* include/argz.h: Use libc_hidden_proto for argz_delete.
	* string/argz-delete.c: Add libc_hidden_def.
	* string/envz.c: Likewise.  Use <envz.h>, not "envz.h".

	* sysdeps/unix/sysv/linux/x86_64/clone.S (thread_start): Use
	HIDDEN_JUMPTARGET for _exit.
	* sysdeps/unix/sysv/linux/m68k/clone.S (thread_start): Likewise.
	* sysdeps/unix/sysv/linux/i386/clone.S (thread_start): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/clone.S: Likewise.
	* sysdeps/unix/_exit.S (_exit): Add libc_hidden_def.

	* include/libc-symbols.h: Fix [__ASSEMBLY__] -> [__ASSEMBLER__].
	[__ASSEMBLER__] (hidden_weak): Define using hidden_def, or to empty.
	[__ASSEMBLER__] (HIDDEN_JUMPTARGET): New macro.
	* sysdeps/unix/sysv/linux/i386/makecontext.S: Use it for exit.

	* include/stdlib.h: Use libc_hidden_proto for abort,
	__strtof_internal, __strtod_internal, __strtold_internal,
	__strtol_internal, __strtoll_internal, __strtoul_internal,
	__strtoull_internal. __strtof_l_internal, __strtod_l_internal,
	__strtold_l_internal, __strtol_l_internal, __strtoll_l_internal,
	__strtoul_l_internal, __strtoull_l_internal.
	* include/wchar.h: Use libc_hidden_proto for __wcstof_internal,
	__wcstod_internal, __wcstold_internal, __wcstol_internal,
	__wcstoll_internal, __wcstoul_internal, ____wcstof_l_internal,
	____wcstod_l_internal, ____wcstold_l_internal, ____wcstol_l_internal,
	____wcstoll_l_internal, ____wcstoul_l_internal, __wcscasecmp_l,
	__wcsncasecmp_l.
	* sysdeps/generic/abort.c: Add libc_hidden_def.
	* stdlib/strtod.c: Likewise.
	* sysdeps/generic/strtol.c: Likewise.
	* sysdeps/wordsize-64/strtol.c: Likewise.
	* sysdeps/wordsize-64/wcstol.c: Likewise.
	* sysdeps/wordsize-64/wcstol_l.c: Likewise.

	* include/stdlib.h: Use libc_hidden_proto for qsort.
	* stdlib/msort.c: Add libc_hidden_def.

	* include/utime.h: Use libc_hidden_proto for utime.
	* sysdeps/generic/utime.c: Add libc_hidden_def.
	* sysdeps/unix/utime.c: Likewise.

	* sysdeps/generic/utmp_file.c (LOCK_FILE): sigemptyset -> __sigemptyset
	* sysdeps/posix/profil.c (__profil): sigfillset -> __sigfillset
	* sysdeps/posix/sprofil.c (__sprofil): Likewise.
	* shadow/lckpwdf.c (__lckpwdf): Likewise (both).
	* sysdeps/posix/spawni.c (__spawni): sigismember -> __sigismember

	* include/signal.h: Use libc_hidden_proto for raise, sigemptyset,
	sigfillset, sigismember, __sigpause, __libc_current_sigrtmin,
	and __libc_current_sigrtmax.
	* signal/sigismem.c: Add libc_hidden_def.
	* signal/sigfillset.c: Likewise.
	* signal/sigempty.c: Likewise.
	* sysdeps/generic/sigpause.c (__sigpause): Likewise.
	* sysdeps/posix/sigpause.c (__sigpause): Likewise.
	* sysdeps/unix/bsd/osf/alpha/sigpause.S: Likewise.
	* sysdeps/posix/raise.c: Likewise.
	* sysdeps/generic/raise.c: Likewise.

2002-08-03  Ulrich Drepper  <drepper@redhat.com>

	* include/string.h: Use libc_hidden_proto for __stpcpy.
	* sysdeps/alpha/stpcpy.S (__stpcpy): Add libc_hidden_def.
	* sysdeps/alpha/alphaev67/stpcpy.S: Likewise.
	* sysdeps/generic/stpcpy.c: Likewise.
	* sysdeps/i386/stpcpy.S: Likewise.
	* sysdeps/i386/i586/stpcpy.S: Likewise.
	* sysdeps/powerpc/stpcpy.S: Likewise.
	* sysdeps/sparc/sparc32/stpcpy.S: Likewise.
	* sysdeps/sparc/sparc64/stpcpy.S: Likewise.

	* include/string.h: Use libc_hidden_proto for __strcasecmp_l,
	__strncasecmp_l, __strdup, __strndup, __strerror_r.
	* sysdeps/generic/strcasecmp_l.c (__strcasecmp_l): Add
	libc_hidden_def.
	* string/strdup.c (__strdup): Likewise.
	* string/strndup.c (__strndup): Likewise.
	* sysdeps/generic/_strerror.c (__strerror_r): Likewise.
	* sysdeps/generic/strncase_l.c (__strncasecmp_l): Likewise.

2002-08-03  Jakub Jelinek  <jakub@redhat.com>

	* include/libio.h: New file.
	* libio/libioP.h (__overflow, __woverflow): Remove libc_hidden_proto.
	* libio/iolibio.h: #include <libio.h>, not "libio.h".
	* sysdeps/generic/morecore.c (__sbrk): Add libc_hidden_proto.
	* sysdeps/unix/bsd/syscalls.list: Remove all __GI_* aliases.
	* sysdeps/unix/common/syscalls.list: Likewise.
	* sysdeps/unix/inet/syscalls.list: Likewise.
	* sysdeps/unix/sysv/irix4/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/alpha/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/ia64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/hppa/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/mips/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/syscalls.list: Likewise.
	* sysdeps/unix/sysv/linux/syscalls.list: Likewise.
	* sysdeps/unix/sysv/sysv4/solaris2/syscalls.list: Likewise.
	* sysdeps/unix/syscalls.list: Likewise.

2002-08-03  Jakub Jelinek  <jakub@redhat.com>
	    Ulrich Drepper  <drepper@redhat.com>

	* malloc/malloc.c (public_cALLOc): Only divide if at least one of
	the arguments is big enough to cause an overflow.

2002-08-03  Ulrich Drepper  <drepper@redhat.com>

	* assert/assert.c: Use hidden_def not INTDEF.

2002-08-03  Jakub Jelinek  <jakub@redhat.com>

	* include/libc-symbols.h: Optimize if HAVE_BROKEN_ALIAS_ATTRIBUTE is
	not defined.

2002-08-03  Roland McGrath  <roland@redhat.com>

	* include/sys/syslog.h: Use libc_hidden_proto for syslog, vsyslog.
	* include/err.h: Use libc_hidden_proto for warn, warnx, vwarn, vwarn,
	verr, verrx.
	* include/stdlib.h: Use libc_hidden_proto for exit, getenv, bsearch.
	* misc/syslog.c: Add libc_hidden_def.
	* misc/err.c: Likewise.
	* stdlib/exit.c: Likewise.
	* stdlib/bsearch.c: Likewise.
	* sysdeps/generic/getenv.c: Likewise.

	* include/libc-symbols.h (hidden_weak): Define it for [__ASSEMBLER__].

	* sysdeps/unix/make-syscalls.sh: Generate libc_hidden_def or
	libc_hidden_weak for every system call symbol defined.

	* include/time.h: Use libc_hidden_proto for time, asctime, mktime,
	timelocal, localtime, strftime.
	* time/asctime.c: Add libc_hidden_def.
	* time/mktime.c: Likewise.
	* time/localtime.c: Likewise.
	* time/strftime.c: Likewise.
	* time/strptime.c: Likewise.
	* sysdeps/generic/time.c: Likewise.
	* sysdeps/unix/time.c: Likewise.
	* sysdeps/unix/sysv/i386/time.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/time.S: Likewise.

	* include/arpa/inet.h: Use libc_hidden_proto for inet_ntop, inet_pton.
	inet_makeaddr, inet_netof, inet_addr, __inet_addr.
	* resolv/inet_ntop.c: Likewise.
	* resolv/inet_pton.c: Likewise.
	* inet/inet_mkadr.c: Add libc_hidden_def.
	* inet/inet_netof.c: Likewise.
	* resolv/inet_addr.c: Likewise.

	* include/libc-symbols.h: Remove `defined HAVE_BROKEN_ALIAS_ATTRIBUTE'
	clauses from conditionals for now.  Will have to be fixed later
	for older compilers.

	* sysdeps/generic/mempcpy.c (__mempcpy): #undef it before defn.

2002-08-02  Ulrich Drepper  <drepper@redhat.com>

	* configure.in (HAVE_BROKEN_ALIAS_ATTRIBUTE): Add check for
	broken alias attribute handling.
	* config.h.in (HAVE_BROKEN_ALIAS_ATTRIBUTE): Add.

2002-08-02  Roland McGrath  <roland@frob.com>

	* elf/Makefile ($(objpfx)interp.os): Depend on config.make,
	since it sets the variables we use in a -D switch.

2002-08-02  Roland McGrath  <roland@redhat.com>

	* posix/bits/posix1_lim.h (SSIZE_MAX): Define to LONG_MAX, not INT_MAX.
	On 32-bit platforms they are the same; on 64-bit platforms ssize_t
	matches long int, not int.

	* locale/localeinfo.h (_NL_CURRENT_DATA): New macro.
	* wcsmbs/wcsmbsload.h (update_conversion_ptrs): Use it.
	* locale/lc-ctype.c (_nl_postload_ctype): Likewise.
	* wctype/wctrans.c (wctrans): Likewise.
	* wctype/wctype.c (__wctype): Likewise.
	* intl/loadmsgcat.c (_nl_init_domain_conv): Use _NL_CURRENT.

2002-08-02  Ulrich Drepper  <drepper@redhat.com>

	* assert/assert.c (__assert_fail): Fix typo in comment.

	* include/rpc/rpc.h: Declare RPC_VARS tsd as extern.
	* sunrpc/rpc_thread.c: Define it without static.
	* sunrpc/Versions [libc] (GLIBC_PRIVATE): Export __libc_tsd_RPC_VARS.

2002-08-02  Jakub Jelinek  <jakub@redhat.com>

	* assert/assert.c (__assert_fail): Remove undef.
	Replace INTDEF with libc_hidden_def.
	* assert/__assert.c (__assert): Remove INTUSE.
	* elf/dl-minimal.c (__assert_fail): Replace INTDEF with
	libc_hidden_weak.
	* include/libc-symbols.h (hidden_proto, hidden_def, hidden_weak,
	hidden_ver, libc_hidden_proto, libc_hidden_def, libc_hidden_weak,
	libc_hidden_ver, rtld_hidden_proto, rtld_hidden_def, rtld_hidden_weak,
	rltd_hidden_ver, libm_hidden_proto, libm_hidden_def, libm_hidden_weak,
	libm_hiden_ver): Define.
	* include/assert.h (__assert_fail_internal): Remove.
	(__assert_fail): Add prototype.  Add hidden_proto.
	* include/libc-internal.h (__libc_freeres, __profile_frequency): Add
	libc_hidden_proto.
	* include/wchar.h (__mbrtowc_internal, __mbrlen_internal): Remove.
	(__mbrtowc, __mbrlen): Use libc_hidden_proto.  Remove macros.
	* include/string.h (__mempcpy, __stpncpy, __rawmemchr, __strcasecmp):
	Add libc_hidden_proto.
	* include/fcntl.h (__open64, __libc_open, __libc_fcntl, __open,
	__fcntl): Add libc_hidden_proto.  Remove macros.
	(__open_internal, __fcntl_internal): Remove.
	* libio/iofdopen.c (_IO_fcntl): Remove INTUSE from __fcntl.
	* malloc/set-freeres.c (__libc_freeres): Add libc_hidden_def.
	* nss/nsswitch.h (__nss_database_lookup, __nss_next): Add
	libc_hiden_proto.
	* nss/nsswitch.c (__nss_database_lookup, __nss_next): Add
	libc_hidden_def.
	* sysdeps/generic/mempcpy.c (__mempcpy): Remove undef.
	Add libc_hidden_def.
	* sysdeps/generic/open64.c (__open64): Add libc_hidden_def.
	* sysdeps/generic/open.c (__open): Remove undef.
	Add libc_hidden_def.  Remove INTDEF.
	* sysdeps/generic/fcntl.c (__fcntl): Remove undef.
	Add libc_hidden_def.
	* sysdeps/mach/hurd/fcntl.c (__fcntl): Likewise.
	* sysdeps/i386/i586/mempcpy.S (__mempcpy): Add libc_hidden_def.
	* sysdeps/i386/i686/mempcpy.S (__mempcpy): Likewise.
	* sysdeps/mach/hurd/fcntl.c (__libc_fcntl, __fcntl): Remove undef.
	(__fcntl): Remove INTDEF2.  Add libc_hidden_weak.
	(__libc_fcntl): Add libc_hidden_def.
	* sysdeps/mach/hurd/open.c (__libc_open, __open): Remove undef.
	(__open): Remove INTDEF2.  Add libc_hidden_weak.
	(__libc_open): Add libc_hidden_def.
	* sysdeps/posix/open64.c (__open64): Add libc_hidden_weak.
	* sysdeps/standalone/open.c (__open): Add libc_hidden_def.
	* sysdeps/unix/sysv/aix/fcntl.c (__libc_fcntl, __fcntl): Remove undef.
	Add libc_hidden_def.
	* sysdeps/unix/sysv/aix/open.c (__libc_open, __open): Remove undef.
	Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/i386/fcntl.c (__libc_fcntl, __fcntl): Remove
	undef.
	(__fcntl): Remove INTDEF2.  Add libc_hidden_weak.
	(__libc_fcntl): Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/syscalls.list (__fcntl_internal,
	__getpgid_internal, __chown_internal): Remove.
	(__GI___fcntl, __GI___libc_fcntl, __GI___getpgid, __GI___pipe,
	__GI___sched_setscheduler, __GI___select, __GI___setpgid,
	__GI___chown): Add.
	* sysdeps/unix/syscalls.list (__close_internal, __dup2_internal,
	__getpid_internal, __open_internal, __write_internal): Remove.
	(__GI___fcntl, __GI___libc_fcntl, __GI___open, __GI___libc_open,
	__GI___chown, __GI___close, __GI___dup2, __GI___getpid,
	__GI___libc_open, __GI___open, __GI___read, __GI___libc_read,
	__GI___select, __GI___statfs, __GI___write, __GI___libc_write): Add.
	* wcsmbs/mbrlen.c (__mbrlen): Remove undef.
	Replace INTDEF with libc_hidden_def.
	* wcsmbs/mbrtowc.c (__mbrtowc): Likewise.
	* catgets/catgetsinfo.h (__open_catalog): Add libc_hidden_proto.
	* catgets/open_catalog.c (__open_catalog): Add libc_hidden_def.
	* elf/dl-profile.c (__profile_frequency): Add libc_hidden_proto.
	* include/rpc/rpc.h (__rpc_thread_svc_fdset, __rpc_thread_createerr):
	Add libc_hidden_proto.
	* include/sys/poll.h (__poll): Add libc_hidden_proto.
	* include/sys/select.h (__select): Likewise.
	* include/sys/socket.h (__send): Likewise.
	* include/sys/statfs.h (__statfs): Likewise.
	* include/unistd.h (__pwrite64, __libc_read, __pipe, __chown, __dup2,
	__getpid, __getpgid, __setpgid, __close, __read, __write,
	__getpagesize, __sbrk): Likewise.
	(__chown_internal, __dup2_internal, __getpid_internal,
	__getpgid_internal, __close_internal, __write_internal,
	__getpagesize_internal): Remove.
	(__close, __dup2, __getpagesize, __getpgid, __getpid, __libc_write):
	Remove macros.
	* include/printf.h (__printf_fp): Add libc_hidden_proto.
	* include/sched.h (__sched_setscheduler): Likewise.
	* include/resolv.h (__res_ninit, __res_randomid): Likewise.
	* include/stdlib.h (__secure_getenv): Likewise.
	* include/signal.h (__sigaction, __sigsuspend): Likewise.
	* inet/getaliasent_r.c (NSS_attribute_hidden): Remove.
	* inet/getaliasname_r.c (NSS_attribute_hidden): Remove.
	* inet/getnetbyad_r.c (NSS_attribute_hidden): Remove.
	* inet/getnetbynm_r.c (NSS_attribute_hidden): Remove.
	* inet/getnetent_r.c (NSS_attribute_hidden): Remove.
	* inet/getproto_r.c (NSS_attribute_hidden): Remove.
	* inet/getprtent_r.c (NSS_attribute_hidden): Remove.
	* inet/getprtname_r.c (NSS_attribute_hidden): Remove.
	* inet/getrpcbyname_r.c (NSS_attribute_hidden): Remove.
	* inet/getrpcbynumber_r.c (NSS_attribute_hidden): Remove.
	* inet/getrpcent_r.c (NSS_attribute_hidden): Remove.
	* inet/getservent_r.c (NSS_attribute_hidden): Remove.
	* inet/getsrvbynm_r.c (NSS_attribute_hidden): Remove.
	* inet/getsrvbypt_r.c (NSS_attribute_hidden): Remove.
	* inet/gethstbyad_r.c (DB_LOOKUP_FCT): Remove INTUSE.
	* inet/gethstbynm2_r.c (DB_LOOKUP_FCT): Likewise.
	* inet/gethstbynm_r.c (DB_LOOKUP_FCT): Likewise.
	* inet/gethstent_r.c (DB_LOOKUP_FCT): Likewise.
	* libio/genops.c (__overflow): Add libc_hidden_def.
	* libio/iovdprintf.c: Remove libio.h include.
	* libio/libioP.h (libc_hidden_proto, libc_hidden_def,
	libc_hidden_weak): Define to nothing if not defined.
	(__overflow, __woverflow): Add libc_hidden_proto.
	* libio/wgenops.c (__woverflow): Add libc_hidden_def.
	* nss/getXXent_r.c (NSS_attribute_hidden): Remove.
	(DB_LOOKUP_FCT): Add libc_hidden_proto.
	* nss/getXXbyYY_r.c (NSS_attribute_hidden): Remove.
	(DB_LOOKUP_FCT): Add libc_hidden_proto.
	* nss/XXX-lookup.c (DB_LOOKUP_FCT): Add libc_hidden_proto
	and libc_hidden_def.
	* nss/hosts-lookup.c (__nss_hosts_lookup): Remove INTDEF.
	* posix/bsd-getpgrp.c (__getpgid_internal): Remove.
	(__getpgid): Add libc_hidden_proto.
	(__bsd_getpgrp): Remove INTUSE.
	* resolv/res_init.c (__res_ninit, __res_randomid): Add
	libc_hidden_def.
	* shadow/getspent_r.c (NSS_attribute_hidden): Remove.
	* shadow/getspnam_r.c (NSS_attribute_hidden): Remove.
	* stdio-common/printf_fp.c (__printf_fp): Add libc_hidden_def.
	* stdlib/strfmon.c (__printf_fp): Add libc_hidden_proto.
	* stdlib/secure-getenv.c (__secure_getenv): Add libc_hidden_def.
	* sunrpc/rpc_thread.c (__rpc_thread_svc_fdset,
	__rpc_thread_createerr): Add libc_hidden_def.
	* sysdeps/alpha/alphaev67/rawmemchr.S (__rawmemchr): Add
	libc_hidden_def.
	* sysdeps/alpha/alphaev67/stpncpy.S (__stpncpy): Likewise.
	* sysdeps/alpha/rawmemchr.S (__rawmemchr): Likewise.
	* sysdeps/alpha/stpncpy.S (__stpncpy): Likewise.
	* sysdeps/generic/chown.c (__chown): Likewise.
	* sysdeps/generic/close.c (__close): Likewise.
	* sysdeps/generic/dup2.c (__dup2): Likewise.
	* sysdeps/generic/pipe.c (__pipe): Likewise.
	* sysdeps/generic/prof-freq.c (__profile_frequency): Likewise.
	* sysdeps/generic/pwrite64.c (__pwrite64): Likewise.
	* sysdeps/generic/rawmemchr.c (__rawmemchr): Likewise.
	* sysdeps/generic/read.c (__libc_read): Likewise.
	(__read): Add libc_hidden_weak.
	* sysdeps/generic/sbrk.c (__sbrk): Add libc_hidden_def.
	* sysdeps/generic/sched_sets.c (__sched_setscheduler): Likewise.
	* sysdeps/generic/select.c (__select): Likewise.
	* sysdeps/generic/send.c (__send): Likewise.
	* sysdeps/generic/setpgid.c (__setpgid): Likewise.
	* sysdeps/generic/sigaction.c (__sigaction): Likewise.
	* sysdeps/generic/sigsuspend.c (__sigsuspend): Likewise.
	* sysdeps/generic/statfs.c (__statfs): Likewise.
	* sysdeps/generic/stpncpy.c (__stpncpy): Likewise.
	* sysdeps/generic/strcasecmp.c (__strcasecmp): Likewise.
	* sysdeps/generic/getpagesize.c (__getpagesize): Likewise.
	Remove undef and INTDEF.
	* sysdeps/generic/getpgid.c (__getpgid): Likewise.
	* sysdeps/generic/getpid.c (__getpid): Likewise.
	* sysdeps/generic/write.c (__libc_write): Likewise.
	(__write): Add libc_hidden_weak.  Remove undef and INTDEF.
	* sysdeps/i386/rawmemchr.S (__rawmemchr): Add libc_hidden_def.
	* sysdeps/i386/stpncpy.S (__stpncpy): Likewise.
	* sysdeps/m68k/rawmemchr.S (__rawmemchr): Likewise.
	* sysdeps/mach/hurd/chown.c (__chown): Likewise.  Remove INTDEF.
	* sysdeps/mach/hurd/close.c (__close): Add libc_hidden_def.
	Remove undef and INTDEF.
	* sysdeps/mach/hurd/dup2.c (__dup2): Likewise.
	* sysdeps/mach/hurd/getpgid.c (__getpgid): Likewise.
	* sysdeps/mach/hurd/getpid.c (__getpid): Likewise.
	* sysdeps/mach/getpagesize.c (__getpagesize): Likewise.
	* sysdeps/mach/hurd/write.c (__libc_write): Likewise.
	(__write): Add libc_hidden_weak.  Remove undef and INTDEF.
	* sysdeps/mach/hurd/pipe.c: Include unistd.h.
	(__pipe): Add libc_hidden_def.
	* sysdeps/mach/hurd/dl-sysdep.c (__libc_read, __libc_write): Add
	libc_hidden_weak.
	* sysdeps/mach/hurd/poll.c (__poll): Add libc_hidden_def.
	* sysdeps/mach/hurd/profil.c (__profile_frequency): Likewise.
	* sysdeps/mach/hurd/read.c (__libc_read): Likewise.
	(__read): Add libc_hidden_weak.
	* sysdeps/mach/hurd/pwrite64.c (__pwrite64): Likewise.
	(__libc_pwrite64): Add libc_hidden_def.
	* sysdeps/mach/hurd/sbrk.c (__sbrk): Likewise.
	* sysdeps/mach/hurd/select.c (__select): Likewise.
	* sysdeps/mach/hurd/send.c (__send): Likewise.
	* sysdeps/mach/hurd/setpgid.c (__setpgid): Likewise.
	* sysdeps/mach/hurd/sigaction.c (__sigaction): Likewise.
	* sysdeps/mach/hurd/sigsuspend.c (__sigsuspend): Likewise.
	* sysdeps/mach/hurd/statfs.c (__statfs): Likewise.
	* sysdeps/posix/dup2.c: Likewise.
	Remove undef and INTDEF.
	* sysdeps/posix/getpagesize.c (__getpagesize): Likewise.
	* sysdeps/posix/pwrite64.c (__libc_pwrite64): Add libc_hidden_def.
	(__pwrite64): Add libc_hidden_weak.
	* sysdeps/posix/sigsuspend.c (__sigsuspend): Add libc_hidden_def.
	* sysdeps/sparc/sparc64/rawmemchr.S (__rawmemchr): Likewise.
	* sysdeps/sparc/sparc64/stpncpy.S (__stpncpy): Likewise.
	* sysdeps/standalone/close.c (__close): Likewise.
	* sysdeps/standalone/write.c (__libc_write): Likewise.
	(__write): Add libc_hidden_weak.
	* sysdeps/standalone/read.c (__read): Likewise.
	(__libc_read): Add libc_hidden_def.
	* sysdeps/unix/grantpt.c (grantpt): Remove INTUSE.
	* sysdeps/unix/bsd/m68k/pipe.S (__pipe): Add libc_hidden_def.
	* sysdeps/unix/bsd/osf/alpha/pipe.S (__pipe): Likewise.
	* sysdeps/unix/bsd/vax/pipe.S (__pipe): Likewise.
	* sysdeps/unix/bsd/syscalls.list (__GI___getpagesize): Likewise.
	* sysdeps/unix/bsd/poll.c (__poll): Likewise.
	* sysdeps/unix/bsd/sigaction.c (__sigaction): Likewise.
	* sysdeps/unix/bsd/sigsuspend.c (__sigsuspend): Likewise.
	* sysdeps/unix/common/syscalls.list (__GI___getpgid, __GI___setpgid,
	__GI___sigaction): Add.
	* sysdeps/unix/i386/pipe.S (__pipe): Add libc_hidden_def.
	* sysdeps/unix/inet/syscalls.list (__GI___send): Add.
	* sysdeps/unix/mips/pipe.S (__pipe): Add libc_hidden_def.
	* sysdeps/unix/sparc/pipe.S (__pipe): Likewise.
	* sysdeps/unix/sysv/irix4/syscalls.list (__GI___getpgid,
	__GI___setpgid): Add.
	* sysdeps/unix/sysv/aix/chown.c (__chown): Add libc_hidden_def.
	Remove undef and INTDEF.
	* sysdeps/unix/sysv/aix/getpgid.c (__getpgid): Likewise.
	* sysdeps/unix/sysv/aix/write.c (__write, __libc_write): Likewise.
	* sysdeps/unix/sysv/aix/close.c (__close): Add libc_hidden_def.
	* sysdeps/unix/sysv/aix/getpid.c (__getpid): Likewise.
	* sysdeps/unix/sysv/aix/pipe.c (__pipe): Likewise.
	* sysdeps/unix/sysv/aix/read.c (__read, __libc_read): Likewise.
	* sysdeps/unix/sysv/aix/poll.c (__poll): Likewise.
	* sysdeps/unix/sysv/aix/sbrk.c (__sbrk): Likewise.
	* sysdeps/unix/sysv/aix/sigaction.c (__sigaction): Likewise.
	* sysdeps/unix/sysv/aix/sigsuspend.c (__sigsuspend): Likewise.
	* sysdeps/unix/sysv/aix/statfs.c (__statfs): Likewise.
	* sysdeps/unix/sysv/aix/select.c (__select): Likewise.
	* sysdeps/unix/sysv/aix/setpgid.c (__setpgid): Likewise.
	* sysdeps/unix/sysv/linux/alpha/pipe.S (__pipe): Likewise.
	* sysdeps/unix/sysv/linux/alpha/syscalls.list (__GI___pwrite64,
	__GI___statfs, __GI___send): Add.
	* sysdeps/unix/sysv/linux/alpha/select.S (__select): Add
	libc_hidden_ver resp. libc_hidden_def.
	* sysdeps/unix/sysv/linux/alpha/sigsuspend.S (__sigsuspend): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/linux/ia64/getpagesize.c (__getpagesize):
	Likewise.  Remove undef and INTDEF.
	* sysdeps/unix/sysv/linux/ia64/pipe.S (__pipe): Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/ia64/syscalls.list (__GI___pwrite64,
	__GI___statfs, __GI___send): Add.
	* sysdeps/unix/sysv/linux/ia64/sigaction.c (__sigaction): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/linux/ia64/sigsuspend.c (__sigsuspend):
	Likewise.
	* sysdeps/unix/sysv/linux/sh/pipe.S (__pipe): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/chown.c (__chown): Add
	libc_hidden_ver resp. libc_hidden_def.
	* sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list (__GI___pwrite64,
	__GI___send): Add.
	* sysdeps/unix/sysv/linux/s390/s390-64/sigaction.c (__sigaction):
	Add libc_hidden_weak.
	* sysdeps/unix/sysv/linux/s390/s390-64/sigsuspend.c (__sigsuspend):
	Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/hppa/syscalls.list (__GI___send): Add.
	* sysdeps/unix/sysv/linux/arm/sigaction.c (__sigaction): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/i386/chown.c (__chown): Add libc_hidden_ver
	resp. libc_hidden_def.
	* sysdeps/unix/sysv/linux/i386/sigaction.c (__sigaction): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/m68k/chown.c (__chown): Likewise.  Remove
	INTDEF.
	* sysdeps/unix/sysv/linux/m68k/getpagesize.c (__getpagesize):
	Likewise.  Remove undef.
	* sysdeps/unix/sysv/linux/mips/pwrite64.c (__pwrite64): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/mips/syscalls.list (__GI___send): Add.
	* sysdeps/unix/sysv/linux/mips/sigaction.c (__sigaction): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/powerpc/chown.c (__chown): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/linux/powerpc/pwrite64.c (__pwrite64): Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/getpagesize.c (__getpagesize):
	Likewise.  Remove undef and INTDEF.
	* sysdeps/unix/sysv/linux/sparc/sparc32/pipe.S (__pipe): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sigaction.c (__sigaction): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/sparc/sparc64/pipe.S (__pipe): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/linux/sparc/sparc64/syscalls.list
	(__GI___pwrite64, __GI___statfs, __GI___select, __GI___send): Add.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sigaction.c (__sigaction): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sigsuspend.c (__sigsuspend):
	Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/x86_64/syscalls.list (__GI___pwrite64,
	__GI___statfs): Add.
	* sysdeps/unix/sysv/linux/x86_64/send.c (__send): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/x86_64/sigaction.c (__sigaction): Likewise.
	* sysdeps/unix/sysv/linux/getpagesize.c: Add libc_hidden_def.
	Remove undef and INTDEF.
	* sysdeps/unix/sysv/linux/poll.c (__poll): Add libc_hidden_def.
	* sysdeps/unix/sysv/linux/pwrite64.c (__pwrite64): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/linux/send.S (__send): Likewise.
	* sysdeps/unix/sysv/linux/sigaction.c (__sigaction): Add
	libc_hidden_weak.
	* sysdeps/unix/sysv/linux/sigsuspend.c (__sigsuspend): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/sco3.2.4/__setpgid.c (__setpgid): Likewise.
	* sysdeps/unix/sysv/sco3.2.4/sigaction.S (__sigaction): Likewise.
	* sysdeps/unix/sysv/sysv4/solaris2/syscalls.list (__GI___sigaction):
	Add.
	* sysdeps/unix/sysv/sysv4/__getpgid.c (__getpgid): Add
	libc_hidden_def.  Remove undef and INTDEF.
	* sysdeps/unix/sysv/sysv4/getpgid.c (__getpgid): Likewise.
	* sysdeps/unix/sysv/sysv4/__setpgid.c (__setpgid): Add
	libc_hidden_def.
	* sysdeps/unix/sysv/sysv4/setpgid.c (__setpgid): Likewise.
	* sysdeps/unix/sysv/sysv4/sigaction.c (__sigaction): Likewise.
	* sysdeps/unix/sysv/sigaction.c (__sigaction): Likewise.
	* sysdeps/unix/getpagesize.c (__getpagesize): Add libc_hidden_def.
	Remove undef and INTDEF.
	* configure.in (HAVE_BROKEN_VISIBILITY_ATTRIBUTE): Add check for
	broken visibility attribute handling.
	* config.h.in (HAVE_BROKEN_VISIBILITY_ATTRIBUTE): Add.

2002-08-02  Ulrich Drepper  <drepper@redhat.com>

	* locale/iso-639.def: Add entries for Venda and Nothern Sotho.
	Reported by Dwayne Bailey <dwayne@obsidian.co.za>.

	* resolv/nss_dns/dns-host.c (_nss_dns_gethostbyaddr_r): Adapt
	previous patch.

2002-06-29  Todd Fries  <todd@openbsd.org>

	* resolv/gethnamaddr.c (gethostbyaddr): Try ip6.int if ip6.arpa fails.

2002-08-02  Jakub Jelinek  <jakub@redhat.com>

	* include/errno.h: Don't include tls.h if _ISOMAC is defined.

2002-07-30  Roland McGrath  <roland@redhat.com>

	* resolv/resolv.h (_res): Define macro unconditionally.
	[! _LIBC_REENTRANT] (_res): Move this conditional decl to ...
	* include/resolv.h: ... here.
	[USE_TLS && HAVE___THREAD] (_res): #undef it and declare
	as a __thread variable.
	* resolv/res_libc.c [USE_TLS && HAVE___THREAD] (_res): Define it as
	a __thread variable instead of a global.
	* resolv/res_data.c [_LIBC]: Don't #undef _res.

	* include/errno.h: Include <tls.h> to make sure USE_TLS defined by the
	time we test it.

	* intl/loadmsgcat.c [__GNUC__]: #undef alloca before defining it.

	* malloc/malloc.c [_LIBC]: Include <string.h> instead of using local
	decls of memset and memcpy.

	* sysdeps/generic/sysdep.h (END): Conditionalize on [__ASSEMBLER__].
	* sysdeps/unix/sysv/linux/i386/sysdep.h (L): Likewise.

	* elf/dl-load.c (_dl_map_object_from_fd): Comment fix.

	* sysdeps/generic/bits/libc-tsd.h [USE_TLS && HAVE___THREAD]
	(__libc_tsd_define): Define using __thread.

	* sunrpc/rpc_thread.c: Use __libc_tsd_define.
	(__rpc_thread_variables): Use __libc_tsd_get.
	(__rpc_thread_destroy): Use __libc_tsd_get instead of calling
	__rpc_thread_variables, which might allocate what we're about to free.

	* inet/herrno.c [USE_TLS && HAVE___THREAD] (h_errno): Define as a
	thread-local variable.
	* resolv/netdb.h (h_errno): Define macro unconditionally.
	[_LIBC] (__set_h_errno): Macro moved to ...
	* include/netdb.h: ... here.
	[USE_TLS && HAVE___THREAD] (h_errno): Declare __thread variable.
	[USE_TLS && HAVE___THREAD] (__set_h_errno): Define using that.
	[! _LIBC_REENTRANT]: #undef h_errno here.

	* include/errno.h: Protect from multiple inclusion.

	* misc/sys/select.h (__NFDBITS, __FDELT, __FDMASK): #undef these
	before defining them, since Linux's <linux/posix_types.h> might have
	defined them.

2002-08-02  Jakub Jelinek  <jakub@redhat.com>

	* malloc/malloc.c (public_cALLOc): Check for overflow on
	multiplication.
	* sunrpc/xdr_array.c (xdr_array): Likewise.
	* sunrpc/rpc/types.h (mem_free): Add comment.
	Patch by Solar Designer <solar@openwall.com>.

2002-08-02  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/kernel-features.h
	(__ASSUME_SET_THREAD_AREA_SYSCALL): Define.

2002-08-01  Roland McGrath  <roland@redhat.com>

	* libio/fileops.c (_IO_file_sync_mmap): New function.
	(_IO_file_jumps_mmap): Use it.
	(_IO_file_underflow_mmap): Rewritten.  If after EOF or fflush,
	repeat the stat check and resize the mapped buffer as necessary.

2002-07-31  Roland McGrath  <roland@redhat.com>

	* libio/fileops.c (decide_maybe_mmap): New static function.
	Code taken from libio/iofopen.c:__fopen_maybe_mmap to try to
	mmap the file contents.  Then switch the jump tables to the mmap
	tables if it worked, or the vanilla file tables if not.
	(_IO_file_underflow_maybe_mmap): New function.
	(_IO_file_seekoff_maybe_mmap): New function.
	(_IO_file_xsgetn_maybe_mmap): New function.
	(_IO_file_jumps_maybe_mmap): New variable, jump table using those.
	* libio/libioP.h: Declare those.
	* libio/wfileops.c (_IO_wfile_underflow_maybe_mmap): New function.
	(_IO_wfile_jumps_maybe_mmap): New variable, jump table using that.
	* libio/iofopen.c (__fopen_maybe_mmap): Don't try to mmap here.
	If the stream is read-only, set its jump tables to those new ones.
	* libio/iofdopen.c (_IO_new_fdopen) [_G_HAVE_MMAP]: Set the initial
	jump tables to the maybe_mmap ones, and don't call __fopen_maybe_mmap.
	We need the tables set before _IO_file_attach.

	* libio/tst-mmap-eofsync.c: New file.
	* libio/tst-mmap-fflushsync.c: New file.
	* libio/bug-mmap-fflush.c: New file.
	* libio/tst-mmap2-eofsync.c: New file.
	* libio/Makefile (tests): Add them.

	* libio/wfileops.c (_IO_wfile_underflow_mmap): Don't set EOF bit when
	_IO_file_underflow_mmap fails, it already set the appropriate bit.

2002-07-31  Jeff Bailey  <jbailey@gnu.org>

	* libio/stdio.h (sys_errlist, sys_nerr, _sys_errlist, _sys_nerr):
	Declarations moved to <bits/sys_errlist.h>.  Include that file.
	* libio/Makefile (headers): Add bits/sys_errlist.h to the list.
	* sysdeps/generic/bits/sys_errlist.h: New file.  This does *not*
	declare sys_errlist and sys_nerr.
	* sysdeps/unix/sysv/linux/bits/sys_errlist.h: New file.  Does
	provide declarations.

2002-07-31  Roland McGrath  <roland@redhat.com>

	* elf/rtld.c (dl_main): Fix typo in error message.

2002-07-31  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/Versions (ld: GLIBC_2.0): __fxstat -> __fxstat64,
	__xstat -> __xstat64, __lseek -> __libc_lseek64.  Completes 2002-06-09
	sysdeps/mach/hurd/dl-sysdep.c change.

2002-07-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/configure.in: Check /lib/modules/`uname
	-r`/build/include for kernel headers.

	* po/fi.po: New file.

2002-07-15  Alexandre Oliva  <aoliva@redhat.com>

	* configure.in (static_nss): Set to `yes' if --disable-shared.

2002-07-23  Bruno Haible  <bruno@clisp.org>

	* intl/loadmsgcat.c (PRI*): Redefine the macros if PRI_MACROS_BROKEN
	is set.

2002-07-25  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/sigcontextinfo.h: New file.
	* sysdeps/unix/sysv/linux/ia64/profil-counter.h: Fix profil_counter
	arguments.

2002-07-25  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/adjtime.c (__adjtimex_internal): Add
	alias.

2002-07-21  Bruno Haible  <bruno@clisp.org>

	* intl/libintl.h (__GNU_GETTEXT_SUPPORTED_REVISION): New macro.
	* intl/gettext.h (struct mo_file_header): New fields n_sysdep_segments,
	sysdep_segments_offset, n_sysdep_strings, orig_sysdep_tab_offset,
	trans_sysdep_tab_offset.
	(struct sysdep_segment): New type.
	(struct sysdep_string): New type.
	(SEGMENTS_END): New macro.
	* intl/gettextP.h (struct sysdep_string_desc): New type.
	(struct loaded_domain): New fields malloced, n_sysdep_strings,
	orig_sysdep_tab, trans_sysdep_tab, must_swap_hash_tab. Make fields
	orig_tab, trans_tab, hash_tab to const pointers because they point
	into read-only memory.
	* intl/loadmsgcat.c: Include stdint.h, inttypes.h, hash-string.h.
	(PRI*): Define fallback values.
	(get_sysdep_segment_value): New function.
	(_nl_load_domain): Distinguish major and minor revision parts. Add
	support for minor revision 1 with system dependent strings.
	(_nl_unload_domain): Also free the 'malloced' field.
	* intl/dcigettext.c (_nl_find_msg): Remove test for domain->hash_size,
	now done in loadmsgcat.c. Add support for system dependent strings.

2002-07-16  Stepan Kasal  <kasal@math.cas.cz>

	* posix/bug-regex7.c: New file.
	* posix/bug-regex8.c: New file.
	* posix/Makefile (tests): Add bug-regex7 and bug-regex8.

2002-07-16  Stepan Kasal  <kasal@math.cas.cz>

	* posix/bug-regex4.c (main): Fix typos.
	* posix/bug-regex6.c (main): Likewise.

2002-07-27  Ulrich Drepper  <drepper@redhat.com>

	* posix/bug-regex6.c (main): Fix warnings.

	* iconvdata/Makefile (CPPFLAGS): Add NOT_IN_libc.

	* iconv/iconv_prog.c (main): Improve error message for the cases
	where -t and/or -f parameter are missing.

2002-07-10  Stepan Kasal  <kasal@math.cas.cz>

	* posix/regexec.c (re_match): Reorganize to remove duplicate code.
	(re_search): Likewise.
	(re_match_2): Likewise.
	(re_search_2): Likewise.
	(re_search_stub): New function.
	(re_search_2_stub): New function.
	* regcomp.c (re_compile_pattern): Typo in a comment fixed.

2002-07-10  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regex_internal.h: Add new member STOP to struct re_string_t.
	(re_string_eoi): Use STOP instead of LEN.
	* posix/regex_internal.c (re_string_allocate): Initialize pstr->len.
	(re_string_construct): Likewise.
	(re_string_reconstruct): Adjust pstr->stop like pstr->len.
	* posix/regexec.c (re_search_internal): Add a new argument STOP
	so that it can handle the argument STOP of re_search_2 and re_match_2
	correctly.
	(regexec): Adapt to new I/F of re_search_internal.
	(re_search_stub): Likewise.

2002-07-25  Ulrich Drepper  <drepper@redhat.com>

	* sunrpc/clnt_gen.c: Don't include <sys/errno.h>.

	* elf/dl-minimal.c: Remove definition of __assert_perror_fail.

	* sysdeps/wordsize-32/divdi3.c: Define __divdi3_internal.
	* sysdeps/wordsize-32/lldiv.c: Make gcc use __divdi3_internal instead
	of __divdi3.

	* sysdeps/unix/sysv/linux/adjtime.c: Use __adjtimex_internal.
	* sysdeps/unix/sysv/linux/ntp_gettime.c: Likewise.
	* sysdeps/unix/sysv/linux/syscalls.list: Add __adjtimex_internal
	alias for adjtimex syscall.

	* elf/dl-minimal.c: Define __assert_fail_internal.
	* assert/assert.c: Likewise.
	* include/assert.h: Define __assert_file macro if !SHARED and not
	NOT_IN_libc.

	* iconv/Makefile: Define NOT_IN_libc for objects in standalone
	programs.
	* locale/Makefile: Likewise.
	* nscd/Makefile: Likewise.
	* catgets/Makefile: Likewise.

2002-07-24  Ulrich Drepper  <drepper@redhat.com>

	* libio/fileops.c (_IO_file_seekoff_mmap): Do use fp->_offset to
	compute current position.

	* stdio-common/tst-fseek.c (main): Improve error messages.

	* libio/tst-freopen.c (main): Remove unused variable.

	* libio/fileops.c (_IO_file_seekoff_mmap): Set fp->_offset after
	succesful seek call.  Simplify error checking.

2002-07-25  Jakub Jelinek  <jakub@redhat.com>

	* config.h.in: Use __ASSEMBLER__ test macro not ASSEMBLER.
	* sysdeps/ia64/fpu/libm_support.h: Likewise.

2002-07-19  Roland McGrath  <roland@frob.com>

	* hurd/hurdsig.c (_hurdsig_getenv): Always return null if
	__libc_enable_secure is set.

2002-07-24  Roland McGrath  <roland@frob.com>

	Added <ifaddrs.h> interface with functions `getifaddrs', `freeifaddrs'.
	This implementation supports only IPv4.
	* inet/ifaddrs.h: New file.
	* sysdeps/generic/ifaddrs.c: New file.
	* sysdeps/gnu/ifaddrs.c: New file.
	* inet/test-ifaddrs.c: New file.
	* inet/Makefile (routines): Add ifaddrs.
	(headers): Add ifaddrs.h here.
	(tests): Add test-ifaddrs.
	* inet/Versions (GLIBC_2.3): New set, add getifaddrs and freeifaddrs.

	* resolv/res_hconf.c (_res_hconf_reorder_addrs): Use an explicit
	socket call to get an AF_INET socket, instead of using __opensock.
	The SIOCGIFNETMASK ioctl will work only with a PF_INET socket.

	* sysdeps/generic/ifreq.h (__ifreq): Take third argument SOCKFD,
	if not -1 use it instead of calling __opensock.
	* sysdeps/unix/sysv/linux/ifreq.h (__ifreq): Likewise.
	* sysdeps/mach/hurd/ifreq.h (__ifreq): Take new argument and ignore it.
	* resolv/res_hconf.c (_res_hconf_reorder_addrs): Pass new argument.

	* sysdeps/mach/hurd/ifreq.h: New file.
	* sysdeps/generic/ifreq.h (__if_freereq): Take second argument NUM_IFS.
	* sysdeps/unix/sysv/linux/ifreq.h (__if_freereq): Likewise.
	* resolv/res_hconf.c (_res_hconf_reorder_addrs): Update caller.

	* libio/fileops.c (_IO_file_seekoff_mmap): Don't rely on FP->_offset,
	which gets moved around.  Calculate size of mmap'd buffer instead.

2002-07-24  Philip Blundell  <philb@gnu.org>

	* sysdeps/unix/arm/brk.S: Improve schedule.
	* sysdeps/unix/sysv/linux/arm/socket.S (PUSHARGS_1): Use more
	efficient instruction.
	(__socket): Optimize return sequence.

2002-07-24  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/opensock.c (__opensock): Prefer inet
	sockets on old kernels.

2002-07-22  Philip Blundell  <philb@gnu.org>

	* sysdeps/unix/sysv/linux/arm/errlist.c: Remove extra weak alias
	definiton of _old_sys_nerr.  Define _old_sys_errlist as strong
	alias.

2002-07-24  Ulrich Drepper  <drepper@redhat.com>

	* locale/hashval.h: Make more self-contained by defining LONG_BITS.
	* locale/programs/simple-hash.c: Remove LONG_BITS definition.

	* locale/programs/locarchive.c (add_locale_to_archive): Correct
	test to detect duplicate locales.

	* libio/fileops.c (_IO_new_file_seekoff): Fail if relative
	position would be before beginning of file.
	(_IO_file_seekoff_mmap): Likewise.
	* libio/Makefile (tests): Add bug-fseek.
	* libio/bug-fseek.c: New file.

	* intl/explodename.c: Remove support for CEN-style locale variables.
	It was never used and shouldn't be since it's not portable.
	* intl/finddomain.c: Likewise.
	* intl/l10nflist.c: Likewise.
	* intl/loadinfo.h: Likewise.
	* locale/findlocale.c: Likewise.

2002-07-24  Roland McGrath  <roland@frob.com>

	* libio/fileops.c (_IO_file_seekoff_mmap): When just examining the
	position, calculate it to take into account an active pushback buffer.

	* libio/Makefile (tests): Add bug-ungetc.
	* libio/bug-ungetc.c: New file.

2002-07-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/generic/libc-tls.c: New file.
	* csu/Makefile (routines): Add libc-tls.
	(static-only-routines): Add libc-tls.
	* elf/dl-support.c (_dl_phdr): New variable.
	(_dl_phnum): New variable.
	(_dl_aux_init): Initialize _dl_phdr and _dl_phnum from aux vector.
	* sysdeps/generic/libc-start.c (__libc_start_main): Reorganize code
	for !SHARED.  First look through auxiliary vector.  If TLS always
	call __pthread_initialize_minimal.

	* sysdeps/generic/dl-tls.c (_dl_allocate_tls): Make sure size argument
	in mmap call is never zero.

2002-07-23  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/fpu/s_copysign.S: Use optimized version.
	* sysdeps/x86_64/fpu/s_copysignf.S: Likewise.

2002-07-22  Ulrich Drepper  <drepper@redhat.com>

	* libio/tst-eof.c: Rewrite to let test-skeleton.c deal with
	creation and removal of the temp file.

	* libio/bug-rewind.c: Use test skeleton.  Use create_temp_file for
	file creation.
	* test-skeleton.c (create_temp_file): New function.

2002-07-22  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/dl-machine.h (elf_machine_load_address): Use
	local label.

2002-07-21  Roland McGrath  <roland@frob.com>

	* wcsmbs/Makefile (strtox-CFLAGS): New variable,
	put -I../include before -I../stdlib so we get the right errno.h et al.
	(CFLAGS-wcstod.c): Use that variable instead of -I../stdlib.
	(CFLAGS-wcstof.c): Likewise.
	(CFLAGS-wcstold.c): Likewise.
	(CFLAGS-wcstod_l.c): Likewise.
	(CFLAGS-wcstof_l.c): Likewise.
	(CFLAGS-wcstold_l.c): Likewise.

2002-07-19  Roland McGrath  <roland@frob.com>

	* sysdeps/mach/hurd/errnos.awk: Remove __set_errno defn from output.

2002-07-20  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ldsodefs.h (HAVE_AUX_XID): Define if
	__ASSUME_AT_XID is defined.
	* sysdeps/unix/sysv/linux/kernel-features.h (__ASSUME_AT_XID): Define
	for 2.4.1 and up.
	* sysdeps/generic/dl-sysdep.c (_dl_sysdep_start): Optimize handling
	of AT_UID, AT_EUID, AT_GID, and AT_EGID.

	* wcsmbs/Makefile (CFLAGS-wcstod.c): Add -I../stdlib.
	(CFLAGS-wcstof.c): Likewise.
	(CFLAGS-wcstold.c): Likewise.
	(CFLAGS-wcstod_l.c): Likewise.
	(CFLAGS-wcstof_l.c): Likewise.
	(CFLAGS-wcstold_l.c): Likewise.

2002-07-18  Jakub Jelinek  <jakub@redhat.com>

	* resource/sys/resource.h (__rlimit_resource_t, __rusage_who_t,
	__priority_which_t): Always typedef to int for C++.

2002-07-19  Ulrich Drepper  <drepper@redhat.com>

	* configure.in: Add test for __thread support in compiler.
	* config.h.in: Add HAVE___THREAD.
	* Makefile (headers): Remove errno.h, sys/errno.h, and bits/errno.h.
	* include/sys/errno.h: Moved to...
	* stdlib/sys/errno.h: ...here.  New file.
	* stdlib/errno.h: New file.  Moved from...
	* include/errno.h: ...here.  Changed into an internal header defining
	libc-local things like __set_errno.
	* stdlib/Makefile (headers): Add errno.h, sys/errno.h, and
	bits/errno.h.
	* elf/dl-minimal.c: Include <tls.h>.  Define errno as thread-local
	variable if USE_TLS && HAVE___THREAD.  Don't define __errno_location
	either.
	* elf/rtld.c (_dl_start): Add code to initialize TLS for ld.so
	from...
	(_dl_start_final): ...here.  Add code to initialize tls elements from
	bootstrap_map.
	* sysdeps/generic/errno-loc.c: Define errno as thread-local variable
	if USE_TLS && HAVE___THREAD.
	* sysdeps/generic/bits/errno.h: Remove __set_errno definition.
	* sysdeps/mach/hurd/bits/errno.h: Likewise.
	* sysdeps/standalone/arm/bits/errno.h: Likewise.
	* sysdeps/standalone/bits/errno.h: Likewise.
	* sysdeps/unix/bsd/bsd4.4/bits/errno.h: Likewise.
	* sysdeps/unix/sysv/aix/bits/errno.h: Likewise.
	* sysdeps/unix/sysv/hpux/bits/errno.h: Likewise.
	* sysdeps/unix/sysv/linux/bits/errno.h: Likewise.
	* sysdeps/unix/sysv/linux/hppa/bits/errno.h: Likewise.
	* sysdeps/unix/sysv/linux/mips/bits/errno.h: Likewise.
	* sysdeps/unix/sysv/sysv4/solaris2/bits/errno.h: Likewise.
	* sysdeps/i386/dl-machine.c (elf_machine_rel) [RTLD_BOOTSTRAP]: Don't
	use GL(dl_rtld_map), use map parameter.
	* sysdeps/sh/dl-machine.h (elf_machine_rela): Likewise.
	* sysdeps/unix/sysv/linux/i386/sysdep.S: Define errno in .tbss if
	USE_TLS && HAVE___THREAD.
	* sysdeps/unix/sysv/linux/i386/sysdep.h: Unify SETUP_PIC_REG
	definitions.  If USE_TLS && HAVE___THREAD store errooor value using
	TLS code sequence.
	* sysdeps/unix/sysv/linux/i386/i686/sysdep.h: Likewise.

	* sysdeps/unix/sysv/linux/getcwd.c: No real need to restore errno.
	* sysdeps/unix/sysv/linux/grantpt.c: Likewise.
	* sysdeps/unix/sysv/linux/internal_statvfs.c: Likewise.
	* sysdeps/unix/sysv/linux/msgctl.c: Likewise.
	* sysdeps/unix/sysv/linux/readv.c: Likewise.
	* sysdeps/unix/sysv/linux/writev.c: Likewise.

2002-07-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/bits/mman.h: Fix MS_SYNC and
	MS_INVALIDATE values.

2002-07-17  Andreas Schwab  <schwab@suse.de>
	    Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/pread.c: Sign extend offset.
	* sysdeps/unix/sysv/linux/pwrite.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/pread.c: Likewise.
	* sysdeps/unix/sysv/linux/mips/pwrite.c: Likewise.

2002-07-01  H.J. Lu  <hjl@gnu.org>

	* elf/circleload1.c (load_dso): Call "circlemod1" and check
	return value.

	* elf/circlemod1.c (circlemod1): Return int.
	* elf/circlemod2.c (circlemod2): Likewise.
	* elf/circlemod2a.c (circlemod2): Likewise.
	* elf/circlemod3.c (circlemod3): Likewise.
	(circlemod3a): A new function.

2002-07-16  Ulrich Drepper  <drepper@redhat.com>

	* catgets/tst-catgets.c (main): Don't expect results for
	untranslated messages.

	* glibcbug.in: Fix little typo.  Remove STDIO.

	* config.h.in: Fail if __FAST_MATH__ is defined.
	* math/Makefile (CPPFLAGS-test-ifloat.c): Also define TEST_FAST_MATH.
	(CPPFLAGS-test-idouble.c): Likewise.
	(CPPFLAGS-test-ildouble.c): Likewise.

2002-07-15  Ulrich Drepper  <drepper@redhat.com>

	* intl/tst-gettext.sh: Pass -f option to msgfmt.
	* intl/tst-gettext.c: Correctly handle untranslated messages in
	positive tests.

	* po/de.po: Update from translation team.

2002-07-02  H.J. Lu  <hjl@gnu.org>

	* sysdeps/mips/atomicity.h: Don't include <sgidefs.h>.  Always
	use ll/sc.
	* sysdeps/unix/sysv/linux/mips/sys/tas.h: Likewise.

	* sysdeps/unix/sysv/linux/configure.in: Set arch_minimum_kernel
	to 2.4.0 for mips.

2002-07-15  Ulrich Drepper  <drepper@redhat.com>

	* elf/dl-load.c (_dl_map_object_from_fd): If loaded object uses
	TLS fail if USE_TLS is not defined.

	* libio/wfileops.c (_IO_wfile_seekoff): Reposition wide pointers
	and adjust state for seek position.  [PR libc/4070]
	* libio/Makefile (tests): Add bug-rewind.
	* libio/bug-rewind.c: New file.

2002-07-12  Philip Blundell  <philb@gnu.org>

	* sysdeps/generic/backtrace.c (FIRST_FRAME_POINTER): New macro.
	(__backtrace): Use it.
	* sysdeps/arm/frame.h (FIRST_FRAME_POINTER): Define.  [PR libc/2632]

2002-07-12  Philip Blundell  <philb@gnu.org>

	* sysdeps/arm/dl-machine.h (elf_machine_rel): Don't handle
	R_ARM_RELATIVE if RTLD_BOOTSTRAP and HAVE_Z_COMBRELOC.  Only check
	for rtld map if neither RTLD_BOOTSTRAP nor HAVE_Z_COMBRELOC is defined.
	(elf_machine_rela): Remove unused variable.

	* sysdeps/unix/sysv/linux/arm/Makefile [subdir=elf]
	(sysdep-rtld-routines, sysdep_routines, sysdep-dl-routines): Don't
	define.

2002-07-12  Ulrich Drepper  <drepper@redhat.com>

	* iconvdata/gconv-modules: Add aliases for ISO-8859-11.

2002-07-14  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/bits/link.h: Add biarch support.

2002-07-13  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/mips/register-dump.h (register_dump):
	Use correct indices.
	Patch by Eliot Dresselhaus <eliot@ayrnetworks.com>.

2002-07-09  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* sysdeps/s390/bits/byteswap.h: Unified 31/64 bit byteswap.h.
	* sysdeps/s390/s390-32/bits/byteswap.h: Remove.
	* sysdeps/s390/s390-64/bits/byteswap.h: Remove.
	* sysdeps/s390/bits/link.h: Unified 31/64 bit link.h.
	* sysdeps/s390/s390-32/bits/link.h: Remove.
	* sysdeps/s390/s390-64/bits/link.h: Remove.
	* sysdeps/s390/bits/setjmp.h: Unified 31/64 bit setjmp.h.
	* sysdeps/s390/s390-32/bits/setjmp.h: Remove.
	* sysdeps/s390/s390-64/bits/setjmp.h: Remove.
	* sysdeps/s390/bits/wordsize.h: New file.
	* sysdeps/unix/sysv/linux/s390/bits/elfclass.h: Unified 31/64 bit
	elfclass.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/elfclass.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/fcntl.h: Unified 31/64 bit fcntl.h.
	* sysdeps/unix/sysv/linux/s390/s390-32/bits/fcntl.h: Remove.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/fcntl.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/ipc.h: Unified 31/64 bit ipc.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/ipc.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/mman.h: Unified 31/64 bit mman.h.
	* sysdeps/unix/sysv/linux/s390/s390-32/bits/mman.h: Remove.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/mman.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/msq.h: Unified 31/64 bit msq.h.
	* ysdeps/unix/sysv/linux/s390/s390-64/bits/msq.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/resource.h: Unified 31/64 bit
	resource.h.
	* sysdeps/unix/sysv/linux/s390/s390-32/bits/resource.h: Remove.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/resource.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/sem.h: Unified 31/64 bit sem.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/sem.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/shm.h: Unified 31/64 bit shm.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/shm.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/sigaction.h: Unified 31/64 bit
	sigaction.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/sigaction.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/siginfo.h: Unified 31/64 bit
	siginfo.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/siginfo.h: Remove.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/sigstack.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/socket.h: Unified 31/64 bit
	socket.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/socket.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/stat.h: Unified 31/64 bit stat.h.
	* sysdeps/unix/sysv/linux/s390/s390-32/bits/stat.h: Remove.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/stat.h: Remove.
	* sysdeps/unix/sysv/linux/s390/bits/types.h: Unified 31/64 bit types.h.
	* sysdeps/unix/sysv/linux/s390/s390-64/bits/types.h: Remove.
	* sysdeps/unix/sysv/linux/s390/net/route.h: New file.
	* sysdeps/unix/sysv/linux/s390/sys/procfs.h: Unified 31/64 bit
	procfs.h.
	* sysdeps/unix/sysv/linux/s390/s390-32/sys/procfs.h: Remove.
	* sysdeps/unix/sysv/linux/s390/s390-64/sys/procfs.h: Remove.
	* sysdeps/unix/sysv/linux/s390/sys/ucontext.h: Unified 31/64 bit
	ucontext.h.
	* sysdeps/unix/sysv/linux/s390/s390-32/sys/ucontext.h: Remove.
	* sysdeps/unix/sysv/linux/s390/s390-64/sys/ucontext.h: Remove.

2002-07-11  Ulrich Drepper  <drepper@redhat.com>

	* Versions.def (libc): Add GLIBC_2.3.
	* stdlib/Versions [libc] (GLIBC_2.3): Add realpath.
	* stdlib/canonicalize.c: Add compatibility version for realpath
	and make new code available in GLIBC_2.3.

2002-07-06  Bruno Haible  <bruno@clisp.org>

	* malloc/hooks.c (public_gET_STATe): Access max_total_mem in mp_.

2002-07-11  Ulrich Drepper  <drepper@redhat.com>

	* resolv/res_hconf.c (_res_hconf_init): Move code into new
	function do_init.  Use __libc_once.
	(do_init): New function.

	* iconvdata/iso8859-11.h: Removed.
	* iconvdata/Makefile (gen-8bit-gap-modules): Add iso8859-11.
	(distribute): Remove iso8859-11.h.
	* iconvdata/tst-tables.sh: Add ISO-8859-11.

	* stdio-common/vfscanf.c (inchar): Restore errno from previous
	underflow operation if c == (W)EOF.

2002-07-03  Jakub Jelinek  <jakub@redhat.com>

	* stdio-common/printf_fp.c (__printf_fp): If _FPIO_CONST_SHIFT is
	non-zero, adjust exponent.
	* sysdeps/ieee754/ldbl-128/s_erfl.c (__erfl, erfl, __erfcl, erfcl):
	Remove NO_LONG_DOUBLE aliases.
	* sysdeps/ieee754/ldbl-128/s_expm1l.c (__expm1l, expm1l): Likewise.
	* sysdeps/ieee754/ldbl-128/s_log1pl.c (__log1pl, log1pl): Likewise.
	(__log1pl): Raise divide by zero and invalid exceptions when needed.
	* sysdeps/ieee754/ldbl-128/e_powl.c (__ieee754_powl): Special case
	1**y and -1**+-Inf.
	* sysdeps/ieee754/ldbl-128/ldbl2mpn.c (__mpn_extract_long_double):
	Fix BITS_PER_MP_LIMB 32 extraction.
	* sysdeps/ieee754/ldbl-128/e_log2l.c (__ieee754_log2l): Don't raise
	exceptions for qNaNs.
	* sysdeps/ieee754/ldbl-128/e_log10l.c (__ieee754_log10l): Likewise.
	* sysdeps/ieee754/ldbl-128/e_lgammal_r.c (__ieee754_lgamma_r):
	Raise exceptions when needed.  Don't recurse unnecessarily.
	Special case 1.0L and 2.0L arguments to avoid -0.0L as result.
	* sysdeps/ieee754/ldbl-128/e_j0l.c (__ieee754_y0l): Don't raise
	exceptions for qNaNs.
	* sysdeps/ieee754/ldbl-128/s_remquol.c (__remquol): Make qs 64-bit
	to fix *quo return value sign.
	* sysdeps/ieee754/ldbl-128/e_gammal_r.c (__ieee754_gamma_r): Special
	case -Inf argument.
	* soft-fp/op-4.h (_FP_FRAC_CLZ_4): Fix a pasto.

2002-07-01  Jakub Jelinek  <jakub@redhat.com>

	* libio/tst-eof.c (do_test): Remove unused ch and tm variables.
	* iconvdata/iso-2022-jp-3.c (EMIT_SHIFT_TO_INIT): Kill warnings if
	-DNDEBUG.

2002-07-10  Ulrich Drepper  <drepper@redhat.com>

	* malloc/hooks.c (realloc_check): If mremap succeeds actually use
	the result.

	* sysdeps/i386/i486/bits/string.h: Add early clobber for "a"
	output parameter.  Reported by Denis Zaitsev <zzz@cd-club.ru>.

	* Versions.def (libthread_db): Add GLIBC_2.3.

2002-07-09  Jakub Jelinek  <jakub@redhat.com>

	* libio/freopen.c (freopen): Reset jump tables, use mmap stdio for the
	new stream if possible.
	* libio/freopen64.c (freopen64): Likewise.
	* libio/Makefile (tests): Add tst-freopen.
	* libio/tst-freopen.c: New file.

2002-07-03  Jakub Jelinek  <jakub@redhat.com>

	* libio/stdio.h (obstack_printf): Add format attribute.
	(obstack_vprintf): Likewise.

2002-07-04  Jakub Jelinek  <jakub@redhat.com>

	* posix/regex_internal.h (re_token_t): Shrink the structure to 8
	resp. 16 bytes on 32-bit resp. 64-bit platforms.
	(re_charset_t, re_string_t): Reorder structure members for 64-bit
	architectures.

2002-07-04  Jakub Jelinek  <jakub@redhat.com>

	* posix/regcomp.c (re_compile_internal): Move clearing of dfa...
	(init_dfa): ...here.

2002-07-05  Isamu Hasegawa  <isamu@yamato.ibm.com>

	* posix/regcomp.c (parse_sub_exp): Add nodes OP_OPEN_SUBEXP and
	OP_CLOSE_SUBEXP at both ends of sub expressions instead of SUBEXP
	nodes in parse trees.
	(calc_first): Fix the Definition of `firsts' of OP_OPEN_SUBEXP
	and OP_CLOSE_SUBEXP, and remove the definition of SUBEXP.
	(calc_epsdest): Treat OP_OPEN_SUBEXP and OP_CLOSE_SUBEXP as the
	nodes which can epsilon transit.
	* posix/regex_internal.h: Add OP_OPEN_SUBEXP and OP_CLOSE_SUBEXP
	to IS_EPSILON_NODE macro.
	* posix/regexec.c (update_regs): New function to update registers
	by refering OP_OPEN_SUBEXP and OP_CLOSE_SUBEXP nodes.
	(proceed_next_node): Use the entities of the nodes to determine
	whether the node can transit to.
	(set_regs): Use update_regs function to update registers.

2002-07-03  Jakub Jelinek  <jakub@redhat.com>

	* posix/bug-regex4.c (main): Remove duplicate setlocale.
	* posix/bug-regex6.c: New file.
	* posix/Makefile (tests): Add bug-regex6.
	(bug-regex6-ENV): Set LOCPATH.

2002-07-10  Ulrich Drepper  <drepper@redhat.com>

	* Versions.def [libpthread]: Add GLIBC_2.2.6.
	* posix/Versions [libc] (GLIBC_2.2.6): Add __nanosleep.

2002-07-06  Bruno Haible  <bruno@clisp.org>

	* sysdeps/unix/sysv/sysv4/bits/sigset.h (__NSSBITS): Correct value.

2002-07-06  Bruno Haible  <bruno@clisp.org>

	* include/sys/socket.h (__libc_sendto, __libc_recvfrom): New
	declarations.

	* sysdeps/i386/fpu/libm-test-ulps: Add some ulps for AMD K7.

	* rt/Makefile (tests): Don't add tst-aio* in a single-threaded build.

	* sysdeps/unix/bsd/sun/sunos4/bits/utsname.h: Test for _SYS_UTSNAME_H,
	not _UTSNAME_H.
	* sysdeps/unix/bsd/ultrix4/bits/utsname.h: Likewise.

	* sysdeps/generic/bits/stropts.h: Protect against direct inclusion.
	* sysdeps/generic/bits/ustat.h: Likewise.

	* sysdeps/unix/sysv/linux/bits/statvfs.h (ST_NODIRATIME): Set to 2048.

2002-07-08  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/elf/initfini.c (__asm__): Call call_gmon_start.

2002-07-08  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/fpu/s_fdiml.S: Fix wrong register name.

2002-07-06  Andreas Jaeger  <aj@suse.de>

	* sysdeps/x86_64/fpu/bits/mathinline.h: New file.
	* sysdeps/x86_64/fpu/s_copysign.S: New file.
	* sysdeps/x86_64/fpu/s_copysignf.S: New file.
	* sysdeps/x86_64/fpu/s_copysignl.S: New file.
	* sysdeps/x86_64/fpu/s_finitel.S: New file.
	* sysdeps/x86_64/fpu/s_fmax.S: New file.
	* sysdeps/x86_64/fpu/s_fmaxf.S: New file.
	* sysdeps/x86_64/fpu/s_fmaxl.S: New file.
	* sysdeps/x86_64/fpu/s_fmin.S: New file.
	* sysdeps/x86_64/fpu/s_fminf.S: New file.
	* sysdeps/x86_64/fpu/s_fminl.S: New file.

2002-06-05  Brian Youmans <3diff@gnu.org>

	* sysdeps/ia64/fpu/e_acos.S: Added text of Intel license.
	* sysdeps/ia64/fpu/e_acosf.S: Likewise.
	* sysdeps/ia64/fpu/e_acosl.S: Likewise.
	* sysdeps/ia64/fpu/e_asin.S: Likewise.
	* sysdeps/ia64/fpu/e_asinf.S: Likewise.
	* sysdeps/ia64/fpu/e_asinl.S: Likewise.
	* sysdeps/ia64/fpu/e_atan2.S: Likewise.
	* sysdeps/ia64/fpu/e_atan2f.S: Likewise.
	* sysdeps/ia64/fpu/e_cosh.S: Likewise.
	* sysdeps/ia64/fpu/e_coshf.S: Likewise.
	* sysdeps/ia64/fpu/e_coshl.S: Likewise.
	* sysdeps/ia64/fpu/e_exp.S: Likewise.
	* sysdeps/ia64/fpu/e_expf.S: Likewise.
	* sysdeps/ia64/fpu/e_fmod.S: Likewise.
	* sysdeps/ia64/fpu/e_fmodf.S: Likewise.
	* sysdeps/ia64/fpu/e_fmodl.S: Likewise.
	* sysdeps/ia64/fpu/e_hypot.S: Likewise.
	* sysdeps/ia64/fpu/e_hypotf.S: Likewise.
	* sysdeps/ia64/fpu/e_hypotl.S: Likewise.
	* sysdeps/ia64/fpu/e_log.S: Likewise.
	* sysdeps/ia64/fpu/e_logf.S: Likewise.
	* sysdeps/ia64/fpu/e_pow.S: Likewise.
	* sysdeps/ia64/fpu/e_powf.S: Likewise.
	* sysdeps/ia64/fpu/e_powl.S: Likewise.
	* sysdeps/ia64/fpu/e_remainder.S: Likewise.
	* sysdeps/ia64/fpu/e_remainderf.S: Likewise.
	* sysdeps/ia64/fpu/e_remainderl.S: Likewise.
	* sysdeps/ia64/fpu/e_scalb.S: Likewise.
	* sysdeps/ia64/fpu/e_scalbf.S: Likewise.
	* sysdeps/ia64/fpu/e_scalbl.S: Likewise.
	* sysdeps/ia64/fpu/e_sinh.S: Likewise.
	* sysdeps/ia64/fpu/e_sinhf.S: Likewise.
	* sysdeps/ia64/fpu/e_sinhl.S: Likewise.
	* sysdeps/ia64/fpu/e_sqrt.S: Likewise.
	* sysdeps/ia64/fpu/e_sqrtf.S: Likewise.
	* sysdeps/ia64/fpu/e_sqrtl.S: Likewise.
	* sysdeps/ia64/fpu/libm_atan2_req.S: Likewise.
	* sysdeps/ia64/fpu/libm_error.c: Likewise.
	* sysdeps/ia64/fpu/libm_frexp4.S: Likewise.
	* sysdeps/ia64/fpu/libm_frexp4f.S: Likewise.
	* sysdeps/ia64/fpu/s_frexpl.c: Likewise.
	* sysdeps/ia64/fpu/s_ilogb.S: Likewise.
	* sysdeps/ia64/fpu/s_ilogbf.S: Likewise.
	* sysdeps/ia64/fpu/s_ilogbl.S: Likewise.
	* sysdeps/ia64/fpu/s_ldexp.S: Likewise.
	* sysdeps/ia64/fpu/s_ldexpf.S: Likewise.
	* sysdeps/ia64/fpu/s_ldexpl.S: Likewise.
	* sysdeps/ia64/fpu/s_log1p.S: Likewise.
	* sysdeps/ia64/fpu/s_log1pf.S: Likewise.
	* sysdeps/ia64/fpu/s_log1pl.S: Likewise.
	* sysdeps/ia64/fpu/s_logb.S: Likewise.
	* sysdeps/ia64/fpu/s_logbf.S: Likewise.
	* sysdeps/ia64/fpu/s_logbl.S: Likewise.
